*****************************************************************
* zzAbout.prg
* Window with info about zz*.prg SalesBridge programs
*

PARAMETERS cevent, ctaskalias

*       *********************************************************
*       *                                                         
*       *         zzAbout Setup Code - SECTION 1         
*       *                                                         
*       *********************************************************
*

#REGION 1
*++
* Support code for the Modal 'About' window. This program is
* designed to be run by wLaunch(), even though modal programs
* can normally be run directly. We do this so the <Order Form>
* button can launch the order form window without difficulty.
*--
PRIVATE ALL EXCEPT _*

m.cInfoTop  = 'SalesBridge Version 3.1b'
m.block1 = ;
 [ ] + CHR(13) + ;
 [Developed by Patrick Smith ] + CHR(13) + ;
 [(c) 1989-1995 Contact Technology ] + CHR(13) + ;
 [ ] + CHR(13) + ;
 [This program contains no copy protection schemes, ] + CHR(13) + ;
 [and this version may be copied freely. ] + CHR(13) + ;
 [ ] + CHR(13) + ;
 [SalesBridge is designed for large and small networks and ] + CHR(13) + ;
 [can quickly handle 100,000 records. (With correct indexing.) ] + CHR(13) + ;
 [ ] + CHR(13) + ;
 [Pricing: ] + CHR(13) + ;
 [ ] + CHR(13) + ;
 [No charge! Any donations gratefully accepted. ] + CHR(13) + ;
 [ ] + CHR(13) + ;
 [This program was written to be a tool ] + CHR(13) + ;
 [to provide a "head start" for developers. ] + CHR(13) + ;
 [Also it is a way to meet new people and give something back! ] + CHR(13) + ;
 [ ] + CHR(13) + ;
 [Custom modifications/programming available.] + CHR(13) + ;
 [ ] + CHR(13)

m.block2 = ;
 [What do you think of this program? ] + CHR(13) + ;
 [send your ideas/comments to: ] + CHR(13) + ;
 [ ] + CHR(13) + ;
 [shasta@crl.com] + CHR(13) + ;
 [76233,1607@compuserve.com] + CHR(13) + ;
 [Ashasta@aol.com] + CHR(13) + ;
 [ ] + CHR(13) + ;
 [See ReadMe.1st and Help for more information ] + CHR(13) + ;
 [ ] + CHR(13) + ;
 [PDS March 1995 ]  + ;
 [ ] + CHR(13) + ;
 [ ] + CHR(13)

m.cInfoText = m.Block1 + m.Block2
 
m.cAboutOpt = ''

* Using wModalRead() even when we are run under control of
* wDispatch() gives continued access to the help window via F1.

DO wModalRead WITH 'read1()'

RETURN .T.

* EOF - zzAbout main routine
*********************************************************************
FUNCTION read1
*++
* The code for this function is generated by GENSCRN. It is called
* as the WHEN clause in the above READ. It issues the GETs and executes
* its own READ.
*--


#REGION 0
REGIONAL m.currarea, m.talkstat, m.compstat

IF SET("TALK") = "ON"
	SET TALK OFF
	m.talkstat = "ON"
ELSE
	m.talkstat = "OFF"
ENDIF
m.compstat = SET("COMPATIBLE")
SET COMPATIBLE FOXPLUS

*       *********************************************************
*       *                                                         
*       *               Windows Window definitions                
*       *                                                         
*       *********************************************************
*

IF NOT WEXIST("about") ;
	OR UPPER(WTITLE("ABOUT")) == "ABOUT.PJX" ;
	OR UPPER(WTITLE("ABOUT")) == "ABOUT.SCX" ;
	OR UPPER(WTITLE("ABOUT")) == "ABOUT.MNX" ;
	OR UPPER(WTITLE("ABOUT")) == "ABOUT.PRG" ;
	OR UPPER(WTITLE("ABOUT")) == "ABOUT.FRX" ;
	OR UPPER(WTITLE("ABOUT")) == "ABOUT.QPR"
	DEFINE WINDOW about ;
		AT  0.000, 0.000  ;
		SIZE 24.000,74.000 ;
		TITLE " About SalesBridge " ;
		FONT "MS Sans Serif", 9 ;
		STYLE "B" ;
		FLOAT ;
		NOCLOSE ;
		SHADOW ;
		NOMINIMIZE ;
		DOUBLE ;
		COLOR RGB(,,,0,128,128)
	MOVE WINDOW about CENTER
ENDIF


*       *********************************************************
*       *                                                         
*       *         ABOUT SalesBridge Setup Code - SECTION 2         
*       *                                                         
*       *********************************************************
*

#REGION 1

ACTIVATE WINDOW about NOSHOW

@ 6.000,2.000 EDIT cInfoText SIZE 14.000,70.000,0.000 ;
	FONT "MS Sans Serif", 9 ;
	STYLE "B" ;
    SCROLL NOMODIFY


*       *********************************************************
*       *                                                         
*       *             ABOUT SalesBridge Screen Layout              
*       *                                                         
*       *********************************************************
*

#REGION 1
IF WVISIBLE("about")
	ACTIVATE WINDOW about SAME
ELSE
	ACTIVATE WINDOW about NOSHOW
ENDIF
@ 21.000,27.000 GET cAboutOpt ;
	PICTURE "@*HN OK " ;
	SIZE 1.615,20.833,10.000 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 9 ;
	STYLE "B" ;
	VALID AboutOption(cAboutOpt)
@ 0.667,12.778 SAY "SalesBridge for Windows Customer Database"  ;
	FONT "MS Sans Serif", 10 ;
	STYLE "B"
@ 2.417,16.111 SAY "Copyright 1989-1995 Contact Technology"  ;
	FONT "MS Sans Serif", 9 ;
	STYLE "B"
@ 4.000,2.000 EDIT cInfoTop ;
	SIZE 1.000,70.000,0.000 ;
	DEFAULT " " ;
	FONT "MS Sans Serif", 9 ;
	STYLE "B" ;
	WHEN .F.

IF NOT WVISIBLE("about")
	ACTIVATE WINDOW about
ENDIF

READ CYCLE MODAL

RELEASE WINDOW about

#REGION 0
IF m.talkstat = "ON"
	SET TALK ON
ENDIF
IF m.compstat = "ON"
	SET COMPATIBLE ON
ENDIF

* EOF - Read1()
*********************************************************************
#REGION 1
FUNCTION AboutOption
PARAMETER cOption
*++
* Process option buttons and display correct text in window.
* Keep In case other windows are to be edited from the
* main "about" window
*--
PRIVATE nHandle

m.cOption = UPPER(ALLTRIM(m.cOption))

DO CASE
CASE cOption = 'OK'
  CLEAR READ
OTHERWISE
  CLEAR READ
ENDCASE

* Stay on the OK button.
_CUROBJ = OBJNUM(cAboutOpt, RDLEVEL()) + 1

RETURN .T.

* EOF - AboutOption()
*********************************************************************
*********************************************************************
*********************************************************************
* EOF - zzAbout.prg
