*       *********************************************************
*       *                                                         
*       * 03/11/95             ZZBROW.PRG                10:17:49 
*       *                                                         
*       *********************************************************
*       *                                                         
*       * Patrick Smith                                           
*       *                                                         
*       * Copyright (c) 1995 Contact Technology                   
*       * 26 Aries Lane                                           
*       * Novato, CA  94947                                       
*       * U.S.A                                             
*       *                                                         
*       * Description:                                            
*       * This program was automatically generated by GENSCRN.    
*       *                                                         
*       *********************************************************

PARAMETERS cevent, ctaskalias

*       *********************************************************
*       *                                                         
*       *          ZZBROW/Windows Setup Code - SECTION 1          
*       *                                                         
*       *********************************************************
*

#REGION 1
*++
* Browse update task support code
*--

* Make sure this is the ONLY task window open!
IF NOT EMPTY(_aWindows[1])
  IF _aWindows[1] = '1_ZZBROW'
    * OK to go back to this window
  ELSE
    WAIT 'Close all windows before performing this function, press <Enter>' WINDOW
    RETURN
  ENDIF
ENDIF

PRIVATE ALL EXCEPT _*


*       *********************************************************
*       *                                                         
*       *          ZZBROW/Windows Setup Code - SECTION 2          
*       *                                                         
*       *********************************************************
*

#REGION 1
* Define offsets into GET variable array structure.
* The first section of the array must match the table layout
* so we can use GATHER/SCATTER to transfer between file and array.
* Make sure it is an exact match to the dbf structure!
* Adjust the size of the array below to hold the memvars

#DEFINE t_cFld1      t_aGETvars[1]
#DEFINE t_cWid1      t_aGETvars[2]
#DEFINE t_cFld2      t_aGETvars[3]
#DEFINE t_cWid2      t_aGETvars[4]
#DEFINE t_cFld3      t_aGETvars[5]
#DEFINE t_cWid3      t_aGETvars[6]
#DEFINE t_cFld4      t_aGETvars[7]
#DEFINE t_cWid4      t_aGETvars[8]
#DEFINE t_cFld5      t_aGETvars[9]
#DEFINE t_cWid5      t_aGETvars[10]
#DEFINE t_cFld6      t_aGETvars[11]
#DEFINE t_cWid6      t_aGETvars[12]
#DEFINE t_cFld7      t_aGETvars[13]
#DEFINE t_cWid7      t_aGETvars[14]
#DEFINE t_cFld8      t_aGETvars[15]
#DEFINE t_cWid8      t_aGETvars[16]
#DEFINE t_cFld9      t_aGETvars[17]
#DEFINE t_cWid9      t_aGETvars[18]
#DEFINE t_cFld10     t_aGETvars[19]
#DEFINE t_cWid10     t_aGETvars[20]
#DEFINE t_cFld11     t_aGETvars[21]
#DEFINE t_cWid11     t_aGETvars[22]
#DEFINE t_cFld12     t_aGETvars[23]
#DEFINE t_cWid12     t_aGETvars[24]
#DEFINE t_cBrowStr   t_aGETvars[25]

* Now define elements for additional non-table fields
#DEFINE t_cOption    t_aGETvars[28]
#DEFINE t_nTopBump   t_aGETvars[29]
#DEFINE t_nBotBump   t_aGETvars[30]

  * And now define the array itself
  DIMENSION t_aGETvars[30]

  * Declare Screen-set wide global variables
  m.t_cWindow = ''   && Window name for this instance
  m.t_nWinRow = 2    && Default row for our window
  m.t_nWinCol = 2    && Default column for our window
  m.t_nCurObj = 0    && Current object number
  m.t_nRecno = 0     && Current record number
  m.t_cOrder= ''     && Default table order.
  m.t_bAddNew = .F.  && Set true if adding new record
  m.t_bChanges = .F. && Changes have been made flag.
  m.t_bAtTop = .F.   && Beginning of file flag
  m.t_bAtEnd = .F.   && End of file flag

  * Determine our task alias, or create a new one.
  IF m.cEvent = 'LAUNCH'
    * Look for topmost existing instance of this task first.
    m.t_cWindow = wTaskWin( m.cTaskAlias )

    IF EMPTY( m.t_cWindow )
      * Create a new instance of this task.
      m.cTaskAlias = wNewTask( m.cTaskAlias )
      IF EMPTY( m.cTaskAlias )
        RETURN .F.
      ENDIF

      m.t_cWindow = wAddWin( m.cTaskAlias, 'ZZBROW', ;
                         'Browse List Update' )
    ELSE
      * Get the task alias associated with window we found.
      m.cTaskAlias = wWinAlias( m.t_cWindow )
    ENDIF
  ENDIF

  * Restore last saved state (if any) of memory variables.
  DO wGetState WITH m.cTaskAlias

  * Make sure the files we use are open
  IF NOT USED('zzbrow')
    * Use AGAIN in case another task, or BROWSE, has file open
    * under a different alias name.
    USE (LOCFILE('zzbrow','DBF','Where is the Browse List file?'));
        IN 0 AGAIN ALIAS zzbrow
  ENDIF
  SELECT zzbrow

  * Restore current record from saved context.
  IF m.t_nRecno > 0 AND m.t_nRecno <= RECCOUNT()
    GO m.t_nRecno
  ENDIF

  DO CASE
    CASE m.cEvent = 'CLOSE'
      IF NOT save_form('closing the window')
        RETURN .F.
      ENDIF
      HIDE WINDOW (t_cWindow)

    CASE m.cEvent = 'UPDATE'
      * If changes have been made, ignore simple update events.
      * Note that this code depends on SET EXACT OFF.
      IF NOT (t_bChanges AND cEvent == 'UPDATE')
        IF save_form('selecting a new record')
          * Process Special event messages we support.
          IF '>' $ m.cEvent
            DO controls WITH SUBSTR(cEvent,AT('>',cEvent)+1)
          ELSE
            IF '-' $ m.cEvent
              GO VAL(SUBSTR(cEvent,AT('-',cEvent)+1))
            ENDIF
            DO load_form
            DO show_form
          ENDIF
        ENDIF
      ENDIF

    CASE m.cEvent = 'LAUNCH' OR m.cEvent = 'ACTIVATE'
      IF NOT WVISIBLE( m.t_cWindow )
        * Position newly created window(s) at last saved position.
        * SIZE must be manually adjusted, NOT from screen generator
        MODIFY WINDOW ( m.t_cWindow ) ;
                FONT 'MS Sans Serif',8 STYLE 'B';
                ICON FILE cardfile.ico ;
                AT m.t_nWinRow, m.t_nWinCol SIZE 26,90 ;

        * Initialize the GET variable array.
        STORE '' TO t_aGETvars
        STORE 0 TO t_nTopBump, t_nBotBump, t_nCurObj

        * Load current record into GET variable array.
        DO load_form
      ENDIF

      * Issue GETS if this is first time, or another task cleared them
      ACTIVATE WINDOW (m.t_cWindow) NOSHOW
      IF OBJNUM( t_nTopBump, wRdLevel() ) = 0
        DO issue_gets

        * Object numbers have changed, so clear saved object number
        m.t_nCurObj = 0
      ELSE
        * If window was just re-opened, show the gets.
        IF NOT WVISIBLE(m.t_cWindow)
          SHOW GETS WINDOW (m.t_cWindow) LEVEL wRdLevel()
        ENDIF
      ENDIF

      * Set option buttons correctly
      DO set_buttons WITH m.t_bChanges
      ACTIVATE WINDOW (m.t_cWindow)

      * If no saved object, determine default first object to read.
      IF m.t_nCurObj = 0
        m.t_nCurObj = OBJNUM( t_cFld1, wRdLevel() )
      ENDIF

      * Define flag to remember the state of our menu pad. The
      * Activate clause is re-called each time a dialog window
      * is closed. By using this flag we can avoid the overhead of
      * re-redefining our menu in these cases.
      bMenuUp = .F.

      * Give ZZProc.prg our READ level validation expressions
      DO wReadInit WITH 'brow_deact()', 'get_valid()', ;
                        'save_form("closing the window")'

      READ CYCLE SAVE OBJECT m.t_nCurObj ;
         ACTIVATE brow_act() ;
         DEACTIVATE brow_deact() ;
         VALID READKEY(1) = 5     && Only terminate if deactivate

      m.t_nCurObj = _nCurObj      && Remember last data object
  ENDCASE

  * Save current context information
  m.t_cOrder = ORDER('zzbrow')    && Remember data table order
  m.t_nRecno = RECNO('zzbrow')    && and record number
  DO wSaveState WITH m.cTaskAlias

  IF NOT WVISIBLE(t_cWindow)
    * Close the tables we use. If other tasks use them, they will
    * reopen them as part of their context restoration.
    SELECT zzbrow
    USE

    * Close associated browse window also, if open.
    IF WEXIST('Browse_Fields')
      DEACTIVATE WINDOW 'Browse_Fields'
    ENDIF

    DO wDelTask WITH m.cTaskAlias
  ENDIF
  RETURN .T.

*******************************************************************
PROCEDURE issue_gets
*++
* The code for this procedure will be generated by GENSCRN.  It
* will issue all the @GETs for the screen.  We want the GET
* commands to be in a seperate procedure so we can call them
* conditionally from the task program setup code.
*--

* ! Important !
* Make sure the When statement for the "get" field "TopBump"
* contains the name of the last "get" field and
* "BotBump" contains the name of the first "get" field
* this will insure that the cursor cycles properly!!!!!
*

*       *********************************************************
*       *
*       *              ZZBROW/Windows Screen Layout
*       *
*       *********************************************************
*




*       *********************************************************
*       *                                                         
*       *              ZZBROW/Windows Screen Layout               
*       *                                                         
*       *********************************************************
*

#REGION 1
@ 5.462,4.667 SAY "Field" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT"
@ 5.385,24.333 SAY "Width In" + CHR(13) + ;
		"List" ;
	SIZE 2.000,8.167, 0.000 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT"
@ 0.000,0.167 GET t_nTopBump ;
	PICTURE "@*IVN " ;
	SIZE 1.000,0.833,1.000 ;
	DEFAULT 0 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wBumper(OBJNUM(t_cFldVal1) + 7)
@ 9.000,4.167 GET t_cFld1 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 9.154,24.667 GET t_cWid1 ;
	SPINNER 1.000, 1, 99 ;
	PICTURE "@K ##" ;
	SIZE 0.846, 6.000 ;
	DEFAULT 1.000 ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() ) ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 11.000,4.167 GET t_cFld2 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 11.154,24.667 GET t_cWid2 ;
	SPINNER 1.000, 1, 99 ;
	PICTURE "@K ##" ;
	SIZE 0.846, 6.000 ;
	DEFAULT 1.000 ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() ) ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 13.000,4.167 GET t_cFld3 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 13.154,24.667 GET t_cWid3 ;
	SPINNER 1.000, 1, 99 ;
	PICTURE "@K ##" ;
	SIZE 0.846, 6.000 ;
	DEFAULT 1.000 ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() ) ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 15.000,4.167 GET t_cFld4 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 15.154,24.667 GET t_cWid4 ;
	SPINNER 1.000, 1, 99 ;
	PICTURE "@K ##" ;
	SIZE 0.846, 6.000 ;
	DEFAULT 1.000 ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() ) ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 17.000,4.167 GET t_cFld5 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 17.154,24.667 GET t_cWid5 ;
	SPINNER 1.000, 1, 99 ;
	PICTURE "@K ##" ;
	SIZE 0.846, 6.000 ;
	DEFAULT 1.000 ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() ) ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 19.000,4.167 GET t_cFld6 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 19.154,24.667 GET t_cWid6 ;
	SPINNER 1.000, 1, 99 ;
	PICTURE "@K ##" ;
	SIZE 0.846, 6.000 ;
	DEFAULT 1.000 ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() ) ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 9.077,50.333 GET t_cFld7 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 9.231,71.833 GET t_cWid7 ;
	SPINNER 1.000, 1, 99 ;
	PICTURE "@K ##" ;
	SIZE 0.846, 6.000 ;
	DEFAULT 1.000 ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() ) ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 11.077,50.333 GET t_cFld8 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 11.231,71.833 GET t_cWid8 ;
	SPINNER 1.000, 1, 99 ;
	PICTURE "@K ##" ;
	SIZE 0.846, 6.000 ;
	DEFAULT 1.000 ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() ) ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 13.077,50.333 GET t_cFld9 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 13.231,71.833 GET t_cWid9 ;
	SPINNER 1.000, 1, 99 ;
	PICTURE "@K ##" ;
	SIZE 0.846, 6.000 ;
	DEFAULT 1.000 ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() ) ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 15.077,50.333 GET t_cFld10 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 15.231,71.833 GET t_cWid10 ;
	SPINNER 1.000, 1, 99 ;
	PICTURE "@K ##" ;
	SIZE 0.846, 6.000 ;
	DEFAULT 1.000 ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() ) ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 17.077,50.333 GET t_cFld11 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 17.231,71.833 GET t_cWid11 ;
	SPINNER 1.000, 1, 99 ;
	PICTURE "@K ##" ;
	SIZE 0.846, 6.000 ;
	DEFAULT 1.000 ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() ) ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 19.077,50.333 GET t_cFld12 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 19.231,71.833 GET t_cWid12 ;
	SPINNER 1.000, 1, 99 ;
	PICTURE "@K ##" ;
	SIZE 0.846, 6.000 ;
	DEFAULT 1.000 ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() ) ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 0.000,1.333 GET t_nBotBump ;
	PICTURE "@*IVN " ;
	SIZE 1.077,0.667,1.000 ;
	DEFAULT 0 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wBumper( OBJNUM(t_cDesc) )
@ 1.000,3.500 GET t_cOption ;
	PICTURE "@*BHN " + ;
		(LOCFILE("test.bmp","BMP|ICO|PCT|ICN","Where is test?")) + ";" + ;
		(LOCFILE("undo.bmp","BMP|ICO|PCT|ICN","Where is undo?")) + ";" + ;
		(LOCFILE("save.bmp","BMP|ICO|PCT|ICN","Where is save?")) + ";" + ;
		(LOCFILE("exit.bmp","BMP|ICO|PCT|ICN","Where is exit?")) ;
	SIZE 2.923,9.333,0.667 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	VALID ProcOption(t_cOption,.T.)
@ 8.154,2.167 TO 8.154,36.334 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 8.154,2.167 TO 21.231,2.167 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 21.154,2.333 TO 21.154,36.166 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 8.154,36.333 TO 21.308,36.333 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 0.462,2.000 TO 0.462,44.833 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 0.462,2.000 TO 4.462,2.000 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 0.462,44.833 TO 4.385,44.833 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 4.385,2.333 TO 4.385,45.000 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 1.231,48.167 SAY "Select 12 data fields as columns in" + CHR(13) + ;
		"your customer database browse list." ;
	SIZE 2.000,34.667, 0.000 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT"
@ 5.000,2.000 TO 5.000,36.833 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 5.000,2.000 TO 7.615,2.000 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 7.538,2.167 TO 7.538,36.834 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 5.077,36.667 TO 7.615,36.667 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 0.923,47.500 TO 0.923,82.333 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 0.923,47.500 TO 3.538,47.500 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 3.462,47.667 TO 3.462,82.334 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 1.000,82.167 TO 3.538,82.167 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 5.462,49.833 SAY "Field" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT"
@ 5.231,70.500 SAY "Width In" + CHR(13) + ;
		"List" ;
	SIZE 2.000,8.167, 0.000 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT"
@ 4.923,47.833 TO 4.923,82.666 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 4.923,47.833 TO 7.538,47.833 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 7.462,48.000 TO 7.462,82.667 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 5.000,82.500 TO 7.538,82.500 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 8.231,48.167 TO 8.231,82.334 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 8.231,48.167 TO 21.308,48.167 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 21.231,48.333 TO 21.231,82.166 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 8.231,82.333 TO 21.385,82.333 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)


*       *********************************************************
*       *                                                         
*       *               ZZBROW/Windows Cleanup Code               
*       *                                                         
*       *********************************************************
*

#REGION 1
*       *********************************************************
*       *
*       *               ZZBROW/Windows Cleanup Code
*       *
*       *********************************************************
*

********************************************************************


*       *********************************************************
*       *
*       *   ZZBROW/Windows Supporting Procedures and Functions
*       *
*       *********************************************************
*



*       *********************************************************
*       *                                                         
*       *   ZZBROW/Windows Supporting Procedures and Functions    
*       *                                                         
*       *********************************************************
*

#REGION 1
FUNCTION brow_act
*++
* Task specific READ activation handler.
*--

  * Put up custom menu pad for this task window. The activate clause
  * may sometimes be called after the window is hidden during a close
  * operation, if a dialog box was activated by the form level
  * validation handler. The WVISIBLE() test makes sure we don't put
  * the menu back up in this case. The bMenuUp flag is used only for
  * optimization purposes - so we don't redefine the menu if it's
  * already there.
  IF WVISIBLE(m.t_cWindow) AND NOT bMenuUp
    DO zzbrow.mpr
    bMenuUp = .T.
  ENDIF

  RETURN .T.


********************************************************************
FUNCTION brow_deact
*++
* Task specific READ deactivation handler.
* This routine may be called by the READ command on a READ window
* deactivation, or explicitly by the wClearRead() function. That
* means we cannot depend on WLAST() or WONTOP() to be set right.
*--
  * Under FoxPro for Windows, Minimizing a window from the window
  * control box, or Choosing Next Window, bypasses the GET Valid
  * clause. This is our only chance to catch it, and thereby enforce
  * proper field validation.
  IF wCatchAll(m.t_cWindow)
    * Save last position of window
    m.t_nWinRow = WLROW(m.t_cWindow)
    m.t_nWinCol = WLCOL(m.t_cWindow)

    RELEASE PAD browse OF _MSYSMENU
    RELEASE POPUP browse
    bMenuUp = .F.
    RETURN .T.
  ELSE
    RETURN .F.
  ENDIF


********************************************************************
FUNCTION GET_valid
*++
* Common validation routine called when any field data is changed.
*
* This routine is responsible for:
*  1. Checking lock status of record, locking if needed.
*  2. Setting changes flag and setting buttons.
*
* Returns TRUE.
*  If data was changed and lock could not be established, data is
*  reset to initial value.
*--
PRIVATE xTemp

  IF NOT m.t_bchanges AND wChanged()
    IF NOT wLock(m.cTaskAlias, 'zzbrow', RECNO('zzbrow') )
      * Restore original field contents on Lock failure.
      DO wFldUndo

      * Return success, since user is warned, and changes undone.
      RETURN .T.
    ENDIF

    * Make sure any changes to record made since original
    * display are shown on screen when the record is locked.
    STORE EVALUATE( VARREAD() ) TO m.xTemp
    DO load_form
    STORE m.xTemp TO ( VARREAD() )
    DO show_form

    DO set_buttons WITH .T.
  ENDIF

  RETURN .T.


********************************************************************
PROCEDURE load_form
*++
* Load data from current record for display and/or edit.
*---
  SELECT zzbrow

  * Don't stay at EOF if we can help it.
  IF EOF()
    GOTO BOTTOM

    * If still at EOF, perform implicit add record command.
    IF EOF()
      RETURN init_form()
    ENDIF
  ENDIF

  m.t_bAddNew = .F.
  DO set_buttons WITH .F.

  * Let all the other tasks know what record we have displayed.
  DO wListen WITH m.cTaskAlias, 'zzbrow', RECNO('zzbrow')

  * Load data from field variables into GET variable array.
  SCATTER TO t_aGETvars MEMO
  RETURN


********************************************************************
PROCEDURE init_form
*++
* Initialize internal memory for a new address record.
* Let format default to current setting on add.
*---
  m.t_bAddNew = .T.
  DO set_buttons WITH .T.

  SELECT zzbrow
  SCATTER TO t_aGETvars MEMO BLANK

  * Move to first field to begin entry of new record.
  _CUROBJ = OBJNUM( t_cFld1 )
  RETURN


********************************************************************
PROCEDURE show_form
*++
* Display current data and Enable/Disable fields as appropriate.
*---

  SHOW GETS WINDOW (m.t_cWindow) LEVEL wRdLevel()
  RETURN


********************************************************************
FUNCTION set_buttons
PARAMETER bChanges
*++
* Set changes flag, and update control buttons accordingly.
*--
PRIVATE nRecno

  IF m.bChanges
    SHOW GET t_cOption,2 ENABLE LEVEL wRdLevel()
    SHOW GET t_cOption,3 ENABLE LEVEL wRdLevel()
  ELSE
    SHOW GET t_cOption,2 DISABLE LEVEL wRdLevel()
    SHOW GET t_cOption,3 DISABLE LEVEL wRdLevel()
  ENDIF

  * The AddNEw flag will always be set if there are no records.
  * Code only used in screens with multiple records
  *IF t_bAddNew
  *  t_bAtTop = .T.
  *  t_bAtEnd = .T.
  *ELSE
  *  nRecno = RECNO()
  *  SKIP -1
  *  t_bAtTop = BOF()
  *  GO nRecno

  *  SKIP 1
  *  t_bAtEnd = EOF()
  *  GO nRecno
  *ENDIF

  * Set buttons according to current record
  * Code only used in screens with multiple records
  *IF m.t_bAtTop
  *  SHOW GET t_cOption,1 DISABLE LEVEL wRdLevel()
  *ELSE
  *  SHOW GET t_cOption,1 ENABLE LEVEL wRdLevel()
  *ENDIF

  *IF m.t_bAtEnd
  *  SHOW GET t_cOption,2 DISABLE LEVEL wRdLevel()
  *ELSE
  *  SHOW GET t_cOption,2 ENABLE LEVEL wRdLevel()
  *ENDIF

  * Store new value of task level change flag and return it.
  m.t_bChanges = m.bChanges
  RETURN m.bChanges


********************************************************************
FUNCTION ProcOption
PARAMETER cOption, bInObject
*++
* Process menu and pushbutton options.
*--

* if choice is picture button, strip off ".BMP" from end
* make sure .bmp button file names match menu options!
m.cOption = STRTRAN(m.cOption,'.BMP','')
* identify file name, strip off path + back-slashes
m.cOption = SUBSTR(m.cOption,RAT('\',m.cOption)+1)

SELECT zzbrow
m.cOption = UPPER( ALLTRIM(m.cOption) )

* get complete browse list string, save to zzbrow->BrowStr
* if empty field list, default to 'city'
IF m.cOption = 'EXIT' .OR. m.cOption = 'SAVE' .OR. m.cOption = 'TEST'
  t_cBrowStr = BldList('replace')
  IF EMPTY(t_cBrowStr)
    _BrowStr = 'City'
  ELSE
    _BrowStr = ALLTRIM(t_cBrowStr)
  ENDIF
ENDIF

DO CASE

* First, handle the common task button options.
CASE controls(cOption, bInObject)

* Then, check for task-specific button options.
CASE m.cOption = 'TEST'
  * Launch an independant BROWSE window, linked to ours.
  DO wLaunch WITH 'BrowTest IN zzBrow'

ENDCASE

RETURN .T.

* EOF - ProcOption
********************************************************************
PROCEDURE browtest
PARAMETER cEvent, cTaskAlias
*++
* This BROWSE task is designed to work together with the
* browse update task window.
*
* Parameters from wLaunch are ignored for BROWSE tasks, since
* once they are started, we never get control of them again.
*--

*wait _BrowStr window

* Make sure the files we use are open
IF NOT USED(_MastFile)
  * Use AGAIN in case another task, or BROWSE, has file open
  * under a different alias name.
  USE (LOCFILE(_MastFile,'DBF','Where is the Customer file?'));
      IN 0 AGAIN ALIAS &_MastFile
ENDIF
SELECT &_MastFile

IF NOT EMPTY(DBF())
  m._nBrow = IIF( m._nBrow > 12, 5, m._nBrow + 1)
  m._nBcol = IIF( m._nBcol > 20, 10, m._nBcol + 2)
  DEFINE WINDOW bwin FROM m._nBrow,m._nBcol SIZE 10,75 ;
         FONT 'MS Sans Serif',8 STYLE 'B' ;
         FLOAT SHADOW CLOSE MINIMIZE ZOOM ;
         SYSTEM GROW COLOR SCHEME 8
  BROWSE WINDOW bwin ;
       TITLE 'Test_Customer_List' ;
       FIELDS &_BrowStr ;
       NOMODIFY
  RELEASE WINDOW bwin

  * Add work area to list, omitted temp 8/94
  *kWinName = 'Test_Customer_List'
  *m.nArraySize = ALEN(_aBrowse, 1) + 1
  *DIMENSION _aBrowse[m.nArraySize,2]
  *_aBrowse[m.nArraySize,kWinName] = WONTOP()
  *_aBrowse[m.nArraySize,kWorkarea] = SELECT()
ENDIF

RETURN

* EOF - browtest
********************************************************************
FUNCTION save_form
PARAMETER cMsgTxt
*++
* Validate complete form as a whole, and save changes. If cMsgTxt
* contains a string, use it to ask whether or not user wants to
* save changes.
*--
PRIVATE nBadField, cReason, cAnswer

  SELECT zzbrow
  STORE '' TO m.cReason

  IF m.t_bChanges
    m.cAnswer = IIF(EMPTY(m.cMsgTxt), 'YES', zzQuest(m.t_cWindow, ;
        'Do you want to save changes made to this browse window ' ;
        + 'before ' + m.cMsgTxt + '?' ) )

    * Return failure immediately if user cancels.
    IF m.cAnswer = 'CANCEL'
      RETURN .F.
    ENDIF

    * Save the changes if we are supposed to.
    IF m.cAnswer = 'YES'
      * Make sure all required fields have been entered.
      DO CASE
      *  CASE EMPTY(t_c?????)

      ENDCASE

      IF NOT EMPTY(m.cReason)
        DO zzWarn WITH m.t_cWindow, m.cReason

        * This routine may be called when no GETs are issued (like
        * during Global shutdown). OBJNUM() returns 0 in this case.
        _CUROBJ = nBadField
        RETURN .F.
      ENDIF

      * Add a new record to the database when needed.
      IF m.t_bAddNew
        * Create new record
        APPEND BLANK
        m.t_bAddNew = .F.
      ENDIF

      GATHER FROM t_aGETvars MEMO
      DO set_buttons WITH .F.
    ELSE
      * User said 'dont save', so reload from disk.
      DO load_form
      DO show_form
    ENDIF

    * Whether changes saved or discarded, release the locks.
    DO wUnlock WITH m.cTaskAlias

  ENDIF

  RETURN .T.


* EOF - save_form
**************************************************************************
FUNCTION bldlist
PARAMETERS bldmode
* bldmode = 'test' if only building string for test brow viewing
* bldmode = 'replace' if replacing string into database
* Create string for customer list browse
* This is used in the cust list browse statement
* Create according to fox browse description in manual
*

SELECT zzbrow

mbrowlist = ''

* build string: include field, width, and header (defined for field by user)

IF .NOT. EMPTY(DbfFld(t_cfld1))                    && don't display empty field reference!!
   mbrowlist = DbfFld(t_cfld1) + ':' + ALLTRIM(STR(t_cWid1)) ;
      + ':H=[' + ALLTRIM(t_cfld1) + ']'
ELSE
   t_cFld1 = SPACE(10)
ENDIF
IF .NOT. EMPTY(DbfFld(t_cfld2))
   mbrowlist = mbrowlist + ',' + DbfFld(t_cfld2) + ':' + ALLTRIM(STR(t_cWid2)) ;
      + ':H=[' + ALLTRIM(t_cfld2) + ']'
ELSE
   t_cFld2 = SPACE(10)
ENDIF
IF .NOT. EMPTY(DbfFld(t_cfld3))
   mbrowlist = mbrowlist + ',' + DbfFld(t_cfld3) + ':' + ALLTRIM(STR(t_cWid3)) ;
      + ':H=[' + ALLTRIM(t_cfld3) + ']'
ELSE
   t_cFld3 = SPACE(10)
ENDIF
IF .NOT. EMPTY(DbfFld(t_cfld4))
   mbrowlist = mbrowlist + ',' + DbfFld(t_cfld4) + ':' + ALLTRIM(STR(t_cWid4)) ;
      + ':H=[' + ALLTRIM(t_cfld4) + ']'
ELSE
   t_cFld4 = SPACE(10)
ENDIF
IF .NOT. EMPTY(DbfFld(t_cfld5))
   mbrowlist = mbrowlist + ',' + DbfFld(t_cfld5) + ':' + ALLTRIM(STR(t_cWid5)) ;
      + ':H=[' + ALLTRIM(t_cfld5) + ']'
ELSE
   t_cFld5 = SPACE(10)
ENDIF
IF .NOT. EMPTY(DbfFld(t_cfld6))
   mbrowlist = mbrowlist + ',' + DbfFld(t_cfld6) + ':' + ALLTRIM(STR(t_cWid6)) ;
      + ':H=[' + ALLTRIM(t_cfld6) + ']'
ELSE
   t_cFld6 = SPACE(10)
ENDIF
IF .NOT. EMPTY(DbfFld(t_cfld7))
   mbrowlist = mbrowlist + ',' + DbfFld(t_cfld7) + ':' + ALLTRIM(STR(t_cWid7)) ;
      + ':H=[' + ALLTRIM(t_cfld7) + ']'
ELSE
   t_cFld7 = SPACE(10)
ENDIF
IF .NOT. EMPTY(DbfFld(t_cfld8))
   mbrowlist = mbrowlist + ',' + DbfFld(t_cfld8) + ':' + ALLTRIM(STR(t_cWid8)) ;
      + ':H=[' + ALLTRIM(t_cfld8) + ']'
ELSE
   t_cFld8 = SPACE(10)
ENDIF
IF .NOT. EMPTY(DbfFld(t_cfld9))
   mbrowlist = mbrowlist + ',' + DbfFld(t_cfld9) + ':' + ALLTRIM(STR(t_cWid9)) ;
      + ':H=[' + ALLTRIM(t_cfld9) + ']'
ELSE
   t_cFld9 = SPACE(10)
ENDIF
IF .NOT. EMPTY(DbfFld(t_cfld10))
   mbrowlist = mbrowlist + ',' + DbfFld(t_cfld10) + ':' + ALLTRIM(STR(t_cWid10)) ;
      + ':H=[' + ALLTRIM(t_cfld10) + ']'
ELSE
   t_cFld10 = SPACE(10)
ENDIF
IF .NOT. EMPTY(DbfFld(t_cfld11))
   mbrowlist = mbrowlist + ',' + DbfFld(t_cfld11) + ':' + ALLTRIM(STR(t_cWid11)) ;
      + ':H=[' + ALLTRIM(t_cfld11) + ']'
ELSE
   t_cFld11 = SPACE(10)
ENDIF
IF .NOT. EMPTY(DbfFld(t_cfld12))
   mbrowlist = mbrowlist + ',' + DbfFld(t_cfld12) + ':' + ALLTRIM(STR(t_cWid12)) ;
      + ':H=[' + ALLTRIM(t_cfld12) + ']'
ELSE
   t_cFld12 = SPACE(10)
ENDIF

IF bldmode = 'replace'
   REPLACE browstr WITH mbrowlist         && put into zzdbfs.dbf to build zzmast.dbf browse later
ENDIF

RETURN mbrowlist

* EOF - BldList
*******************************************************************
FUNCTION DbfFld
PARAMETERS UsrFld
* Get .dbf field name from "User Defined Field" selected.
* Assumes Structure array open in memory (_zzsmast), see above
*

IF EMPTY(UsrFld)
   RETURN ''
ENDIF

* Trim user defined field
UsrFld   = ALLTRIM(UsrFld)
*clear wind
*susp
*wait 'usrfld-'+usrfld+'-  usrop-'+usrop+'-  usrval-'+usrval+'-  usrandor-'+usrandor window
*return ''
*PRIVATE BldString,mPos,mSub,UsrFld,UsrType,UsrLen
*PRIVATE UsrDec,UsrOp,UsrVal,UsrAndOr, FiltFld

* Find array position, subscript ;
* of user selected "English, not dbf" field name

mPos = ASCAN(_zzsmast,UsrFld)

* If field is found in current fiel array...
* (users can change field names!)
IF mPos > 0  && if field is found in current fiel array (users can change field names!)
  mSub = ASUBSCRIPT(_zzsmast,mPos,1)
  RtrnFld = ALLTRIM(_zzsmast(mSub,2)) && the dbf field name
ELSE
  RtrnFld = ''
ENDIF

RETURN RtrnFld

* EOF - DbfFld

********************************************************************
********************************************************************
********************************************************************
* EOF - zzbrow.prg