*       *********************************************************
*       *                                                         
*       * 03/11/95              ZZEXP.PRG                17:10:30 
*       *                                                         
*       *********************************************************
*       *                                                         
*       * Patrick Smith                                           
*       *                                                         
*       * Copyright (c) 1995 Contact Technology                   
*       * 26 Aries Lane                                           
*       * Novato, CA  94947                                       
*       * U.S.A                                             
*       *                                                         
*       * Description:                                            
*       * This program was automatically generated by GENSCRN.    
*       *                                                         
*       *********************************************************

PARAMETERS cevent, ctaskalias

*       *********************************************************
*       *                                                         
*       *          ZZEXP/Windows Setup Code - SECTION 1           
*       *                                                         
*       *********************************************************
*

#REGION 1
*++
* Record Export update task support code
*--
* Make sure this is the ONLY task window open!
IF NOT EMPTY(_aWindows[1])
  IF _aWindows[1] = '1_ZZEXP'
    * OK to go back to this window
  ELSE
    WAIT 'Close all windows before performing this function, press <Enter>' WINDOW
    RETURN
  ENDIF
ENDIF

PRIVATE ALL EXCEPT _*


*       *********************************************************
*       *                                                         
*       *          ZZEXP/Windows Setup Code - SECTION 2           
*       *                                                         
*       *********************************************************
*

#REGION 1
* Define offsets into GET variable array structure.
* The first section of the array must match the table layout
* so we can use GATHER/SCATTER to transfer between file and array.
* Make sure it is an exact match to the dbf structure!
* Adjust the size of the array below to hold the memvars

#DEFINE t_cDesc      t_aGETvars[1]
#DEFINE t_cFile      t_aGETvars[2]
#DEFINE t_cType      t_aGETvars[3]
#DEFINE t_cDelim     t_aGETvars[4]
#DEFINE t_cNdx       t_aGETvars[5]
#DEFINE t_cField1    t_aGETvars[6]
#DEFINE t_cField2    t_aGETvars[7]
#DEFINE t_cField3    t_aGETvars[8]
#DEFINE t_cField4    t_aGETvars[9]
#DEFINE t_cField5    t_aGETvars[10]
#DEFINE t_cField6    t_aGETvars[11]
#DEFINE t_cField7    t_aGETvars[12]
#DEFINE t_cField8    t_aGETvars[13]
#DEFINE t_cField9    t_aGETvars[14]
#DEFINE t_cField10   t_aGETvars[15]
#DEFINE t_cField11   t_aGETvars[16]
#DEFINE t_cField12   t_aGETvars[17]
#DEFINE t_cField13   t_aGETvars[18]
#DEFINE t_cField14   t_aGETvars[19]
#DEFINE t_cField15   t_aGETvars[20]
#DEFINE t_cField16   t_aGETvars[21]
#DEFINE t_cField17   t_aGETvars[22]
#DEFINE t_cField18   t_aGETvars[23]
#DEFINE t_cField19   t_aGETvars[24]
#DEFINE t_cField20   t_aGETvars[25]
#DEFINE t_cFiltDsc   t_aGETvars[26]
#DEFINE t_cFilt      t_aGETvars[27]

* Now define elements for additional non-table fields
#DEFINE t_cOption    t_aGETvars[41]
#DEFINE t_nTopBump   t_aGETvars[42]
#DEFINE t_nBotBump   t_aGETvars[43]

  * And now define the array itself
  DIMENSION t_aGETvars[50]

  * Declare Screen-set wide global variables
  m.t_cWindow = ''   && Window name for this instance
  m.t_nWinRow = 2    && Default row for our window
  m.t_nWinCol = 2    && Default column for our window
  m.t_nCurObj = 0    && Current object number
  m.t_nRecno = 0     && Current record number
  m.t_cOrder = 'zzExp'     && Default table order.
  m.t_bAddNew = .F.  && Set true if adding new record
  m.t_bChanges = .F. && Changes have been made flag.
  m.t_bAtTop = .F.   && Beginning of file flag
  m.t_bAtEnd = .F.   && End of file flag

  * Determine our task alias, or create a new one.
  IF m.cEvent = 'LAUNCH'
    * Look for topmost existing instance of this task first.
    m.t_cWindow = wTaskWin( m.cTaskAlias )

    IF EMPTY( m.t_cWindow )
      * Create a new instance of this task.
      m.cTaskAlias = wNewTask( m.cTaskAlias )
      IF EMPTY( m.cTaskAlias )
        RETURN .F.
      ENDIF

      m.t_cWindow = wAddWin( m.cTaskAlias, 'ZZEXP', ;
                         'Export Records' )
    ELSE
      * Get the task alias associated with window we found.
      m.cTaskAlias = wWinAlias( m.t_cWindow )
    ENDIF
  ENDIF

  * Restore last saved state (if any) of memory variables.
  DO wGetState WITH m.cTaskAlias

  * Make sure the files we use are open
  IF NOT USED(_mastfile)
    * Use AGAIN in case another task, or BROWSE, has file open
    * under a different alias name.
    USE (LOCFILE(_mastfile,'DBF','Where is the Customer master  file?'));
        IN 0 AGAIN ALIAS &_mastfile
    SET INDEX TO &_MastNdx
  ENDIF
  SELECT &_mastfile

  * Make sure the files we use are open
  * get filter array list
  IF NOT USED('zzFilt')
    * Use AGAIN in case another task, or BROWSE, has file open
    * under a different alias name.
    USE (LOCFILE('zzFilt','DBF','Where is the Filter file?'));
        IN 0 AGAIN ALIAS zzFilt
  ENDIF
  SELECT zzFilt
  SET INDEX TO zzFilt
  SET ORDER TO 1

  IF NOT USED('zzexp')
    * Use AGAIN in case another task, or BROWSE, has file open
    * under a different alias name.
    USE (LOCFILE('zzexp','DBF','Where is the export format file?'));
        IN 0 AGAIN ALIAS zzexp
  ENDIF
  SELECT zzexp
  SET INDEX TO (m.t_cOrder)
  SET ORDER TO (m.t_cOrder)

  * Restore current record from saved context.
  IF m.t_nRecno > 0 AND m.t_nRecno <= RECCOUNT()
    GO m.t_nRecno
  ENDIF

  DO CASE
    CASE m.cEvent = 'CLOSE'
      IF NOT save_form('closing the window')
        RETURN .F.
      ENDIF
      HIDE WINDOW (t_cWindow)

    CASE m.cEvent = 'UPDATE'
      * If changes have been made, ignore simple update events.
      * Note that this code depends on SET EXACT OFF.
      IF NOT (t_bChanges AND cEvent == 'UPDATE')
        IF save_form('selecting a new record')
          * Process Special event messages we support.
          IF '>' $ m.cEvent
            DO controls WITH SUBSTR(cEvent,AT('>',cEvent)+1)
          ELSE
            IF '-' $ m.cEvent
              GO VAL(SUBSTR(cEvent,AT('-',cEvent)+1))
            ENDIF
            DO load_form
            DO show_form
          ENDIF
        ENDIF
      ENDIF

    CASE m.cEvent = 'LAUNCH' OR m.cEvent = 'ACTIVATE'
      IF NOT WVISIBLE( m.t_cWindow )
        * Position newly created window(s) at last saved position.
        * SIZE must be manually adjusted, NOT from screen generator
        MODIFY WINDOW ( m.t_cWindow ) ;
                FONT 'MS Sans Serif',8 STYLE 'B';
                ICON FILE cardfile.ico ;
                AT m.t_nWinRow, m.t_nWinCol SIZE 31,96 ;
                COLOR RGB(,,,192,192,192)

        * Initialize the GET variable array.
        STORE '' TO t_aGETvars
        STORE 0 TO t_nTopBump, t_nBotBump, t_nCurObj

        * Load current record into GET variable array.
        DO load_form
      ENDIF

      * Issue GETS if this is first time, or another task cleared them
      ACTIVATE WINDOW (m.t_cWindow) NOSHOW
      IF OBJNUM( t_nTopBump, wRdLevel() ) = 0
        DO issue_gets

        * Object numbers have changed, so clear saved object number
        m.t_nCurObj = 0
      ELSE
        * If window was just re-opened, show the gets.
        IF NOT WVISIBLE(m.t_cWindow)
          SHOW GETS WINDOW (m.t_cWindow) LEVEL wRdLevel()
        ENDIF
      ENDIF

      * Set option buttons correctly
      DO set_buttons WITH m.t_bChanges
      ACTIVATE WINDOW (m.t_cWindow)

      * If no saved object, determine default first object to read.
      IF m.t_nCurObj = 0
        m.t_nCurObj = OBJNUM( t_cDesc, wRdLevel() )
      ENDIF

      * Define flag to remember the state of our menu pad. The
      * Activate clause is re-called each time a dialog window
      * is closed. By using this flag we can avoid the overhead of
      * re-redefining our menu in these cases.
      bMenuUp = .F.

      * Give ZZProc.prg our READ level validation expressions
      DO wReadInit WITH 'exp_deact()', 'get_valid()', ;
                        'save_form("closing the window")'

      READ CYCLE SAVE OBJECT m.t_nCurObj ;
         ACTIVATE exp_act() ;
         DEACTIVATE exp_deact() ;
         VALID READKEY(1) = 5     && Only terminate if deactivate

      m.t_nCurObj = _nCurObj      && Remember last data object
  ENDCASE

  * Save current context information
  m.t_cOrder = ORDER('zzExp')    && Remember data table order
  m.t_nRecno = RECNO('zzExp')    && and record number
  DO wSaveState WITH m.cTaskAlias

  IF NOT WVISIBLE(t_cWindow)
    * Close the tables we use. If other tasks use them, they will
    * reopen them as part of their context restoration.
    SELECT zzFilt
    USE
    SELECT zzExp
    USE

    * Close associated browse window also, if open.,
    IF WEXIST('Exp_List')
      DEACTIVATE WINDOW 'Exp_List'
    ENDIF

    DO wDelTask WITH m.cTaskAlias
  ENDIF
  RETURN .T.

*******************************************************************
PROCEDURE issue_gets
*++
* The code for this procedure will be generated by GENSCRN.  It
* will issue all the @GETs for the screen.  We want the GET
* commands to be in a seperate procedure so we can call them
* conditionally from the task program setup code.
*--

* ! Important !
* Make sure the When statement for the "get" field "TopBump"
* contains the name of the last "get" field and
* "BotBump" contains the name of the first "get" field
* this will insure that the cursor cycles properly!!!!!
*

*       *********************************************************
*       *                                                         
*       *               ZZEXP/Windows Screen Layout               
*       *                                                         
*       *********************************************************
*

#REGION 1
@ 5.154,2.167 SAY "Description:" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 6.538,46.833 SAY "Export File Type:" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 6.308,2.667 SAY "Export File:" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 8.000,48.333 SAY "Delimited With:" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 10.231,2.167 SAY 'Fields: "All" in  1st field exports all customer database fields. Choose fields across and down.' ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 5.000,54.167 SAY "Order by:" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 0.000,0.167 GET t_nTopBump ;
	PICTURE "@*IVN " ;
	SIZE 1.000,1.167,1.000 ;
	DEFAULT 0 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wBumper(OBJNUM(t_cDesc) + 7)
@ 5.308,16.667 GET t_cdesc ;
	SIZE 1.000,24.833 ;
	DEFAULT " " ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	PICTURE "@K" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 6.385,16.667 GET t_cfile ;
	SIZE 1.000,15.333 ;
	DEFAULT " " ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	PICTURE "@K" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 4.846,65.833 GET t_cNdx ;
	PICTURE "@^" ;
	FROM _aTags ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 6.385,65.833 GET t_cType ;
	PICTURE "@^ SDF;Delimited;FoxPro (.DBF);FoxPlus/dBase3 (.DBF);DIF;MOD;SYLK;WK1;WKS;WR1;WRK;XLS" ;
	SIZE 1.538,21.333 ;
	DEFAULT "SDF" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 8.000,66.167 GET t_cdelim ;
	SIZE 1.000,3.333 ;
	DEFAULT " " ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	PICTURE "@K" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 12.923,3.167 GET t_cField1 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 12.923,22.167 GET t_cField2 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 12.923,41.167 GET t_cField3 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 12.923,60.167 GET t_cField4 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 14.615,3.167 GET t_cField5 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 14.615,22.167 GET t_cField6 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 14.615,41.167 GET t_cField7 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 14.615,60.167 GET t_cField8 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 16.308,3.167 GET t_cField9 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 16.308,22.167 GET t_cField10 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 16.308,41.167 GET t_cField11 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 16.308,60.167 GET t_cField12 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 0.000,1.333 GET t_nBotBump ;
	PICTURE "@*IVN " ;
	SIZE 1.077,0.833,1.000 ;
	DEFAULT 0 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wBumper( OBJNUM(t_cDesc) )
@ 18.000,3.167 GET t_cField13 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 18.000,22.167 GET t_cField14 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 18.000,41.167 GET t_cField15 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 18.000,60.167 GET t_cField16 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 19.692,3.167 GET t_cField17 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 19.692,22.167 GET t_cField18 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 19.692,41.167 GET t_cField19 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 19.692,60.167 GET t_cField20 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 22.692,3.000 SAY "Export Filtered List (List Defined in Filter Window, Blank = All Records) " ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT"
@ 25.385,2.833 GET t_cFiltDsc ;
	PICTURE "@^" ;
	FROM _zzFilt ;
	SIZE 1.538,87.167 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 28.538,1.833 SAY IIF(_Ok2All,'','For: Owner = [' +_Owner + ']' ) ;
	SIZE 1.000,33.333 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 1.000,2.667 GET t_cOption ;
	PICTURE "@*BHN " + ;
		(LOCFILE("prev.bmp","BMP|ICO|PCT|ICN","Where is prev?")) + ";" + ;
		(LOCFILE("next.bmp","BMP|ICO|PCT|ICN","Where is next?")) + ";" + ;
		(LOCFILE("list.bmp","BMP|ICO|PCT|ICN","Where is list?")) + ";" + ;
		(LOCFILE("add.bmp","BMP|ICO|PCT|ICN","Where is add?")) + ";" + ;
		(LOCFILE("execute.bmp","BMP|ICO|PCT|ICN","Where is execute?")) + ";" + ;
		(LOCFILE("undo.bmp","BMP|ICO|PCT|ICN","Where is undo?")) + ";" + ;
		(LOCFILE("save.bmp","BMP|ICO|PCT|ICN","Where is save?")) + ";" + ;
		(LOCFILE("exit.bmp","BMP|ICO|PCT|ICN","Where is exit?")) ;
	SIZE 2.923,8.667,0.667 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	VALID ProcOption(t_cOption,.T.)
@ 4.077,1.500 TO 4.077,78.000 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 0.692,1.500 TO 0.692,77.833 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 0.692,1.167 TO 4.154,1.167 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 0.692,77.833 TO 4.077,77.833 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 4.615,1.167 TO 4.615,14.500 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 4.615,1.167 TO 8.000,1.167 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 4.615,14.167 TO 7.846,14.167 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 7.846,1.167 TO 7.846,14.500 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 4.615,15.833 TO 4.615,42.833 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 4.615,15.500 TO 8.077,15.500 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 8.000,15.667 TO 8.000,43.000 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 4.615,43.000 TO 8.000,43.000 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 4.615,45.000 TO 9.307,45.000 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 4.615,45.000 TO 4.615,63.500 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 4.692,63.167 TO 9.230,63.167 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 9.154,45.167 TO 9.154,63.500 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 4.615,65.000 TO 4.615,88.167 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 4.615,64.667 TO 9.307,64.667 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 9.231,64.833 TO 9.231,88.000 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 4.692,88.000 TO 9.230,88.000 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 9.846,1.167 TO 9.846,91.334 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 9.846,1.167 TO 11.692,1.167 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 9.923,91.167 TO 11.615,91.167 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 11.538,1.333 TO 11.538,91.500 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 12.308,1.500 TO 12.308,79.667 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 12.308,1.167 TO 21.693,1.167 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 21.615,1.333 TO 21.615,79.500 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 12.385,79.500 TO 21.616,79.500 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 22.308,1.167 TO 22.308,91.334 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 22.308,1.167 TO 24.154,1.167 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 22.385,91.167 TO 24.077,91.167 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 24.000,1.333 TO 24.000,91.500 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 24.769,1.667 TO 24.769,91.500 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 24.769,1.333 TO 27.384,1.333 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 27.385,1.667 TO 27.385,91.334 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 24.846,91.333 TO 27.384,91.333 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)


*       *********************************************************
*       *                                                         
*       *               ZZEXP/Windows Cleanup Code                
*       *                                                         
*       *********************************************************
*

#REGION 1
********************************************************************


*       *********************************************************
*       *                                                         
*       *   ZZEXP/Windows Supporting Procedures and Functions     
*       *                                                         
*       *********************************************************
*

#REGION 1
FUNCTION exp_act
*++
* Task specific READ activation handler.
*--

  * Put up custom menu pad for this task window. The activate clause
  * may sometimes be called after the window is hidden during a close
  * operation, if a dialog box was activated by the form level
  * validation handler. The WVISIBLE() test makes sure we don't put
  * the menu back up in this case. The bMenuUp flag is used only for
  * optimization purposes - so we don't redefine the menu if it's
  * already there.
  IF WVISIBLE(m.t_cWindow) AND NOT bMenuUp
    DO zzexp.mpr
    bMenuUp = .T.
  ENDIF

  RETURN .T.


********************************************************************
FUNCTION exp_deact
*++
* Task specific READ deactivation handler.
* This routine may be called by the READ command on a READ window
* deactivation, or explicitly by the wClearRead() function. That
* means we cannot depend on WLAST() or WONTOP() to be set right.
*--
  * Under FoxPro for Windows, Minimizing a window from the window
  * control box, or Choosing Next Window, bypasses the GET Valid
  * clause. This is our only chance to catch it, and thereby enforce
  * proper field validation.
  IF wCatchAll(m.t_cWindow)
    * Save last position of window
    m.t_nWinRow = WLROW(m.t_cWindow)
    m.t_nWinCol = WLCOL(m.t_cWindow)

    RELEASE PAD export OF _MSYSMENU
    RELEASE POPUP export
    bMenuUp = .F.
    RETURN .T.
  ELSE
    RETURN .F.
  ENDIF


********************************************************************
FUNCTION GET_valid
*++
* Common validation routine called when any field data is changed.
*
* This routine is responsible for:
*  1. Checking lock status of record, locking if needed.
*  2. Setting changes flag and setting buttons.
*
* Returns TRUE.
*  If data was changed and lock could not be established, data is
*  reset to initial value.
*--
PRIVATE xTemp

  IF NOT m.t_bchanges AND wChanged()
    IF NOT wLock(m.cTaskAlias, 'zzexp', RECNO('zzexp') )
      * Restore original field contents on Lock failure.
      DO wFldUndo

      * Return success, since user is warned, and changes undone.
      RETURN .T.
    ENDIF

    * Make sure any changes to record made since original
    * display are shown on screen when the record is locked.
    STORE EVALUATE( VARREAD() ) TO m.xTemp
    DO load_form
    STORE m.xTemp TO ( VARREAD() )
    DO show_form

    DO set_buttons WITH .T.
  ENDIF

  RETURN .T.


********************************************************************
PROCEDURE load_form
*++
* Load data from current record for display and/or edit.
*---
  SELECT zzexp

  * Don't stay at EOF if we can help it.
  IF EOF()
    GOTO BOTTOM

    * If still at EOF, perform implicit add record command.
    IF EOF()
      RETURN init_form()
    ENDIF
  ENDIF

  m.t_bAddNew = .F.
  DO set_buttons WITH .F.

  * Let all the other tasks know what record we have displayed.
  DO wListen WITH m.cTaskAlias, 'zzexp', RECNO('zzexp')

  * Load data from field variables into GET variable array.
  SCATTER TO t_aGETvars MEMO
  RETURN


********************************************************************
PROCEDURE init_form
*++
* Initialize internal memory for a new address record.
* Let format default to current setting on add.
*---
  m.t_bAddNew = .T.
  DO set_buttons WITH .T.

  SELECT zzexp
  SCATTER TO t_aGETvars MEMO BLANK

  * Move to first field to begin entry of new record.
  _CUROBJ = OBJNUM( t_cDesc )
  RETURN


********************************************************************
PROCEDURE show_form
*++
* Display current data and Enable/Disable fields as appropriate.
*---

  SHOW GETS WINDOW (m.t_cWindow) LEVEL wRdLevel()
  RETURN


********************************************************************
FUNCTION set_buttons
PARAMETER bChanges
*++
* Set changes flag, and update control buttons accordingly.
*--
PRIVATE nRecno

  IF m.bChanges
    SHOW GET t_cOption,6 ENABLE LEVEL wRdLevel()
    SHOW GET t_cOption,7 ENABLE LEVEL wRdLevel()
  ELSE
    SHOW GET t_cOption,6 DISABLE LEVEL wRdLevel()
    SHOW GET t_cOption,7 DISABLE LEVEL wRdLevel()
  ENDIF

  * The AddNEw flag will always be set if there are no records.
  IF t_bAddNew
    t_bAtTop = .T.
    t_bAtEnd = .T.
  ELSE
    nRecno = RECNO()
    SKIP -1
    t_bAtTop = BOF()
    GO nRecno

    SKIP 1
    t_bAtEnd = EOF()
    GO nRecno
  ENDIF

  * Set buttons according to current record
  IF m.t_bAtTop
    SHOW GET t_cOption,1 DISABLE LEVEL wRdLevel()
  ELSE
    SHOW GET t_cOption,1 ENABLE LEVEL wRdLevel()
  ENDIF

  IF m.t_bAtEnd
    SHOW GET t_cOption,2 DISABLE LEVEL wRdLevel()
  ELSE
    SHOW GET t_cOption,2 ENABLE LEVEL wRdLevel()
  ENDIF

  * Store new value of task level change flag and return it.
  m.t_bChanges = m.bChanges
  RETURN m.bChanges


********************************************************************
FUNCTION ProcOption
PARAMETER cOption, bInObject
*++
* Process menu and pushbutton options.
*--

  * place chosen filter into report filter memvar
  SELECT zzFilt
  IF NOT EMPTY(t_cFiltDsc)
    SEEK UPPER(t_cFiltDsc)
    * Limit user to "owned" records if required

    * Add something like [owner='JFK' AND ]
    * to the begining of the filter string
    * if limiting user access to not all records

    IF _Ok2All
      t_cFilt = zzFilt->FiltStr
    ELSE
      t_cFilt = 'owner=[' +_Owner + '] AND ' + ALLTRIM(zzFilt->FiltStr)
      * disable "Owner = " display on reports, pds 12/94
      * un-comment to enable!
      *t_cFiltDsc = '( Owner = ' + _Owner + ') ' + ALLTRIM(qFiltList)
    ENDIF

  ELSE
    IF _Ok2All
      t_cFilt = ''
    ELSE
      t_cFilt = 'owner=[' +_Owner + ']'
      * disable "Owner = " display on reports, pds 12/94
      * un-comment to enable!
      *t_cFiltDsc = '( Owner = ' + _Owner + ') '
    ENDIF
  ENDIF

  * if choice is picture button, strip off ".BMP" from end
  * make sure .bmp button file names match menu options!
  m.cOption = STRTRAN(m.cOption,'.BMP','')
  * identify file name, strip off path + back-slashes
  m.cOption = SUBSTR(m.cOption,RAT('\',m.cOption)+1)

  SELECT zzexp
  m.cOption = UPPER( ALLTRIM(m.cOption) )

  IF  m.cOption = 'COPY'
    APPEND BLANK
    GATHER FROM t_aGETvars MEMO
    DO load_form
    DO show_form
    DO wUnlock WITH m.cTaskAlias
    WAIT 'Record Copied' Window NOWAIT
    RETURN .T.
  ENDIF

  DO CASE
    * First, handle the common task button options.
    CASE controls(cOption, bInObject)

    CASE m.cOption = 'EXECUTE'
      DO ExpExe

    CASE m.cOption = 'LIST'
      * Launch an independant BROWSE window, linked to ours.
      DO wLaunch WITH 'ExpList IN zzexp'

  ENDCASE

  RETURN .T.


********************************************************************
PROCEDURE explist
PARAMETER cEvent, cTaskAlias
*++
* This BROWSE task is designed to work together with the
* filter update task window.
*
* Parameters from wLaunch are ignored for BROWSE tasks, since
* once they are started, we never get control of them again.
*--
  SELECT zzexp

  * Define a window for Browse to pattern itself after. Specify font
  * so size will be consistent even if Main Window font changes.
  DEFINE WINDOW bwin AT 1,1 SIZE 11,75 ;
                        FONT 'MS Sans Serif',8 STYLE 'B' ;
                        FLOAT SHADOW CLOSE MINIMIZE ZOOM ;
                        SYSTEM GROW COLOR SCHEME 8
  MOVE WINDOW bwin CENTER

  * Activate the BROWSE window. The WHEN clause calls zzexp.prg
  * with the event string 'UPDATE-n' where n is the new
  * record number to display in the window.
  BROWSE NOWAIT REST NOMENU NOMODIFY ;
         WINDOW bwin TITLE 'Exp_List' ;
         FIELDS Desc,File,Type,Delim,Field1,Field2,Field3,Field4 ;
         WHEN EVALUATE( 'zzexp' ;
                + '("UPDATE-' + ALLTRIM(STR(RECNO())) ;
                + '", "1_ZZexp")' )

  RELEASE WINDOW bwin
  RETURN


********************************************************************
FUNCTION save_form
PARAMETER cMsgTxt
*++
* Validate complete form as a whole, and save changes. If cMsgTxt
* contains a string, use it to ask whether or not user wants to
* save changes.
*--
PRIVATE nBadField, cReason, cAnswer

  SELECT zzexp
  STORE '' TO m.cReason

  IF m.t_bChanges
    m.cAnswer = IIF(EMPTY(m.cMsgTxt), 'YES', zzQuest(m.t_cWindow, ;
        'Do you want to this export description ' ;
        + 'before ' + m.cMsgTxt + '?' ) )

    * Return failure immediately if user cancels.
    IF m.cAnswer = 'CANCEL'
      RETURN .F.
    ENDIF

    * Save the changes if we are supposed to.
    IF m.cAnswer = 'YES'
      * Make sure all required fields have been entered.
      * none as of 9/94 pds
      DO CASE
       CASE EMPTY(t_cDesc)
         m.cReason = 'A description is required'
         m.nBadField = OBJNUM(t_cdesc)

       CASE EMPTY(t_cFile)
         m.cReason = 'A file name is required'
         m.nBadField = OBJNUM(t_cdesc)

       CASE EMPTY(t_cType)
         m.cReason = 'An export type is required'
         m.nBadField = OBJNUM(t_cdesc)

       CASE EMPTY(t_cNdx)
         m.cReason = 'An Index Order is required'
         m.nBadField = OBJNUM(t_cdesc)

      ENDCASE

      IF NOT EMPTY(m.cReason)
        DO zzWarn WITH m.t_cWindow, m.cReason

        * This routine may be called when no GETs are issued (like
        * during Global shutdown). OBJNUM() returns 0 in this case.
        _CUROBJ = nBadField
        RETURN .F.
      ENDIF

      * Add a new record to the database when needed.
      IF m.t_bAddNew
        * Create new record
        APPEND BLANK
        m.t_bAddNew = .F.
      ENDIF

      GATHER FROM t_aGETvars MEMO
      DO set_buttons WITH .F.
    ELSE
      * User said 'dont save', so reload from disk.
      DO load_form
      DO show_form
    ENDIF

    * Whether changes saved or discarded, release the locks.
    DO wUnlock WITH m.cTaskAlias

  ENDIF

  RETURN .T.


* EOF - save_form
********************************************************************
FUNCTION ExpExe
* Execute Export
*

IF EMPTY(t_cFile)
  WAIT 'You must enter an export file NAME first, Press <Enter>' WINDOW
  RETURN
ENDIF
IF EMPTY(t_cType)
  WAIT 'You must enter an export file TYPE first, Press <Enter>' WINDOW
  RETURN
ENDIF

*****
IF zzCntnue('Do you want to EXPORT records?')
  * Continue
ELSE
  RETURN
ENDIF

ExpFile  = UPPER(ALLTRIM(t_cFile))
ExpType  = UPPER(ALLTRIM(t_cType))
ExpDlm   = t_cDelim
ExpNdx   = ALLTRIM(t_cNdx)
ExpFilt  = ' '
ExpFlds  = ' '
ExpFld1  = ' '
ExpFld2  = ' '
ExpFld3  = ' '
ExpFld4  = ' '
ExpFld5  = ' '
ExpFld6  = ' '
ExpFld7  = ' '
ExpFld8  = ' '
ExpFld9  = ' '
ExpFld10 = ' '
ExpFld11 = ' '
ExpFld12 = ' '
ExpFld13 = ' '
ExpFld14 = ' '
ExpFld15 = ' '
ExpFld16 = ' '
ExpFld17 = ' '
ExpFld18 = ' '
ExpFld19 = ' '
ExpFld20 = ' '

SELECT &_mastfile
* get user selected index order
DO CASE
CASE t_cNdx = _aTags[1]
  SET ORDER TO 1
CASE t_cNdx = _aTags[2]
  SET ORDER TO 2
CASE t_cNdx = _aTags[3]
  SET ORDER TO 3
CASE t_cNdx = _aTags[4]
  SET ORDER TO 4
CASE t_cNdx = _aTags[5]
  SET ORDER TO 5
CASE t_cNdx = _aTags[6]
  SET ORDER TO 6
CASE t_cNdx = _aTags[7]
  SET ORDER TO 7
  SHOW GET m._Find7 ENABLE
CASE t_cNdx = _aTags[8]
  SET ORDER TO 8
CASE t_cNdx = _aTags[9]
  SET ORDER TO 9
CASE t_cNdx = _aTags[10]
  SET ORDER TO 10
OTHERWISE
  SET ORDER TO 1
ENDCASE

DEFINE WINDOW expt ;
  AT 4,7 ;
  SIZE 6,70 ;
  TITLE  'Record Export' ;
  FONT 'Times New Roman', 10 ;
  STYLE 'B' ;
  FLOAT ;
  CLOSE ;
  NOMINIMIZE ;
  DOUBLE
MOVE WINDOW expt CENTER
ACTIVATE WINDOW expt

* get "COPY TO" filter "FOR" string

ExpFilt = t_cFilt

* Build "COPY TO" fields string
IF UPPER(ALLTRIM(t_cField1)) = 'ALL' OR EMPTY(t_cField1)
ELSE
  ExpFld1 = GetFld(t_cField1)
  ExpFlds = ExpFLd1
  IF NOT EMPTY(t_cField2)
    ExpFld2 = GetFld(t_cField2)
    ExpFLds = ExpFLds + ',' + ExpFld2
  ENDIF
  IF NOT EMPTY(t_cField3)
    ExpFld3 = GetFld(t_cField3)
    ExpFLds = ExpFLds + ',' + ExpFld3
  ENDIF
  IF NOT EMPTY(t_cField4)
    ExpFld4 = GetFld(t_cField4)
    ExpFLds = ExpFLds + ',' + ExpFld4
  ENDIF
  IF NOT EMPTY(t_cField5)
    ExpFld5 = GetFld(t_cField5)
    ExpFLds = ExpFLds + ',' + ExpFld5
  ENDIF
  IF NOT EMPTY(t_cField6)
    ExpFld6 = GetFld(t_cField6)
    ExpFLds = ExpFLds + ',' + ExpFld6
  ENDIF
  IF NOT EMPTY(t_cField7)
    ExpFld7 = GetFld(t_cField7)
    ExpFLds = ExpFLds + ',' + ExpFld7
  ENDIF
  IF NOT EMPTY(t_cField8)
    ExpFld8 = GetFld(t_cField8)
    ExpFLds = ExpFLds + ',' + ExpFld8
  ENDIF
  IF NOT EMPTY(t_cField9)
    ExpFld9 = GetFld(t_cField9)
    ExpFLds = ExpFLds + ',' + ExpFld9
  ENDIF
  IF NOT EMPTY(t_cField10)
    ExpFld10 = GetFld(t_cField10)
    ExpFLds = ExpFLds + ',' + ExpFld10
  ENDIF
  IF NOT EMPTY(t_cField11)
    ExpFld11 = GetFld(t_cField11)
    ExpFLds = ExpFLds + ',' + ExpFld11
  ENDIF
  IF NOT EMPTY(t_cField13)
    ExpFld13 = GetFld(t_cField13)
    ExpFLds = ExpFLds + ',' + ExpFld13
  ENDIF
  IF NOT EMPTY(t_cField14)
    ExpFld14 = GetFld(t_cField14)
    ExpFLds = ExpFLds + ',' + ExpFld14
  ENDIF
  IF NOT EMPTY(t_cField15)
    ExpFld15 = GetFld(t_cField15)
    ExpFLds = ExpFLds + ',' + ExpFld15
  ENDIF
  IF NOT EMPTY(t_cField16)
    ExpFld16 = GetFld(t_cField16)
    ExpFLds = ExpFLds + ',' + ExpFld16
  ENDIF
  IF NOT EMPTY(t_cField17)
    ExpFld17 = GetFld(t_cField17)
    ExpFLds = ExpFLds + ',' + ExpFld17
  ENDIF
  IF NOT EMPTY(t_cField18)
    ExpFld18 = GetFld(t_cField18)
    ExpFLds = ExpFLds + ',' + ExpFld18
  ENDIF
  IF NOT EMPTY(t_cField19)
    ExpFld19 = GetFld(t_cField19)
    ExpFLds = ExpFLds + ',' + ExpFld19
  ENDIF
  IF NOT EMPTY(t_cField20)
    ExpFld20 = GetFld(t_cField20)
    ExpFLds = ExpFLds + ',' + ExpFld20
  ENDIF
ENDIF

SET TALK ON
SET ODOM TO 10

* Don't switch the order of the cases!!!!! pds 9/94
DO CASE

*** empty and empty cases

CASE EMPTY(ExpFlds) AND EMPTY(ExpFilt) AND ExpType = 'FOXPRO'
  COPY TO &ExpFile

CASE EMPTY(ExpFlds) AND EMPTY(ExpFilt) AND ExpType = 'FOXPLUS'
  COPY TO &ExpFile TYPE FOXPLUS

CASE EMPTY(ExpFlds) AND EMPTY(ExpFilt) AND ExpType = 'DELIM'
  IF EMPTY(ExpDlm)
    COPY TO &ExpFile DELIMITED
  ELSE
    COPY TO &ExpFile DELIMITED WITH &ExpDlm
  ENDIF

CASE EMPTY(ExpFlds) AND EMPTY(ExpFilt)
  COPY TO &ExpFile TYPE &ExpType

*** empty and not empty cases

CASE EMPTY(ExpFlds) AND NOT EMPTY(ExpFilt) AND ExpType = 'FOXPRO'
  COPY TO &ExpFile FOR &ExpFilt

CASE EMPTY(ExpFlds) AND NOT EMPTY(ExpFilt) AND ExpType = 'FOXPLUS'
  COPY TO &ExpFile FOR &ExpFilt TYPE FOXPLUS

CASE EMPTY(ExpFlds) AND NOT EMPTY(ExpFilt) AND ExpType = 'DELIM'
  IF EMPTY(ExpDlm)
    COPY TO &ExpFile FOR &ExpFilt DELIMITED
  ELSE
    COPY TO &ExpFile FOR &ExpFilt DELIMITED WITH &ExpDlm
  ENDIF

CASE EMPTY(ExpFlds) AND NOT EMPTY(ExpFilt)
  COPY TO &ExpFile FOR &ExpFilt TYPE &ExpType

*** not empty and empty cases

CASE NOT EMPTY(ExpFlds) AND EMPTY(ExpFilt) AND ExpType = 'FOXPRO'
  COPY TO &ExpFile FIELDS &ExpFlds

CASE NOT EMPTY(ExpFlds) AND EMPTY(ExpFilt) AND ExpType = 'FOXPLUS'
  COPY TO &ExpFile FIELDS &ExpFlds TYPE FOXPLUS

CASE NOT EMPTY(ExpFlds) AND EMPTY(ExpFilt) AND ExpType = 'DELIM'
  IF EMPTY(ExpDlm)
    COPY TO &ExpFile FIELDS &ExpFlds DELIMITED
  ELSE
    COPY TO &ExpFile FIELDS &ExpFlds DELIMITED WITH &ExpDlm
  ENDIF

CASE NOT EMPTY(ExpFlds) AND EMPTY(ExpFilt)
  COPY TO &ExpFile FIELDS &ExpFlds TYPE &ExpType

*** not empty and not empty cases

CASE NOT EMPTY(ExpFlds) AND NOT EMPTY(ExpFilt) AND ExpType = 'FOXPRO'
  COPY TO &ExpFile FIELDS &ExpFlds FOR &ExpFilt

CASE NOT EMPTY(ExpFlds) AND NOT EMPTY(ExpFilt) AND ExpType = 'FOXPLUS'
  COPY TO &ExpFile FIELDS &ExpFlds FOR &ExpFilt TYPE FOXPLUS

CASE NOT EMPTY(ExpFlds) AND NOT EMPTY(ExpFilt) AND ExpType = 'DELIM'
  IF EMPTY(ExpDlm)
    COPY TO &ExpFile FIELDS &ExpFlds FOR &ExpFilt DELIMITED
  ELSE
    COPY TO &ExpFile FIELDS &ExpFlds FOR &ExpFilt DELIMITED WITH &ExpDlm
  ENDIF

CASE NOT EMPTY(ExpFlds) AND NOT EMPTY(ExpFilt)
  COPY TO &ExpFile FIELDS &ExpFlds FOR &ExpFilt TYPE &ExpType

ENDCASE

SET TALK OFF
SET ODOM TO 100

WAIT 'Export finished ' WINDOW TIMEOUT 2

DEACTIVATE WINDOW expt

RETURN

* EOF - ExpExe
*******************************************************************
PROCEDURE GetFld
PARAMETERS XpFld
* Get proper .dbf field name from user entered "english" field name
*

IF UPPER(ALLTRIM(XpFld)) = 'ALL' OR EMPTY(XpFld)
  RETURN ' '
ENDIF

* Trim user entered field name values
UsrFld   = ALLTRIM(XpFld)

mPos = ASCAN(_zzsmast,UsrFld)
mSub = ASUBSCRIPT(_zzsmast,mPos,1)

XpFld = ALLTRIM(_zzsmast(mSub,2)) && the dbf field name

*wait 'XpFld = ' + Xpfld window

RETURN XpFld


********************************************************************
********************************************************************
********************************************************************
* EOF - zzExp.prg