*       *********************************************************
*       *                                                         
*       * 03/11/95              ZZIMP.PRG                12:32:25 
*       *                                                         
*       *********************************************************
*       *                                                         
*       * Patrick Smith                                           
*       *                                                         
*       * Copyright (c) 1995 Contact Technology                   
*       * 26 Aries Lane                                           
*       * Novato, CA  94947                                       
*       * U.S.A                                             
*       *                                                         
*       * Description:                                            
*       * This program was automatically generated by GENSCRN.    
*       *                                                         
*       *********************************************************

PARAMETERS cevent, ctaskalias

*       *********************************************************
*       *                                                         
*       *          ZZIMP/Windows Setup Code - SECTION 1           
*       *                                                         
*       *********************************************************
*

#REGION 1
*++
* Record Import update task support code
*--
* Make sure this is the ONLY task window open!
IF NOT EMPTY(_aWindows[1])
  IF _aWindows[1] = '1_ZZIMP'
    * OK to go back to this window
  ELSE
    WAIT 'Close all windows before performing this function, press <Enter>' WINDOW
    RETURN
  ENDIF
ENDIF

PRIVATE ALL EXCEPT _*


*       *********************************************************
*       *                                                         
*       *          ZZIMP/Windows Setup Code - SECTION 2           
*       *                                                         
*       *********************************************************
*

#REGION 1
* Define offsets into GET variable array structure.
* The first section of the array must match the table layout
* so we can use GATHER/SCATTER to transfer between file and array.
* Make sure it is an exact match to the dbf structure!
* Adjust the size of the array below to hold the memvars

#DEFINE t_cDesc      t_aGETvars[1]
#DEFINE t_cFile      t_aGETvars[2]
#DEFINE t_cType      t_aGETvars[3]
#DEFINE t_cDelim     t_aGETvars[4]
#DEFINE t_cField1    t_aGETvars[5]
#DEFINE t_cWid1      t_aGETvars[6]
#DEFINE t_cField2    t_aGETvars[7]
#DEFINE t_cWid2      t_aGETvars[8]
#DEFINE t_cField3    t_aGETvars[9]
#DEFINE t_cWid3      t_aGETvars[10]
#DEFINE t_cField4    t_aGETvars[11]
#DEFINE t_cWid4      t_aGETvars[12]
#DEFINE t_cField5    t_aGETvars[13]
#DEFINE t_cWid5      t_aGETvars[14]
#DEFINE t_cField6    t_aGETvars[15]
#DEFINE t_cWid6      t_aGETvars[16]
#DEFINE t_cField7    t_aGETvars[17]
#DEFINE t_cWid7      t_aGETvars[18]
#DEFINE t_cField8    t_aGETvars[19]
#DEFINE t_cWid8      t_aGETvars[20]
#DEFINE t_cField9    t_aGETvars[21]
#DEFINE t_cWid9      t_aGETvars[22]
#DEFINE t_cField10   t_aGETvars[23]
#DEFINE t_cWid10     t_aGETvars[24]
#DEFINE t_cField11   t_aGETvars[25]
#DEFINE t_cWid11     t_aGETvars[26]
#DEFINE t_cField12   t_aGETvars[27]
#DEFINE t_cWid12     t_aGETvars[28]
#DEFINE t_cField13   t_aGETvars[29]
#DEFINE t_cWid13     t_aGETvars[30]
#DEFINE t_cField14   t_aGETvars[31]
#DEFINE t_cWid14     t_aGETvars[32]
#DEFINE t_cField15   t_aGETvars[33]
#DEFINE t_cWid15     t_aGETvars[34]
#DEFINE t_cField16   t_aGETvars[35]
#DEFINE t_cWid16     t_aGETvars[36]
#DEFINE t_cField17   t_aGETvars[37]
#DEFINE t_cWid17     t_aGETvars[38]
#DEFINE t_cField18   t_aGETvars[39]
#DEFINE t_cWid18     t_aGETvars[40]
#DEFINE t_cField19   t_aGETvars[41]
#DEFINE t_cWid19     t_aGETvars[42]
#DEFINE t_cField20   t_aGETvars[43]
#DEFINE t_cWid20     t_aGETvars[44]

* Now define elements for additional non-table fields
#DEFINE t_cOption    t_aGETvars[61]
#DEFINE t_nTopBump   t_aGETvars[62]
#DEFINE t_nBotBump   t_aGETvars[63]

  * And now define the array itself
  DIMENSION t_aGETvars[70]

  * Declare Screen-set wide global variables
  m.t_cWindow = ''   && Window name for this instance
  m.t_nWinRow = 2    && Default row for our window
  m.t_nWinCol = 2    && Default column for our window
  m.t_nCurObj = 0    && Current object number
  m.t_nRecno = 0     && Current record number
  m.t_cOrder = 'zzImp'     && Default table order.
  m.t_bAddNew = .F.  && Set true if adding new record
  m.t_bChanges = .F. && Changes have been made flag.
  m.t_bAtTop = .F.   && Beginning of file flag
  m.t_bAtEnd = .F.   && End of file flag

  * Determine our task alias, or create a new one.
  IF m.cEvent = 'LAUNCH'
    * Look for topmost existing instance of this task first.
    m.t_cWindow = wTaskWin( m.cTaskAlias )

    IF EMPTY( m.t_cWindow )
      * Create a new instance of this task.
      m.cTaskAlias = wNewTask( m.cTaskAlias )
      IF EMPTY( m.cTaskAlias )
        RETURN .F.
      ENDIF

      m.t_cWindow = wAddWin( m.cTaskAlias, 'ZZIMP', ;
                         'Import Records' )
    ELSE
      * Get the task alias associated with window we found.
      m.cTaskAlias = wWinAlias( m.t_cWindow )
    ENDIF
  ENDIF

  * Restore last saved state (if any) of memory variables.
  DO wGetState WITH m.cTaskAlias

  * get list of import file choices
  DIMENSION _Import(1)
  =ADIR(_Import,'*.*')
  =ASORT(_Import,1)

  * Make sure the files we use are open
  IF NOT USED(_mastfile)
    * Use AGAIN in case another task, or BROWSE, has file open
    * under a different alias name.
    USE (LOCFILE(_mastfile,'DBF','Where is the Customer master  file?'));
        IN 0 AGAIN ALIAS &_mastfile
    SET INDEX TO &_MastNdx
  ENDIF
  SELECT &_mastfile

  * Make sure the files we use are open
  IF NOT USED('zzImp')
    * Use AGAIN in case another task, or BROWSE, has file open
    * under a different alias name.
    USE (LOCFILE('zzImp','DBF','Where is the Import format file?'));
        IN 0 AGAIN ALIAS zzImp
  ENDIF
  SELECT zzImp
  SET INDEX TO (m.t_cOrder)
  SET ORDER TO (m.t_cOrder)

  * Restore current record from saved context.
  IF m.t_nRecno > 0 AND m.t_nRecno <= RECCOUNT()
    GO m.t_nRecno
  ENDIF

  DO CASE
    CASE m.cEvent = 'CLOSE'
      IF NOT save_form('closing the window')
        RETURN .F.
      ENDIF
      HIDE WINDOW (t_cWindow)

    CASE m.cEvent = 'UPDATE'
      * If changes have been made, ignore simple update events.
      * Note that this code depends on SET EXACT OFF.
      IF NOT (t_bChanges AND cEvent == 'UPDATE')
        IF save_form('selecting a new record')
          * Process Special event messages we support.
          IF '>' $ m.cEvent
            DO controls WITH SUBSTR(cEvent,AT('>',cEvent)+1)
          ELSE
            IF '-' $ m.cEvent
              GO VAL(SUBSTR(cEvent,AT('-',cEvent)+1))
            ENDIF
            DO load_form
            DO show_form
          ENDIF
        ENDIF
      ENDIF

    CASE m.cEvent = 'LAUNCH' OR m.cEvent = 'ACTIVATE'
      IF NOT WVISIBLE( m.t_cWindow )
        * Position newly created window(s) at last saved position.
        * SIZE must be manually adjusted, NOT from screen generator
        MODIFY WINDOW ( m.t_cWindow ) ;
                FONT 'MS Sans Serif',8 STYLE 'B';
                ICON FILE cardfile.ico ;
                AT m.t_nWinRow, m.t_nWinCol SIZE 30,96 ;
                COLOR RGB(,,,192,192,192)

        * Initialize the GET variable array.
        STORE '' TO t_aGETvars
        STORE 0 TO t_nTopBump, t_nBotBump, t_nCurObj

        * Load current record into GET variable array.
        DO load_form
      ENDIF

      * Issue GETS if this is first time, or another task cleared them
      ACTIVATE WINDOW (m.t_cWindow) NOSHOW
      IF OBJNUM( t_nTopBump, wRdLevel() ) = 0
        DO issue_gets

        * Object numbers have changed, so clear saved object number
        m.t_nCurObj = 0
      ELSE
        * If window was just re-opened, show the gets.
        IF NOT WVISIBLE(m.t_cWindow)
          SHOW GETS WINDOW (m.t_cWindow) LEVEL wRdLevel()
        ENDIF
      ENDIF

      * Set option buttons correctly
      DO set_buttons WITH m.t_bChanges
      ACTIVATE WINDOW (m.t_cWindow)

      * If no saved object, determine default first object to read.
      IF m.t_nCurObj = 0
        m.t_nCurObj = OBJNUM( t_cDesc, wRdLevel() )
      ENDIF

      * Define flag to remember the state of our menu pad. The
      * Activate clause is re-called each time a dialog window
      * is closed. By using this flag we can avoid the overhead of
      * re-redefining our menu in these cases.
      bMenuUp = .F.

      * Give ZZProc.prg our READ level validation expressions
      DO wReadInit WITH 'Imp_deact()', 'get_valid()', ;
                        'save_form("closing the window")'

      READ CYCLE SAVE OBJECT m.t_nCurObj ;
         ACTIVATE Imp_act() ;
         DEACTIVATE Imp_deact() ;
         VALID READKEY(1) = 5     && Only terminate if deactivate

      m.t_nCurObj = _nCurObj      && Remember last data object
  ENDCASE

  * Save current context information
  m.t_cOrder = ORDER('zzImp')    && Remember data table order
  m.t_nRecno = RECNO('zzImp')    && and record number
  DO wSaveState WITH m.cTaskAlias

  IF NOT WVISIBLE(t_cWindow)
    * Close the tables we use. If other tasks use them, they will
    * reopen them as part of their context restoration.
    SELECT zzImp
    USE

    * Close associated browse window also, if open.,
    IF WEXIST('Import_List')
      DEACTIVATE WINDOW 'Import_List'
    ENDIF

    DO wDelTask WITH m.cTaskAlias
  ENDIF
  RETURN .T.

*******************************************************************
PROCEDURE issue_gets
*++
* The code for this procedure will be generated by GENSCRN.  It
* will issue all the @GETs for the screen.  We want the GET
* commands to be in a seperate procedure so we can call them
* conditionally from the task program setup code.
*--

* ! Important !
* Make sure the When statement for the "get" field "TopBump"
* contains the name of the last "get" field and
* "BotBump" contains the name of the first "get" field
* this will insure that the cursor cycles properly!!!!!
*

*       *********************************************************
*       *                                                         
*       *               ZZIMP/Windows Screen Layout               
*       *                                                         
*       *********************************************************
*

#REGION 1
@ 11.769,3.000 SAY "Fields: (Go across)" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT"
@ 11.769,23.333 SAY 'Length (Ignore if type = "DBF" or "DLM")' ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT"
@ 11.385,2.000 TO 11.385,92.167 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 11.385,2.000 TO 13.231,2.000 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 11.462,92.000 TO 13.154,92.000 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 13.077,2.167 TO 13.077,92.334 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 4.308,2.500 TO 4.308,79.000 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 0.923,2.500 TO 0.923,78.833 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 0.923,2.167 TO 4.385,2.167 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 0.923,78.833 TO 4.308,78.833 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 6.077,3.333 SAY "Description:" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 7.462,3.833 SAY "Import File:" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 5.615,2.167 TO 5.615,15.500 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 5.615,2.167 TO 9.000,2.167 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 5.615,15.167 TO 8.846,15.167 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 8.846,2.167 TO 8.846,15.500 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 5.615,16.833 TO 5.615,43.833 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 5.615,16.500 TO 9.077,16.500 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 9.000,16.667 TO 9.000,44.000 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 5.615,44.000 TO 9.000,44.000 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 7.615,49.333 SAY "Delimited With:" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 6.154,47.833 SAY "Export File Type:" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 5.615,46.000 TO 10.307,46.000 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 5.615,46.000 TO 5.615,64.500 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 5.692,64.167 TO 10.230,64.167 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 10.154,46.167 TO 10.154,64.500 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 5.615,66.000 TO 5.615,89.167 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 5.615,65.667 TO 10.307,65.667 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 10.231,65.833 TO 10.231,89.000 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 5.692,89.000 TO 10.230,89.000 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 13.923,2.333 TO 13.923,92.000 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 13.923,2.000 TO 28.538,2.000 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 28.462,2.333 TO 28.462,92.000 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 14.000,92.000 TO 28.462,92.000 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 0.000,0.167 GET t_nTopBump ;
	PICTURE "@*IVN " ;
	SIZE 1.000,1.167,1.000 ;
	DEFAULT 0 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wBumper(OBJNUM(t_cDesc) + 7)
@ 6.077,17.667 GET t_cdesc ;
	SIZE 1.000,25.000 ;
	DEFAULT " " ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	PICTURE "@K" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 7.154,17.333 GET t_cFile ;
	PICTURE "@^" ;
	FROM _Import ;
	SIZE 1.538,26.000 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 6.077,66.500 GET t_cType ;
	PICTURE "@^ SDF;Delimited;FoxPro (.DBF);FoxPlus/dBase3 (.DBF);DIF;MOD;SYLK;WK1;WKS;WR1;WRK;XLS" ;
	SIZE 1.538,22.167 ;
	DEFAULT "SDF" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 7.692,66.833 GET t_cdelim ;
	SIZE 1.000,3.333 ;
	DEFAULT " " ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	PICTURE "@K" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 14.538,3.333 GET t_cField1 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 14.769,23.167 GET t_cWid1 ;
	SPINNER 1.000, 1, 254 ;
	PICTURE "@K ###" ;
	SIZE 0.846, 5.000 ;
	DEFAULT 1.000 ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() ) ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 14.538,32.667 GET t_cField2 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 14.769,53.167 GET t_cWid2 ;
	SPINNER 1.000, 1, 254 ;
	PICTURE "@K ###" ;
	SIZE 0.846, 5.000 ;
	DEFAULT 1.000 ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() ) ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 14.538,62.667 GET t_cField3 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 14.769,82.500 GET t_cWid3 ;
	SPINNER 1.000, 1, 254 ;
	PICTURE "@K ###" ;
	SIZE 0.846, 5.000 ;
	DEFAULT 1.000 ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() ) ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 16.538,3.333 GET t_cField4 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 16.769,23.167 GET t_cWid4 ;
	SPINNER 1.000, 1, 254 ;
	PICTURE "@K ###" ;
	SIZE 0.846, 5.000 ;
	DEFAULT 1.000 ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() ) ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 16.538,32.667 GET t_cField5 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 16.769,53.167 GET t_cWid5 ;
	SPINNER 1.000, 1, 254 ;
	PICTURE "@K ###" ;
	SIZE 0.846, 5.000 ;
	DEFAULT 1.000 ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() ) ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 16.538,62.667 GET t_cField6 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 16.769,82.500 GET t_cWid6 ;
	SPINNER 1.000, 1, 254 ;
	PICTURE "@K ###" ;
	SIZE 0.846, 5.000 ;
	DEFAULT 1.000 ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() ) ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 18.538,3.333 GET t_cField7 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 18.769,23.167 GET t_cWid7 ;
	SPINNER 1.000, 1, 254 ;
	PICTURE "@K ###" ;
	SIZE 0.846, 5.000 ;
	DEFAULT 1.000 ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() ) ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 18.538,32.667 GET t_cField8 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 18.769,53.167 GET t_cWid8 ;
	SPINNER 1.000, 1, 254 ;
	PICTURE "@K ###" ;
	SIZE 0.846, 5.000 ;
	DEFAULT 1.000 ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() ) ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 18.538,62.667 GET t_cField9 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 18.769,82.500 GET t_cWid9 ;
	SPINNER 1.000, 1, 254 ;
	PICTURE "@K ###" ;
	SIZE 0.846, 5.000 ;
	DEFAULT 1.000 ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() ) ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 20.538,3.333 GET t_cField10 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 20.769,23.167 GET t_cWid10 ;
	SPINNER 1.000, 1, 254 ;
	PICTURE "@K ###" ;
	SIZE 0.846, 5.000 ;
	DEFAULT 1.000 ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() ) ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 20.538,32.667 GET t_cField11 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 20.769,53.167 GET t_cWid11 ;
	SPINNER 1.000, 1, 254 ;
	PICTURE "@K ###" ;
	SIZE 0.846, 5.000 ;
	DEFAULT 1.000 ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() ) ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 20.538,62.667 GET t_cField12 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 20.769,82.500 GET t_cWid12 ;
	SPINNER 1.000, 1, 254 ;
	PICTURE "@K ###" ;
	SIZE 0.846, 5.000 ;
	DEFAULT 1.000 ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() ) ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 22.538,3.333 GET t_cField13 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 22.769,23.167 GET t_cWid13 ;
	SPINNER 1.000, 1, 254 ;
	PICTURE "@K ###" ;
	SIZE 0.846, 5.000 ;
	DEFAULT 1.000 ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() ) ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 22.538,32.667 GET t_cField14 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 22.769,53.167 GET t_cWid14 ;
	SPINNER 1.000, 1, 254 ;
	PICTURE "@K ###" ;
	SIZE 0.846, 5.000 ;
	DEFAULT 1.000 ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() ) ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 22.538,62.667 GET t_cField15 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 22.769,82.500 GET t_cWid15 ;
	SPINNER 1.000, 1, 254 ;
	PICTURE "@K ###" ;
	SIZE 0.846, 5.000 ;
	DEFAULT 1.000 ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() ) ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 24.538,3.333 GET t_cField16 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 24.769,23.167 GET t_cWid16 ;
	SPINNER 1.000, 1, 254 ;
	PICTURE "@K ###" ;
	SIZE 0.846, 5.000 ;
	DEFAULT 1.000 ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() ) ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 24.538,32.667 GET t_cField17 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 24.769,53.167 GET t_cWid17 ;
	SPINNER 1.000, 1, 254 ;
	PICTURE "@K ###" ;
	SIZE 0.846, 5.000 ;
	DEFAULT 1.000 ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() ) ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 24.538,62.667 GET t_cField18 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 24.769,82.500 GET t_cWid18 ;
	SPINNER 1.000, 1, 254 ;
	PICTURE "@K ###" ;
	SIZE 0.846, 5.000 ;
	DEFAULT 1.000 ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() ) ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 26.538,3.333 GET t_cField19 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 26.769,23.167 GET t_cWid19 ;
	SPINNER 1.000, 1, 254 ;
	PICTURE "@K ###" ;
	SIZE 0.846, 5.000 ;
	DEFAULT 1.000 ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() ) ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 26.538,32.667 GET t_cField20 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 26.769,53.167 GET t_cWid20 ;
	SPINNER 1.000, 1, 254 ;
	PICTURE "@K ###" ;
	SIZE 0.846, 5.000 ;
	DEFAULT 1.000 ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() ) ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 0.000,1.333 GET t_nBotBump ;
	PICTURE "@*IVN " ;
	SIZE 1.077,0.833,1.000 ;
	DEFAULT 0 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wBumper( OBJNUM(t_cDesc) )
@ 1.231,3.333 GET t_cOption ;
	PICTURE "@*BHN " + ;
		(LOCFILE("prev.bmp","BMP|ICO|PCT|ICN","Where is prev?")) + ";" + ;
		(LOCFILE("next.bmp","BMP|ICO|PCT|ICN","Where is next?")) + ";" + ;
		(LOCFILE("list.bmp","BMP|ICO|PCT|ICN","Where is list?")) + ";" + ;
		(LOCFILE("add.bmp","BMP|ICO|PCT|ICN","Where is add?")) + ";" + ;
		(LOCFILE("file.bmp","BMP|ICO|PCT|ICN","Where is file?")) + ";" + ;
		(LOCFILE("execute.bmp","BMP|ICO|PCT|ICN","Where is execute?")) + ";" + ;
		(LOCFILE("undo.bmp","BMP|ICO|PCT|ICN","Where is undo?")) + ";" + ;
		(LOCFILE("save.bmp","BMP|ICO|PCT|ICN","Where is save?")) + ";" + ;
		(LOCFILE("exit.bmp","BMP|ICO|PCT|ICN","Where is exit?")) ;
	SIZE 2.923,7.667,0.667 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	VALID ProcOption(t_cOption,.T.)


*       *********************************************************
*       *                                                         
*       *               ZZIMP/Windows Cleanup Code                
*       *                                                         
*       *********************************************************
*

#REGION 1
********************************************************************


*       *********************************************************
*       *                                                         
*       *   ZZIMP/Windows Supporting Procedures and Functions     
*       *                                                         
*       *********************************************************
*

#REGION 1
FUNCTION Imp_act
*++
* Task specific READ activation handler.
*--

  * Put up custom menu pad for this task window. The activate clause
  * may sometimes be called after the window is hidden during a close
  * operation, if a dialog box was activated by the form level
  * validation handler. The WVISIBLE() test makes sure we don't put
  * the menu back up in this case. The bMenuUp flag is used only for
  * optimization purposes - so we don't redefine the menu if it's
  * already there.
  IF WVISIBLE(m.t_cWindow) AND NOT bMenuUp
    DO zzImp.mpr
    bMenuUp = .T.
  ENDIF

  RETURN .T.


********************************************************************
FUNCTION Imp_deact
*++
* Task specific READ deactivation handler.
* This routine may be called by the READ command on a READ window
* deactivation, or explicitly by the wClearRead() function. That
* means we cannot depend on WLAST() or WONTOP() to be set right.
*--
  * Under FoxPro for Windows, Minimizing a window from the window
  * control box, or Choosing Next Window, bypasses the GET Valid
  * clause. This is our only chance to catch it, and thereby enforce
  * proper field validation.
  IF wCatchAll(m.t_cWindow)
    * Save last position of window
    m.t_nWinRow = WLROW(m.t_cWindow)
    m.t_nWinCol = WLCOL(m.t_cWindow)

    RELEASE PAD Import OF _MSYSMENU
    RELEASE POPUP Import
    bMenuUp = .F.
    RETURN .T.
  ELSE
    RETURN .F.
  ENDIF


********************************************************************
FUNCTION GET_valid
*++
* Common validation routine called when any field data is changed.
*
* This routine is responsible for:
*  1. Checking lock status of record, locking if needed.
*  2. Setting changes flag and setting buttons.
*
* Returns TRUE.
*  If data was changed and lock could not be established, data is
*  reset to initial value.
*--
PRIVATE xTemp

  IF NOT m.t_bchanges AND wChanged()
    IF NOT wLock(m.cTaskAlias, 'zzImp', RECNO('zzImp') )
      * Restore original field contents on Lock failure.
      DO wFldUndo

      * Return success, since user is warned, and changes undone.
      RETURN .T.
    ENDIF

    * Make sure any changes to record made since original
    * display are shown on screen when the record is locked.
    STORE EVALUATE( VARREAD() ) TO m.xTemp
    DO load_form
    STORE m.xTemp TO ( VARREAD() )
    DO show_form

    DO set_buttons WITH .T.
  ENDIF

  RETURN .T.


********************************************************************
PROCEDURE load_form
*++
* Load data from current record for display and/or edit.
*---
  SELECT zzImp

  * Don't stay at EOF if we can help it.
  IF EOF()
    GOTO BOTTOM

    * If still at EOF, perform implicit add record command.
    IF EOF()
      RETURN init_form()
    ENDIF
  ENDIF

  m.t_bAddNew = .F.
  DO set_buttons WITH .F.

  * Let all the other tasks know what record we have displayed.
  DO wListen WITH m.cTaskAlias, 'zzImp', RECNO('zzImp')

  * Load data from field variables into GET variable array.
  SCATTER TO t_aGETvars MEMO
  RETURN


********************************************************************
PROCEDURE init_form
*++
* Initialize internal memory for a new address record.
* Let format default to current setting on add.
*---
  m.t_bAddNew = .T.
  DO set_buttons WITH .T.

  SELECT zzImp
  SCATTER TO t_aGETvars MEMO BLANK

  * Move to first field to begin entry of new record.
  _CUROBJ = OBJNUM( t_cDesc )
  RETURN


********************************************************************
PROCEDURE show_form
*++
* Display current data and Enable/Disable fields as appropriate.
*---

  SHOW GETS WINDOW (m.t_cWindow) LEVEL wRdLevel()
  RETURN


********************************************************************
FUNCTION set_buttons
PARAMETER bChanges
*++
* Set changes flag, and update control buttons accordingly.
*--
PRIVATE nRecno

  IF m.bChanges
    SHOW GET t_cOption,7 ENABLE LEVEL wRdLevel()
    SHOW GET t_cOption,8 ENABLE LEVEL wRdLevel()
  ELSE
    SHOW GET t_cOption,7 DISABLE LEVEL wRdLevel()
    SHOW GET t_cOption,8 DISABLE LEVEL wRdLevel()
  ENDIF

  * The AddNEw flag will always be set if there are no records.
  IF t_bAddNew
    t_bAtTop = .T.
    t_bAtEnd = .T.
  ELSE
    nRecno = RECNO()
    SKIP -1
    t_bAtTop = BOF()
    GO nRecno

    SKIP 1
    t_bAtEnd = EOF()
    GO nRecno
  ENDIF

  * Set buttons according to current record
  IF m.t_bAtTop
    SHOW GET t_cOption,1 DISABLE LEVEL wRdLevel()
  ELSE
    SHOW GET t_cOption,1 ENABLE LEVEL wRdLevel()
  ENDIF

  IF m.t_bAtEnd
    SHOW GET t_cOption,2 DISABLE LEVEL wRdLevel()
  ELSE
    SHOW GET t_cOption,2 ENABLE LEVEL wRdLevel()
  ENDIF

  * Store new value of task level change flag and return it.
  m.t_bChanges = m.bChanges
  RETURN m.bChanges


********************************************************************
FUNCTION ProcOption
PARAMETER cOption, bInObject
*++
* Process menu and pushbutton options.
*--

* if choice is picture button, strip off ".BMP" from end
* make sure .bmp button file names match menu options!
m.cOption = STRTRAN(m.cOption,'.BMP','')
* identify file name, strip off path + back-slashes
m.cOption = SUBSTR(m.cOption,RAT('\',m.cOption)+1)


SELECT zzImp
m.cOption = UPPER( ALLTRIM(m.cOption) )

  IF  m.cOption = 'COPY'
    APPEND BLANK
    GATHER FROM t_aGETvars MEMO
    DO load_form
    DO show_form
    DO wUnlock WITH m.cTaskAlias
    WAIT 'Record Copied' Window NOWAIT
    RETURN .T.
  ENDIF

  DO CASE
    * First, handle the common task button options.
    CASE controls(cOption, bInObject)

    CASE m.cOption = 'FILE'
      DO ImpFile

    CASE m.cOption = 'EXECUTE'
      DO ImpExe

    CASE m.cOption = 'LIST'
      * Launch an independant BROWSE window, linked to ours.
      DO wLaunch WITH 'ImpList IN zzImp'

  ENDCASE

  RETURN .T.


********************************************************************
PROCEDURE Implist
PARAMETER cEvent, cTaskAlias
*++
* This BROWSE task is designed to work together with the
* import update task window.
*
* Parameters from wLaunch are ignored for BROWSE tasks, since
* once they are started, we never get control of them again.
*--
  SELECT zzImp

  * Define a window for Browse to pattern itself after. Specify font
  * so size will be consistent even if Main Window font changes.
  DEFINE WINDOW bwin AT 1,1 SIZE 11,75 ;
                        FONT 'MS Sans Serif',8 STYLE 'B' ;
                        FLOAT SHADOW CLOSE MINIMIZE ZOOM ;
                        SYSTEM GROW COLOR SCHEME 8
  MOVE WINDOW bwin CENTER

  * Activate the BROWSE window. The WHEN clause calls zzImp.prg
  * with the event string 'UPDATE-n' where n is the new
  * record number to display in the window.
  BROWSE NOWAIT REST NOMENU NOMODIFY ;
         WINDOW bwin TITLE 'Import_List' ;
         FIELDS Desc,File,Type,Delim,Field1,Field2,Field3,Field4 ;
         WHEN EVALUATE( 'zzImp' ;
                + '("UPDATE-' + ALLTRIM(STR(RECNO())) ;
                + '", "1_ZZIMP")' )

  RELEASE WINDOW bwin
  RETURN


********************************************************************
FUNCTION save_form
PARAMETER cMsgTxt
*++
* Validate complete form as a whole, and save changes. If cMsgTxt
* contains a string, use it to ask whether or not user wants to
* save changes.
*--
PRIVATE nBadField, cReason, cAnswer

  SELECT zzImp
  STORE '' TO m.cReason

  IF m.t_bChanges
    m.cAnswer = IIF(EMPTY(m.cMsgTxt), 'YES', zzQuest(m.t_cWindow, ;
        'Do you want to save this import description ' ;
        + 'before ' + m.cMsgTxt + '?' ) )

    * Return failure immediately if user cancels.
    IF m.cAnswer = 'CANCEL'
      RETURN .F.
    ENDIF

    * Save the changes if we are supposed to.
    IF m.cAnswer = 'YES'
      * Make sure all required fields have been entered.
      * none as of 9/94 pds
      DO CASE
       CASE EMPTY(t_cDesc)
         m.cReason = 'A description is required'
         m.nBadField = OBJNUM(t_cDesc)

       CASE EMPTY(t_cFile)
         m.cReason = 'A file name is required'
         m.nBadField = OBJNUM(t_cFile)

      ENDCASE

      IF NOT EMPTY(m.cReason)
        DO zzWarn WITH m.t_cWindow, m.cReason

        * This routine may be called when no GETs are issued (like
        * during Global shutdown). OBJNUM() returns 0 in this case.
        _CUROBJ = nBadField
        RETURN .F.
      ENDIF

      * Add a new record to the database when needed.
      IF m.t_bAddNew
        * Create new record
        APPEND BLANK
        m.t_bAddNew = .F.
      ENDIF

      GATHER FROM t_aGETvars MEMO
      DO set_buttons WITH .F.
    ELSE
      * User said 'dont save', so reload from disk.
      DO load_form
      DO show_form
    ENDIF

    * Whether changes saved or discarded, release the locks.
    DO wUnlock WITH m.cTaskAlias

  ENDIF

  RETURN .T.


* EOF - save_form
********************************************************************
FUNCTION ImpExe
* Execute Import
* Create file containing zzMast.dbf field names
* in the order that matches the import text file
*

IF EMPTY(t_cFile)
  WAIT 'You must enter an Import file NAME first, Press <Enter>' WINDOW
  RETURN
ENDIF
IF EMPTY(t_cType)
  WAIT 'You must enter an Import file TYPE first, Press <Enter>' WINDOW
  RETURN
ENDIF

IF EMPTY(t_cField1)
  WAIT 'The first import field must be filled in, Press <Enter>' WINDOW
  RETURN
ENDIF

*****
IF zzCntnue('Do you want to PREVIEW import records?')
  * Continue
ELSE
  RETURN
ENDIF

DEFINE WINDOW Impt ;
  AT 4,7 ;
  SIZE 10,80 ;
  TITLE  'Record Import' ;
  FONT 'Times New Roman', 10 ;
  STYLE 'B' ;
  FLOAT ;
  CLOSE ;
  NOMINIMIZE ;
  DOUBLE
MOVE WINDOW Impt CENTER
ACTIVATE WINDOW Impt

@  1, 1 SAY 'Creating Import file'

ImpFile  = UPPER(ALLTRIM(t_cFile))
ImpType  = UPPER(ALLTRIM(t_cType))
ImpDlm   = t_cDelim

* Create empty structure file
* to fill with fields from screen
COPY STRUCTURE EXTENDED TO ImpStru
IF NOT USED('ImpStru')
  * Use AGAIN in case another task, or BROWSE, has file open
  * under a different alias name.
  USE (LOCFILE('ImpStru','DBF','Where is the Import Structure file?'));
      IN 0 AGAIN ALIAS ImpStru
ENDIF
SELECT ImpStru
ZAP

* Create records in impstru, one for each field needed
* in test import file (TestImp.DBF) that matches zzmast.dbf

DO Add1Fld WITH t_cField1,t_cWid1
DO Add1Fld WITH t_cField2,t_cWid1
DO Add1Fld WITH t_cField3,t_cWid1
DO Add1Fld WITH t_cField4,t_cWid1
DO Add1Fld WITH t_cField5,t_cWid1
DO Add1Fld WITH t_cField6,t_cWid1
DO Add1Fld WITH t_cField7,t_cWid1
DO Add1Fld WITH t_cField8,t_cWid1
DO Add1Fld WITH t_cField9,t_cWid1
DO Add1Fld WITH t_cField10,t_cWid1
DO Add1Fld WITH t_cField11,t_cWid1
DO Add1Fld WITH t_cField12,t_cWid1
DO Add1Fld WITH t_cField13,t_cWid1
DO Add1Fld WITH t_cField14,t_cWid1
DO Add1Fld WITH t_cField15,t_cWid1
DO Add1Fld WITH t_cField16,t_cWid1
DO Add1Fld WITH t_cField17,t_cWid1
DO Add1Fld WITH t_cField18,t_cWid1
DO Add1Fld WITH t_cField19,t_cWid1
DO Add1Fld WITH t_cField20,t_cWid1

* Add required field "Rec_Key" to structure file
APPEND BLANK
REPLACE Field_Name WITH 'REC_KEY', ;
        Field_Type WITH 'C', ;
        Field_Len  WITH 20, ;
        Field_Dec  WITH 0

* Add required field "Entered" to structure file
APPEND BLANK
REPLACE Field_Name WITH 'ENTERED', ;
        Field_Type WITH 'D', ;
        Field_Len  WITH 8, ;
        Field_Dec  WITH 0

USE

CREATE zzTest FROM ImpStru

IF NOT USED('zzTest')
  * Use AGAIN in case another task, or BROWSE, has file open
  * under a different alias name.
  USE (LOCFILE('zzTest','DBF','Where is the Test Import file?'));
      IN 0 AGAIN ALIAS zzTest
ENDIF
SELECT zzTest

SET TALK ON
SET ODOM TO 10

DO CASE

CASE ImpType = 'FOXPRO'
  APPEND FROM &ImpFile

CASE ImpType = 'DELIM'
  IF EMPTY(ImpDlm)
    APPEND FROM &ImpFile DELIMITED
  ELSE
    APPEND FROM &ImpFile DELIMITED WITH &ImpDlm
  ENDIF

OTHERWISE
    APPEND FROM &ImpFile TYPE &ImpType

ENDCASE

@  0, 0 CLEAR

* generate unique record key that will not interfere with
* SalesBridge generated record keys,
* ( which start with DTOS(DATE())..... )
REPLACE ALL rec_key WITH 'Imp' + ALLTRIM(STR(RECNO()))+ SUBSTR(fname,1,4)
REPLACE ALL ENTERED WITH DATE()

SET TALK OFF
SET ODOM TO 100

@  0, 0 CLEAR

DEACTIVATE WINDOW Impt

DEFINE WINDOW tBrow ;
  AT 4,7 ;
  SIZE 20,80 ;
  TITLE  'Test Browse - Close Window To Continue' ;
  FONT 'Times New Roman', 10 ;
  STYLE 'B' ;
  FLOAT ;
  CLOSE ;
  NOMINIMIZE ;
  DOUBLE
MOVE WINDOW tBrow CENTER
ACTIVATE WINDOW tBrow

brow

@ 1, 1 SAY 'Records ready for import......'

IF zzCntnue('Do you want to IMPORT records into your file?')
  * Continue
ELSE
  USE
  DEACTIVATE WINDOW tBrow
  RETURN
ENDIF

USE

IF NOT USED(_mastfile)
  * Use AGAIN in case another task, or BROWSE, has file open
  * under a different alias name.
  USE (LOCFILE(_mastfile,'DBF','Where is the Customer file?'));
      IN 0 AGAIN ALIAS &_mastfile
ENDIF
SELECT &_mastfile
SET INDEX TO &_MastNdx
SET ORDER TO 0

@  0, 0 CLEAR

SET TALK ON
SET ODOM TO 10

APPEND FROM zzTest

SET TALK OFF
SET ODOM TO 100

@  0, 0 CLEAR

WAIT 'Import finished ' WINDOW TIMEOUT 2

DEACTIVATE WINDOW tBrow

RETURN

* EOF - ImpExe
*******************************************************************
PROCEDURE Add1Fld
PARAMETERS ImpFld, ImpLen
* Get proper .dbf field name from user entered "english" field name
* array _zzSMast contains each field in zzmast.dbf + the UDF name, length
* field type and decimals
*
* Fields in _zzSMast array are
* 1) field_name
* 2) fldlabel
* 3) field_type
* 4) field_len
* 5) field_dec
*

IF UPPER(ALLTRIM(ImpFld)) = 'ALL' OR EMPTY(ImpFld)
  RETURN ' '
ENDIF

* Trim user entered field name value, get length of field
UsrFld   = ALLTRIM(ImpFld)
UsrLen   = ImpLen

* Find UDF field description in structure array
mPos = ASCAN(_zzsmast,UsrFld)
mSub   = ASUBSCRIPT(_zzsmast,mPos,1)

* get DBF field name
ImpFld = ALLTRIM(_zzsmast(mSub,2)) && the dbf field name

* get DBF field type
ImpTyp = ALLTRIM(_zzsmast(mSub,3)) && the dbf field type

* get DBF field Length
IF UsrLen = 0
  ImpLen = _zzsmast(mSub,4) && the dbf field Length
ENDIF

* get DBF field Decimals
ImpDec = _zzsmast(mSub,5) && the dbf field Decimals

APPEND BLANK

REPLACE Field_Name WITH ImpFld, ;
        Field_Type WITH ImpTyp, ;
        Field_Len  WITH ImpLen, ;
        Field_Dec  WITH ImpDec

RETURN

* EOF - Add1Fld
*******************************************************************
PROCEDURE ImpFile
* Text file viewing window - once started, it behaves like
* a Desk Accessory.
*

MODI FILE t_cFile NOEDIT NOWAIT

WAIT 'CLOSE the file window BEFORE Import records!!!!!' WINDOW TIMEOUT 4

RETURN

* EOF - ImpFile
********************************************************************
********************************************************************
********************************************************************
* EOF - zzImp.prg