*:*********************************************************************
*:
*: Procedure file: C:\FOX2\ZZ\ZZINIT.PRG
*:
*:         System: SalesBridge Customer Database System
*:         Author: Patrick Smith
*:      Copyright (c) 1989-1995, Patrick Smith
*:*********************************************************************
*
***************************************************************************
PROCEDURE init
* Initialize global vars, printer, color(not used yet), modem and other settings
*

*************************************************************
* Allocate and initialize system wide PUBLIC variables. This
* routine must be called once, before any other.
*

SET BELL OFF
SET EXACT OFF
CLEAR GETS

* Enable refresh of BROWSE windows
SET REFRESH TO 30

PUBLIC _nMaxWind, _nCurObj, _nBrow, _nBcol
PUBLIC _cObjType, _xInitial, _cLaunchMe, _cActivate
m._cActivate = ''       && Window to activate next
m._cLaunchMe = ''       && Task program to Launch next
m._nMaxWind = 0
m._nBrow = 5            && Initial Row & Col of browse windows
m._nBcol = 5
m._xInitial = ''        && check for edit field changes

* Allocate and initialize variables for manually implimented
* READ and GET clauses.
PUBLIC _cGetValid, _cDeactExp, _cFrmValid, _cFldValid
m._cFldValid = '.T.'    && Field specific GET valid expr.
m._cDeactExp = '.T.'    && READ deactivate expression.
m._cFrmValid = '.T.'    && Form level valid expression.
m._cGetValid = '.T.'    && Common GET valid expression.

* memvars for task programs
PUBLIC t_bAddNew,t_bChanges,t_bAtTop,T_bAtEnd
m.t_bAddNew  = .F. && Set true if adding new record
m.t_bChanges = .F. && Changes have been made flag.
m.t_bAtTop   = .F. && Beginning of file flag
m.t_bAtEnd   = .F.  && End of file flag

* Global flags and preferences
PUBLIC _bBeep, _bShutdown, _bQuitFox
PUBLIC _bRIP, _bMouse, _bInModal, _bforcenew
m._bBeep     = .T.      && Beep on errors preference flag
m._bShutdown = .F.      && Global shutdown request flag
m._bQuitFox  = .F.      && Quit on exit (FPW is shuting down)
m._bforcenew = .F.      && Request new instance on launch
m._bRIP      = .F.      && Read-In-Progress flag
m._bInModal  = .F.      && Set when WONTOP() is modal

* Window and context saving arrays
PUBLIC _aBrowse[1,2]
PUBLIC _aLocks[1,3]
PUBLIC _aListen[1,3]
PUBLIC _aWindows[1,3]
STORE '' TO _aLocks, _aListen, _aWindows, _aBrowse

PUBLIC _BrowStr
m._BrowStr = 'Lname'    && zzmast.dbf browse fields string

PUBLIC x_Choice
x_Choice = 3           && flag used in zz.prg to exit zz.prg

* Establish shutdown handler
ON SHUTDOWN DO _wSysShut

*

CLOSE DATA


*--------
SET DEBUG OFF
SET TALK OFF
SET ECHO OFF
SET ESCAPE  OFF                         && esc can't cancel, use Ctrl-S to suspend program
*SET ESCAPE  ON                         && esc can cancel, (use for testing)
SET CURSOR  ON
SET DELETED ON                          && don't display deleted records
SET HELP    OFF                         && no FOX help from F1
SET SAFETY  OFF                         && no FOX warnings (overwrite existing file...etc.)

ON ERROR DO zzError WITH ERROR(),MESSAGE(),PROGRAM(),MESSAGE(1),LINENO(1)

CLEAR WINDOWS
SET COLOR TO
@  0, 0 CLEAR

SET MESSAGE TO 24 CENTER

color_mon = ISCOLOR()

* initialization of global variables
* from master settings data file (zzdata.dbf)
DO zzInitx

* init zzmast.dbf search index labels and get fields
* also check for and missing indexes for other datbases
* all indexes taken from zzdbfs.dbf

DO mastinit

* Quick Edit window memvars
DO QInit WITH .T.

* modem initialization, not used as of 11/94 pds
*DO modminit                             

* set up initial filter settings
PUBLIC _Filt, _FiltDesc

DO FltReset IN zzFilt

RETURN

* EOF - Init
***************************************************************************
PROCEDURE zzInitx
* Open zzdata.dbf, get global program settings
*

IF NOT USED('zzData')
  USE (LOCFILE('zzData','DBF','Where is ZZDATA.DBF?'));
      IN 0 AGAIN ALIAS zzData
ENDIF

* saved wallpaper setting, zz.prg Re-start flag, vert/horz scn res
PUBLIC _SvWall, _ReStart,_Vert,_Horz
_SvWall  = ' '
_ReStart = .F.
* Vertical/Horizontal size of the window in pixels,
_Vert    = WROWS()* FONTMETRIC(1, WFONT(1),WFONT(2), WFONT(3))
_Horz    = WCOLS() * FONTMETRIC(6, WFONT(1),WFONT(2), WFONT(3))

PUBLIC _Wall, _Title, _SerNum, _Pprotect
PUBLIC _cHlpFile, _TopicNo, _WkDir, _MastFile
_Wall     = ALLTRIM(Wall)       && .bmp file for wallpaper
_Title    = ALLTRIM(Title)      && title displayed at top 
_SerNum   = ALLTRIM(SerNum)     && program serial number
_PProtect = P                   && ? password protected access (y/n)
_cHlpFile = ALLTRIM(HlpFile)    && windows help file
_TopicNo  = TopicNo             && default help topic, 'Table of contents'
_WkDir    = ALLTRIM(WkDir)      && work files directory *.mem and/or others
_MastFile = ALLTRIM(MastFile)   && customer master dbf file

DO Wall WITH 37,100 IN zzproc   && display wallpaper

* set up foxtools library to access help file
SET LIBRARY TO SYS(2004) + 'foxtools.fll' ADDITIVE
PUBLIC _nWinHelp
_nWinHelp = REGFN('WinHelp','LCIL','I')

USE

IF .NOT. pw_entrd()                     && prompt for password
    m._bShutdown = .t.
    RETURN
ENDIF

* Get master list browse fields
IF NOT USED('zzBrow')
  USE (LOCFILE('zzBrow','DBF','Where is zzBrow.dbf?'));
      IN 0 AGAIN ALIAS zzBrow
ENDIF
SELECT zzBrow

PUBLIC m._BrowStr
m._BrowStr = zzBrow.BrowStr

USE

* Get Master .DBF field Structure array
* used in fields where a list of "english" fields is needed

* first get array in UDF field name order
IF NOT USED('zzSMast')
  * Use AGAIN in case another task, or BROWSE, has file open
  * under a different alias name.
  USE (LOCFILE('zzSMast','DBF','Where is the Structure file?'));
      IN 0 AGAIN ALIAS zzSMast
ENDIF
SELECT zzSMast
* create array to hold master file structure
m.Count = RECC()
PUBLIC ARRAY _zzSMast[m.Count,7]
COPY TO ARRAY _zzSMast ;
     FIELDS fldlabel,field_name,field_type, ;
       field_len,field_dec,field_pos,field_pic
*      FOR Ok2Filt
m.Count = _tally
* increase size of array
DIMENSION _zzSMast[m.Count+1,7]
* Insert blank element so users can blank out field
= AINS(_zzSMast, m.Count+1)
_zzSMast[m.Count+1,1] = space(20)
* Sort fields in alpha order
=ASORT(_zzSMast,1)

* Next... get array in DBF field name order
SELECT zzSMast
* create array to hold master file structure
PUBLIC ARRAY _zzSMast2[m.Count,7]
COPY TO ARRAY _zzSMast2 ;
     FIELDS field_name,fldlabel,field_type, ;
       field_len,field_dec,field_pos,field_pic
*      FOR Ok2Filt
m.Count = _tally
* increase size of array
DIMENSION _zzSMast2[m.Count+1,7]
* Insert blank element so users can blank out field
= AINS(_zzSMast2, m.Count+1)
_zzSMast2[m.Count+1,1] = space(20)
* Sort fields in alpha order
=ASORT(_zzSMast2,1)

* Then, .... get array for filter list
IF NOT USED('zzFilt')
  * Use AGAIN in case another task, or BROWSE, has file open
  * under a different alias name.
  USE (LOCFILE('zzFilt','DBF','Where is the Filter file?'));
      IN 0 AGAIN ALIAS zzFilt
ENDIF
SELECT zzFilt
SET INDEX TO zzFilt
SET ORDER TO 1

* create array to hold filter list
m.Count = RECC()
PUBLIC ARRAY _zzFilt[m.count,1]

COPY TO ARRAY _zzFilt ;
     FIELDS Desc

m.count = _tally
* increase size of array
DIMENSION _zzFilt[m.count+1,1]
* Insert blank element so users can blank out field
= AINS(_zzFilt, m.count+1)
_zzFilt[m.count+1,1] = space(20)
* Sort fields in alpha order
=ASORT(_zzFilt,1)

USE

RETURN

* EOF - zzInit
**********************************************************************
PROCEDURE mastinit
PARAMETERS Ok2Ndx,Ok2Pack
* Get master list search indexes and lookup fields
* Also, set up indexes for all databases referenced
* in zzDbfs.dbf

DEFINE WINDOW mastinit ;
  AT 4,7 ;
  SIZE 6,70 ;
  TITLE  'SalesBridge Database Initialization' ;
  FONT 'Times New Roman', 10 ;
  STYLE 'B' ;
  FLOAT ;
  CLOSE ;
  NOMINIMIZE ;
  DOUBLE
MOVE WINDOW mastinit CENTER
ACTIVATE WINDOW mastinit

IF Ok2Pack
  IF zzCntnue('Do you want to REMOVE deleted customer records?')
    * Continue
  ELSE
    DEACTIVATE WINDOW mastinit
    RETURN
  ENDIF
ENDIF
IF Ok2Ndx
  IF zzCntnue('Do you want to REBUILD customer indexes?')
    * Continue
  ELSE
    DEACTIVATE WINDOW mastinit
    RETURN
  ENDIF
ENDIF

CLOSE DATA

IF Ok2Pack OR Ok2Ndx
  USE (LOCFILE(_MastFile,'DBF','Where is the Customer master .dbf?'));
      IN 0 EXCLUSIVE ALIAS &_MastFile
ELSE
  USE (LOCFILE(_MastFile,'DBF','Where is the Customer master .dbf?'));
      IN 0 SHARED ALIAS &_MastFile
ENDIF
SELECT &_MastFile

@ 2, 1 SAY 'Initializing Customer File'

IF Ok2Pack
  SET TALK ON
  PACK
  SET TALK OFF
  @ 0, 0 CLEAR
ENDIF

IF Ok2Ndx
  ERASE zz1.idx
  ERASE zz2.idx
  ERASE zz3.idx
  ERASE zz4.idx
  ERASE zz5.idx
  ERASE zz6.idx
  ERASE zz7.idx
  ERASE zz8.idx
  ERASE zz9.idx
  ERASE zz10.idx
  ERASE zz11.idx
  ERASE zz12.idx
ENDIF

IF NOT USED('zzNdx')
  USE (LOCFILE('zzndx','DBF','Where is zzNdx.dbf?'));
      IN 0 AGAIN ALIAS zzNdx
ENDIF
SELECT zzNdx
SET FILTER TO MastNdx
* if you want more than one master dbf
* choose the following "SET FILTER"
*SET FILTER TO DBF = UPPER(_MastFile)
GO TOP


RELEASE _aTags
PUBLIC _aTags[12]
_aTags = ''

PUBLIC m._Find1,m._Find2,m._Find3,m._Find4,m._Find5, ;
       m._Find6,m._Find7,m._Find8,m._Find9,m._Find10,m._Find11,m._Find12
PUBLIC m._FPic1,m._FPic2,m._FPic3,m._FPic4,m._FPic5, ;
       m._FPic6,m._FPic7,m._FPic8,m._FPic9,m._FPic10,m._FPic11,m._FPic12

* Skip through the index file
* to get "Find" fields for each of 12 indexes
* Create index if not found

** Index 1
DO CASE
CASE SrchType = 'D'
  m._Find1 = DATE()
CASE SrchType = 'N'
  m._Find1 = 0
CASE SrchType = 'C'
  m._Find1 = SPACE(12)
ENDCASE
_aTags[1] = NdxLbl
m._FPic1 = SrchPic

IF .NOT. FILE(ALLTRIM(Ndx)+'.IDX')
  DO Ndx1Mast   && create one master index
ENDIF
SKIP

** Index 2
DO CASE
CASE SrchType = 'D'
  m._Find2 = DATE()
CASE SrchType = 'N'
  m._Find2 = 0
CASE SrchType = 'C'
  m._Find2 = SPACE(12)
ENDCASE
_aTags[2] = NdxLbl
m._FPic2 = SrchPic

IF .NOT. FILE(ALLTRIM(Ndx)+'.IDX')
  DO Ndx1Mast   && create one master index
ENDIF
SKIP

** Index 3
DO CASE
CASE SrchType = 'D'
  m._Find3 = DATE()
CASE SrchType = 'N'
  m._Find3 = 0
CASE SrchType = 'C'
  m._Find3 = SPACE(12)
ENDCASE
_aTags[3] = NdxLbl
m._FPic3 = SrchPic

IF .NOT. FILE(ALLTRIM(Ndx)+'.IDX')
  DO Ndx1Mast   && create one master index
ENDIF
SKIP

** Index 4
DO CASE
CASE SrchType = 'D'
  m._Find4 = DATE()
CASE SrchType = 'N'
  m._Find4 = 0
CASE SrchType = 'C'
  m._Find4 = SPACE(12)
ENDCASE
_aTags[4] = NdxLbl
m._FPic4 = SrchPic

IF .NOT. FILE(ALLTRIM(Ndx)+'.IDX')
  DO Ndx1Mast   && create one master index
ENDIF
SKIP

** Index 5
DO CASE
CASE SrchType = 'D'
  m._Find5 = DATE()
CASE SrchType = 'N'
  m._Find5 = 0
CASE SrchType = 'C'
  m._Find5 = SPACE(12)
ENDCASE
_aTags[5] = NdxLbl
m._FPic5 = SrchPic

IF .NOT. FILE(ALLTRIM(Ndx)+'.IDX')
  DO Ndx1Mast   && create one master index
ENDIF
SKIP

** Index 6
DO CASE
CASE SrchType = 'D'
  m._Find6 = DATE()
CASE SrchType = 'N'
  m._Find6 = 0
CASE SrchType = 'C'
  m._Find6 = SPACE(12)
ENDCASE
_aTags[6] = NdxLbl
m._FPic6 = SrchPic

IF .NOT. FILE(ALLTRIM(Ndx)+'.IDX')
  DO ndx1mast   && create one master index
ENDIF
SKIP

** Index 7
DO CASE
CASE SrchType = 'D'
  m._Find7 = DATE()
CASE SrchType = 'N'
  m._Find7 = 0
CASE SrchType = 'C'
  m._Find7 = SPACE(12)
ENDCASE
_aTags[7] = NdxLbl
m._FPic7 = SrchPic

IF .NOT. FILE(ALLTRIM(Ndx)+'.IDX')
  DO Ndx1Mast   && create one master index
ENDIF
SKIP

** Index 8
DO CASE
CASE SrchType = 'D'
  m._Find8 = DATE()
CASE SrchType = 'N'
  m._Find8 = 0
CASE SrchType = 'C'
  m._Find8 = SPACE(12)
ENDCASE
_aTags[8] = NdxLbl
m._FPic8 = SrchPic

IF .NOT. FILE(ALLTRIM(Ndx)+'.IDX')
  DO ndx1mast   && create one master index
ENDIF
SKIP

** Index 9
DO CASE
CASE SrchType = 'D'
  m._Find9 = DATE()
CASE SrchType = 'N'
  m._Find9 = 0
CASE SrchType = 'C'
  m._Find9 = SPACE(12)
ENDCASE
_aTags[9] = NdxLbl
m._FPic9 = SrchPic

IF .NOT. FILE(ALLTRIM(Ndx)+'.IDX')
  DO Ndx1Mast   && create one master index
ENDIF
SKIP

** Index 10
DO CASE
CASE SrchType = 'D'
  m._Find10 = DATE()
CASE SrchType = 'N'
  m._Find10 = 0
CASE SrchType = 'C'
  m._Find10 = SPACE(12)
ENDCASE
_aTags[10] = NdxLbl
m._FPic10 = SrchPic

IF .NOT. FILE(ALLTRIM(Ndx)+'.IDX')
  DO Ndx1Mast   && create one master index
ENDIF
SKIP

** Index 11
DO CASE
CASE SrchType = 'D'
  m._Find11 = DATE()
CASE SrchType = 'N'
  m._Find11 = 0
CASE SrchType = 'C'
  m._Find11 = SPACE(12)
ENDCASE
_aTags[11] = NdxLbl
m._FPic11 = SrchPic

IF .NOT. FILE(ALLTRIM(Ndx)+'.IDX')
  DO Ndx1Mast   && create one master index
ENDIF
SKIP

** Index 12
DO CASE
CASE SrchType = 'D'
  m._Find12 = DATE()
CASE SrchType = 'N'
  m._Find12 = 0
CASE SrchType = 'C'
  m._Find12 = SPACE(12)
ENDCASE
_aTags[12] = NdxLbl
m._FPic12 = SrchPic

IF .NOT. FILE(ALLTRIM(Ndx)+'.IDX')
  DO Ndx1Mast   && create one master index
ENDIF

SELECT zzNdx
USE

IF Ok2Pack OR Ok2Ndx
  SELECT &_MastFile
  USE
  USE (LOCFILE(_MastFile,'DBF','Where is the Customer master .dbf?'));
      IN 0 SHARED ALIAS &_MastFile
ENDIF

SELECT &_MastFile
* Master file indexes
PUBLIC _MastNdx
_MastNdx = 'zz1,zz2,zz3,zz4,zz5,zz6,zz7,zz8,zz9,zz10,zz11,zz12'
SET INDEX TO &_MastNdx
GO TOP

DEACTIVATE WINDOW mastinit

RETURN

* EOF - MastInit
************************************************************************
PROCEDURE Ndx1Mast 
* Create one master file (zzmast.dbf) index
*

@ 0, 0 CLEAR
@ 1, 1 SAY  'Indexing ' + ALLTRIM(NdxLbl) ;
      + ' for ' + ALLTRIM(STR(RECC())) + ' records now...'
TempKey = ALLTRIM(NdxKey)
TempNdx = ALLTRIM(Ndx)

@ 3, 1
SET TALK ON
SELECT &_MastFile
INDEX ON &tempkey TO &TempNdx COMPACT
SELECT zzNdx

SET TALK OFF
@  0, 0 CLEAR

RETURN

* - EOF - Ndx1Mast 
*!*********************************************************************
*!
*!      Procedure: MODMINIT
*!
*!      Called by: MODEMSET           (procedure in ZZMAINT.PRG)
*!               : INIT               (procedure in ZZINIT.PRG)
*!
*!   Memory Files: ZZMODEM.MEM
*!
*!*********************************************************************
PROCEDURE modminit
* Initialize/re-initialize modem settings & usage
* Not used, save for future use, pds 11/94

PUBLIC mdm_used, mdm_torp, mdm_com, mdm_9, mdm_sound, ;
   mdm_area, mdm_access, mdm_init, mdm_hang, mdm_time

** either use previously saved configuration or create defaults now
IF FILE('zzModem.mem')
   RESTORE FROM zzModem.mem ADDITIVE
ELSE
   gmdmused  = .F.                        && modem is (default) NOT currently used
   gmdm_com  = 'COM1'                     && modem comm port
   gmdm_9    = .F.                        && do NOT dial a "9" (to exit to a dial ton
   gmdmtorp  = [T]                        && modem comm port to use
   gmdm_sond = [0]                        && set sound loudness to 1. (Range is 0 - 3
   gmdm_area = SPACE(3)                   && area code starts as blank
   gmdm_acc  = SPACE(20)                  && save 20 spaces for user to enter an acce
   gmdm_init = PADR([ATZ],40,' ')         && save 40 spaces for modem init string to
   gmdm_hang = PADR([ATH],40,' ')         && save 40 spaces for modem hang-up string
   gmdm_time = 0.1                        && delay to use between commands, to allow
   * now create/save to memfile...
   SAVE ALL LIKE gmdm* TO zzmodem.mem
ENDIF

mdm_used   = gmdmused
mdm_torp   = gmdmtorp
mdm_9      = gmdm_9
mdm_com    = gmdm_com
mdm_sound  = gmdm_sond
mdm_area   = gmdm_area
mdm_access = TRIM(gmdm_acc)
mdm_init   = TRIM(gmdm_init) + SPACE(40)
mdm_hang   = TRIM(gmdm_hang) + SPACE(40)
mdm_time   = gmdm_time

RELEASE ALL LIKE gmdm*                  && save memory space...

RETURN

* EOF -  modminit
*******************************************************************************
PROCEDURE QInit
PARAMETERS Ok2Open
* Initialize quick edit window memvars
*

IF Ok2Open
  * Init quick edit memvars
  IF NOT USED('zzQ')
    USE (LOCFILE('zzQ','DBF','Where is zzq.dbf?'));
        IN 0 AGAIN ALIAS zzQ
  ENDIF
ENDIF

SELECT zzQ

PUBLIC _QLbl1,_QLbl2,_QLbl3,_QLbl4,_QLbl5
PUBLIC _QLbl6,_QLbl7,_QLbl8,_QLbl9,_QLbl10
PUBLIC _QLbl11,_QLbl12,_QLbl13,_QLbl14,_QLbl15
PUBLIC _QLbl16,_QLbl17,_QLbl18,_QLbl19,_QLbl20,_QLbl21

PUBLIC _QVar1,_QVar2,_QVar3,_QVar4,_QVar5
PUBLIC _QVar6,_QVar7,_QVar8,_QVar9,_QVar10
PUBLIC _QVar11,_QVar12,_QVar13,_QVar14,_QVar15
PUBLIC _QVar16,_QVar17,_QVar18,_QVar19,_QVar20,_QVar21

PUBLIC _QPic1,_QPic2,_QPic3,_QPic4,_QPic5
PUBLIC _QPic6,_QPic7,_QPic8,_QPic9,_QPic10
PUBLIC _QPic11,_QPic12,_QPic13,_QPic14,_QPic15
PUBLIC _QPic16,_QPic17,_QPic18,_QPic19,_QPic20,_QPic21

_QLbl1  = QLbl1
_QLbl2  = QLbl2
_QLbl3  = QLbl3
_QLbl4  = QLbl4
_QLbl5  = QLbl5
_QLbl6  = QLbl6
_QLbl7  = QLbl7
_QLbl8  = QLbl8
_QLbl9  = QLbl9
_QLbl10 = QLbl10
_QLbl11 = QLbl11
_QLbl12 = QLbl12
_QLbl13 = QLbl13
_QLbl14 = QLbl14
_QLbl15 = QLbl15
_QLbl16 = QLbl16
_QLbl17 = QLbl17
_QLbl18 = QLbl18
_QLbl19 = QLbl19
_QLbl20 = QLbl20
_QLbl21 = QLbl21

_QVar1  = ALLTRIM(QVar1)
_QVar2  = ALLTRIM(QVar2)
_QVar3  = ALLTRIM(QVar3)
_QVar4  = ALLTRIM(QVar4)
_QVar5  = ALLTRIM(QVar5)
_QVar6  = ALLTRIM(QVar6)
_QVar7  = ALLTRIM(QVar7)
_QVar8  = ALLTRIM(QVar8)
_QVar9  = ALLTRIM(QVar9)
_QVar10 = ALLTRIM(QVar10)
_QVar11 = ALLTRIM(QVar11)
_QVar12 = ALLTRIM(QVar12)
_QVar13 = ALLTRIM(QVar13)
_QVar14 = ALLTRIM(QVar14)
_QVar15 = ALLTRIM(QVar15)
_QVar16 = ALLTRIM(QVar16)
_QVar17 = ALLTRIM(QVar17)
_QVar18 = ALLTRIM(QVar18)
_QVar19 = ALLTRIM(QVar19)
_QVar20 = ALLTRIM(QVar20)
_QVar21 = ALLTRIM(QVar21)

_QPic1  = ALLTRIM(QPic1)
_QPic2  = ALLTRIM(QPic2)
_QPic3  = ALLTRIM(QPic3)
_QPic4  = ALLTRIM(QPic4)
_QPic5  = ALLTRIM(QPic5)
_QPic6  = ALLTRIM(QPic6)
_QPic7  = ALLTRIM(QPic7)
_QPic8  = ALLTRIM(QPic8)
_QPic9  = ALLTRIM(QPic9)
_QPic10 = ALLTRIM(QPic10)
_QPic11 = ALLTRIM(QPic11)
_QPic12 = ALLTRIM(QPic12)
_QPic13 = ALLTRIM(QPic13)
_QPic14 = ALLTRIM(QPic14)
_QPic15 = ALLTRIM(QPic15)
_QPic16 = ALLTRIM(QPic16)
_QPic17 = ALLTRIM(QPic17)
_QPic18 = ALLTRIM(QPic18)
_QPic19 = ALLTRIM(QPic19)
_QPic20 = ALLTRIM(QPic20)
_QPic21 = ALLTRIM(QPic21)

IF Ok2Open
  USE
ENDIF

RETURN

* EOF - QInit
*******************************************************************************
*******************************************************************************
*******************************************************************************
* EOF - ZZINIT.PRG
