*       *********************************************************
*       *                                                         
*       * 03/11/1995             ZZNDX.PRG               15:23:15 
*       *                                                         
*       *********************************************************
*       *                                                         
*       * Patrick Smith                                           
*       *                                                         
*       * Copyright (c) 1995 Contact Technology                   
*       * 26 Aries Lane                                           
*       * Novato, CA  94947                                       
*       * U.S.A                                             
*       *                                                         
*       * Description:                                            
*       * This program was automatically generated by GENSCRN.    
*       *                                                         
*       *********************************************************

PARAMETERS cevent, ctaskalias

*       *********************************************************
*       *                                                         
*       *          ZZNDX/Windows Setup Code - SECTION 1           
*       *                                                         
*       *********************************************************
*

#REGION 1
*++
* Search Index update task support code
*--

* Make sure this is the ONLY task window open!
IF NOT EMPTY(_aWindows[1])
  IF _aWindows[1] = '1_ZZNDX'
    * OK to go back to this window
  ELSE
    WAIT 'Close all windows before performing this function, press <Enter>' WINDOW
    RETURN
  ENDIF
ENDIF

PRIVATE ALL EXCEPT _*


*       *********************************************************
*       *                                                         
*       *          ZZNDX/Windows Setup Code - SECTION 2           
*       *                                                         
*       *********************************************************
*

#REGION 1
* Define offsets into GET variable array structure.
* The first section of the array must match the table layout
* so we can use GATHER/SCATTER to transfer between file and array.
* Make sure it is an exact match to the dbf structure!
* Adjust the size of the array below to hold the memvars

#DEFINE t_cDbf       t_aGETvars[1]
#DEFINE t_cNdx       t_aGETvars[2]
#DEFINE t_cNdxLbl    t_aGETvars[3]
#DEFINE t_cNdxKey    t_aGETvars[4]
#DEFINE t_cSrchPic   t_aGETvars[5]
#DEFINE t_cSrchTyp   t_aGETvars[6]
#DEFINE t_cSrchLen   t_aGETvars[7]
#DEFINE t_cSrchBy    t_aGETvars[8]

* Now define elements for additional non-table fields
#DEFINE t_cOption    t_aGETvars[10]
#DEFINE t_nTopBump   t_aGETvars[11]
#DEFINE t_nBotBump   t_aGETvars[12]
#DEFINE t_cFldList   t_aGETvars[13]

  * And now define the array itself
  DIMENSION t_aGETvars[20]

  * Declare Screen-set wide global variables
  m.t_cWindow = ''   && Window name for this instance
  m.t_nWinRow = 2    && Default row for our window
  m.t_nWinCol = 2    && Default column for our window
  m.t_nCurObj = 0    && Current object number
  m.t_nRecno = 0     && Current record number
  m.t_cOrder= ''     && Default table order.
  m.t_bAddNew = .F.  && Set true if adding new record
  m.t_bChanges = .F. && Changes have been made flag.
  m.t_bAtTop = .F.   && Beginning of file flag
  m.t_bAtEnd = .F.   && End of file flag

  * Determine our task alias, or create a new one.
  IF m.cEvent = 'LAUNCH'
    * Look for topmost existing instance of this task first.
    m.t_cWindow = wTaskWin( m.cTaskAlias )

    IF EMPTY( m.t_cWindow )
      * Create a new instance of this task.
      m.cTaskAlias = wNewTask( m.cTaskAlias )
      IF EMPTY( m.cTaskAlias )
        RETURN .F.
      ENDIF

      m.t_cWindow = wAddWin( m.cTaskAlias, 'ZZNDX', ;
                         'SalesBridge Index Update' )
    ELSE
      * Get the task alias associated with window we found.
      m.cTaskAlias = wWinAlias( m.t_cWindow )
    ENDIF
  ENDIF

  * Restore last saved state (if any) of memory variables.
  DO wGetState WITH m.cTaskAlias

  * Make sure the files we use are open
  IF NOT USED('zzndx')
    * Use AGAIN in case another task, or BROWSE, has file open
    * under a different alias name.
    USE (LOCFILE('zzndx','DBF','Where is the ZZ index file?'));
        IN 0 AGAIN ALIAS zzndx
  ENDIF
  SELECT zzndx
  IF .NOT. FILE('zzndx.idx')
    INDEX ON UPPER(DBF+NDX) TO zzndx
  ENDIF
  SET INDEX TO zzndx
  SET ORDER TO (m.t_cOrder)

  * Restore current record from saved context.
  IF m.t_nRecno > 0 AND m.t_nRecno <= RECCOUNT()
    GO m.t_nRecno
  ENDIF

  DO CASE
    CASE m.cEvent = 'CLOSE'
      IF NOT save_form('closing the window')
        RETURN .F.
      ENDIF
      HIDE WINDOW (t_cWindow)

    CASE m.cEvent = 'UPDATE'
      * If changes have been made, ignore simple update events.
      * Note that this code depends on SET EXACT OFF.
      IF NOT (t_bChanges AND cEvent == 'UPDATE')
        IF save_form('selecting a new record')
          * Process Special event messages we support.
          IF '>' $ m.cEvent
            DO controls WITH SUBSTR(cEvent,AT('>',cEvent)+1)
          ELSE
            IF '-' $ m.cEvent
              GO VAL(SUBSTR(cEvent,AT('-',cEvent)+1))
            ENDIF
            DO load_form
            DO show_form
          ENDIF
        ENDIF
      ENDIF

    CASE m.cEvent = 'LAUNCH' OR m.cEvent = 'ACTIVATE'
      IF NOT WVISIBLE( m.t_cWindow )
        * Position newly created window(s) at last saved position.
        * SIZE must be manually adjusted, NOT from screen generator
        MODIFY WINDOW ( m.t_cWindow ) ;
                FONT 'MS Sans Serif',8 STYLE 'B';
                ICON FILE cardfile.ico ;
                AT m.t_nWinRow, m.t_nWinCol SIZE 30,96 ;
                COLOR RGB(,,,192,192,192)

        * Initialize the GET variable array.
        STORE '' TO t_aGETvars
        STORE 0 TO t_nTopBump, t_nBotBump, t_nCurObj

        * Load current record into GET variable array.
        DO load_form
      ENDIF

      * Issue GETS if this is first time, or another task cleared them
      ACTIVATE WINDOW (m.t_cWindow) NOSHOW
      IF OBJNUM( t_nTopBump, wRdLevel() ) = 0
        DO issue_gets

        * Object numbers have changed, so clear saved object number
        m.t_nCurObj = 0
      ELSE
        * If window was just re-opened, show the gets.
        IF NOT WVISIBLE(m.t_cWindow)
          SHOW GETS WINDOW (m.t_cWindow) LEVEL wRdLevel()
        ENDIF
      ENDIF

      * Set option buttons correctly
      DO set_buttons WITH m.t_bChanges
      ACTIVATE WINDOW (m.t_cWindow)

      * If no saved object, determine default first object to read.
      IF m.t_nCurObj = 0
        m.t_nCurObj = OBJNUM( t_cNdxLbl, wRdLevel() )
      ENDIF

      * Define flag to remember the state of our menu pad. The
      * Activate clause is re-called each time a dialog window
      * is closed. By using this flag we can avoid the overhead of
      * re-redefining our menu in these cases.
      bMenuUp = .F.

      * init memvar for field list in screen
      t_cFldList = space(40)

      * Give ZZProc.prg our READ level validation expressions
      DO wReadInit WITH 'ndx_deact()', 'get_valid()', ;
                        'save_form("closing the window")'

      READ CYCLE SAVE OBJECT m.t_nCurObj ;
         ACTIVATE ndx_act() ;
         DEACTIVATE ndx_deact() ;
         VALID READKEY(1) = 5     && Only terminate if deactivate

      m.t_nCurObj = _nCurObj      && Remember last data object
  ENDCASE

  * Save current context information
  m.t_cOrder = ORDER('zzndx')    && Remember data table order
  m.t_nRecno = RECNO('zzndx')    && and record number
  DO wSaveState WITH m.cTaskAlias

  IF NOT WVISIBLE(t_cWindow)
    * Close the tables we use. If other tasks use them, they will
    * reopen them as part of their context restoration.
    SELECT zzndx
    USE

    * Close associated browse window also, if open.
    IF WEXIST('Database_Index_List')
      DEACTIVATE WINDOW 'Database_Index_List'
    ENDIF

    DO wDelTask WITH m.cTaskAlias
  ENDIF
  RETURN .T.

*******************************************************************
PROCEDURE issue_gets
*++
* The code for this procedure will be generated by GENSCRN.  It
* will issue all the @GETs for the screen.  We want the GET
* commands to be in a seperate procedure so we can call them
* conditionally from the task program setup code.
*--

* ! Important !
* Make sure the When statement for the "get" field "TopBump"
* contains the name of the last "get" field and
* "BotBump" contains the name of the first "get" field
* this will insure that the cursor cycles properly!!!!!
*

*       *********************************************************
*       *                                                         
*       *               ZZNDX/Windows Screen Layout               
*       *                                                         
*       *********************************************************
*

#REGION 1
@ 7.385,23.167 SAY "Description of index file:" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 12.923,2.833 SAY "Index Key: (  Ordered by customer database fields  ( Ex: UPPER(Lname+Fname)   )" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 24.000,2.167 SAY "Index Type:" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 26.000,2.167 SAY "Index Length:" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 5.308,4.833 SAY "The database file name, no .DBF extension:" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 6.308,2.667 SAY "The index file name, no .IDX, .CDX extension:" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 10.154,2.500 SAY "Customer Database Field List (For reference) :" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT"
@ 24.077,36.167 SAY "( Type of fields being indexed. Future expansion. )" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 26.077,35.833 SAY "( Length of index, Future expansion. )" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT"
@ 0.000,0.667 GET t_nTopBump ;
	PICTURE "@*IVN " ;
	SIZE 1.000,1.000,1.000 ;
	DEFAULT 0 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wBumper(OBJNUM(t_cDbf) + 5)
@ 5.462,51.333 GET t_cDbf ;
	SIZE 1.000,14.500 ;
	DEFAULT " " ;
	FONT "FoxFont", 9 ;
	PICTURE "@K" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 6.462,51.333 GET t_cNdx ;
	SIZE 1.000,14.500 ;
	DEFAULT " " ;
	FONT "FoxFont", 9 ;
	PICTURE "@K !!!!!!!!" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 7.462,51.333 GET t_cNdxLbl ;
	SIZE 1.000,20.500 ;
	DEFAULT " " ;
	FONT "FoxFont", 9 ;
	PICTURE "@K" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 15.538,3.667 GET t_cNdxKey ;
	SIZE 1.000,57.375 ;
	DEFAULT " " ;
	FONT "FoxFont", 9 ;
	PICTURE "@K" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 21.154,3.833 GET t_cSrchPic ;
	SIZE 1.000,53.500 ;
	DEFAULT " " ;
	FONT "FoxFont", 9 ;
	PICTURE "@K" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 23.923,17.167 GET t_cSrchTyp ;
	PICTURE "@^ C - Character;N - Numeric;D - Date;L - Logical" ;
	SIZE 1.538,16.167 ;
	DEFAULT "C - Character" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 26.077,17.667 GET t_cSrchLen ;
	SPINNER 1.000, 1, 30 ;
	PICTURE "@K ##" ;
	SIZE 0.846, 9.000 ;
	DEFAULT 1.000 ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() ) ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 0.000,1.333 GET t_nBotBump ;
	PICTURE "@*IVN " ;
	SIZE 1.077,1.000,1.000 ;
	DEFAULT 0 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wBumper( OBJNUM(t_cDbf) )
@ 9.923,51.167 GET t_cFldList ;
	PICTURE "@^" ;
	FROM _zzsmast2 ;
	SIZE 1.538,23.167 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 6 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 0.923,3.833 GET t_cOption ;
	PICTURE "@*BHN " + ;
		(LOCFILE("prev.bmp","BMP|ICO|PCT|ICN","Where is prev?")) + ";" + ;
		(LOCFILE("next.bmp","BMP|ICO|PCT|ICN","Where is next?")) + ";" + ;
		(LOCFILE("list.bmp","BMP|ICO|PCT|ICN","Where is list?")) + ";" + ;
		(LOCFILE("add.bmp","BMP|ICO|PCT|ICN","Where is add?")) + ";" + ;
		(LOCFILE("index.bmp","BMP|ICO|PCT|ICN","Where is index?")) + ";" + ;
		(LOCFILE("undo.bmp","BMP|ICO|PCT|ICN","Where is undo?")) + ";" + ;
		(LOCFILE("save.bmp","BMP|ICO|PCT|ICN","Where is save?")) + ";" + ;
		(LOCFILE("exit.bmp","BMP|ICO|PCT|ICN","Where is exit?")) ;
	SIZE 2.923,8.667,0.667 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	VALID ProcOption(t_cOption,.T.)
@ 4.000,2.500 TO 4.000,79.000 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 0.615,2.500 TO 0.615,78.833 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 0.615,2.167 TO 4.077,2.167 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 0.615,78.833 TO 4.000,78.833 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 4.923,2.167 TO 4.923,46.834 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 5.000,2.167 TO 8.692,2.167 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 4.923,46.667 TO 8.692,46.667 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 8.615,2.333 TO 8.615,47.000 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 4.923,49.667 TO 4.923,88.167 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 4.923,49.333 TO 8.692,49.333 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 8.692,49.500 TO 8.692,88.167 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 4.923,88.167 TO 8.692,88.167 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 9.692,2.167 TO 9.692,46.667 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 9.769,2.167 TO 11.615,2.167 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 9.769,46.500 TO 11.538,46.500 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 11.462,2.500 TO 11.462,46.833 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 9.692,49.833 TO 9.692,75.833 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 9.692,49.500 TO 11.692,49.500 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 11.615,49.833 TO 11.615,75.666 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 9.692,75.667 TO 11.615,75.667 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 12.462,2.167 TO 12.462,82.500 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 12.538,2.167 TO 14.384,2.167 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 12.462,82.500 TO 14.231,82.500 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 14.231,2.500 TO 14.231,82.833 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 14.923,2.500 TO 14.923,82.667 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 14.923,2.167 TO 16.923,2.167 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 16.846,2.500 TO 16.846,82.833 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 15.000,82.667 TO 16.923,82.667 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 18.077,2.167 TO 18.077,82.500 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 18.154,2.167 TO 20.000,2.167 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 18.077,82.500 TO 19.846,82.500 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 19.846,2.500 TO 19.846,82.833 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 18.538,3.167 SAY "Fill in Search Picture if index is a Customer Database search index" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 20.538,2.500 TO 20.538,82.667 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 20.538,2.167 TO 22.538,2.167 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 22.462,2.500 TO 22.462,82.833 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 20.615,82.667 TO 22.538,82.667 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)


*       *********************************************************
*       *                                                         
*       *               ZZNDX/Windows Cleanup Code                
*       *                                                         
*       *********************************************************
*

#REGION 1
********************************************************************


*       *********************************************************
*       *                                                         
*       *   ZZNDX/Windows Supporting Procedures and Functions     
*       *                                                         
*       *********************************************************
*

#REGION 1
FUNCTION ndx_act
*++
* Task specific READ activation handler.
*--

  * Put up custom menu pad for this task window. The activate clause
  * may sometimes be called after the window is hidden during a close
  * operation, if a dialog box was activated by the form level
  * validation handler. The WVISIBLE() test makes sure we don't put
  * the menu back up in this case. The bMenuUp flag is used only for
  * optimization purposes - so we don't redefine the menu if it's
  * already there.
  IF WVISIBLE(m.t_cWindow) AND NOT bMenuUp
    DO zzndx.mpr
    bMenuUp = .T.
  ENDIF

  RETURN .T.


********************************************************************
FUNCTION ndx_deact
*++
* Task specific READ deactivation handler.
* This routine may be called by the READ command on a READ window
* deactivation, or explicitly by the wClearRead() function. That
* means we cannot depend on WLAST() or WONTOP() to be set right.
*--
  * Under FoxPro for Windows, Minimizing a window from the window
  * control box, or Choosing Next Window, bypasses the GET Valid
  * clause. This is our only chance to catch it, and thereby enforce
  * proper field validation.
  IF wCatchAll(m.t_cWindow)
    * Save last position of window
    m.t_nWinRow = WLROW(m.t_cWindow)
    m.t_nWinCol = WLCOL(m.t_cWindow)

    RELEASE PAD index OF _MSYSMENU
    RELEASE POPUP index
    bMenuUp = .F.
    RETURN .T.
  ELSE
    RETURN .F.
  ENDIF


********************************************************************
FUNCTION GET_valid
*++
* Common validation routine called when any field data is changed.
*
* This routine is responsible for:
*  1. Checking lock status of record, locking if needed.
*  2. Setting changes flag and setting buttons.
*
* Returns TRUE.
*  If data was changed and lock could not be established, data is
*  reset to initial value.
*--
PRIVATE xTemp

  IF NOT m.t_bchanges AND wChanged()
    IF NOT wLock(m.cTaskAlias, 'zzndx', RECNO('zzndx') )
      * Restore original field contents on Lock failure.
      DO wFldUndo

      * Return success, since user is warned, and changes undone.
      RETURN .T.
    ENDIF

    * Make sure any changes to record made since original
    * display are shown on screen when the record is locked.
    STORE EVALUATE( VARREAD() ) TO m.xTemp
    DO load_form
    STORE m.xTemp TO ( VARREAD() )
    DO show_form

    DO set_buttons WITH .T.
  ENDIF

  RETURN .T.


********************************************************************
PROCEDURE load_form
*++
* Load data from current record for display and/or edit.
*---
  SELECT zzndx

  * Don't stay at EOF if we can help it.
  IF EOF()
    GOTO BOTTOM

    * If still at EOF, perform implicit add record command.
    IF EOF()
      RETURN init_form()
    ENDIF
  ENDIF

  m.t_bAddNew = .F.
  DO set_buttons WITH .F.

  * Let all the other tasks know what record we have displayed.
  DO wListen WITH m.cTaskAlias, 'zzndx', RECNO('zzndx')

  * Load data from field variables into GET variable array.
  SCATTER TO t_aGETvars MEMO
  RETURN


********************************************************************
PROCEDURE init_form
*++
* Initialize internal memory for a new address record.
* Let format default to current setting on add.
*---
  m.t_bAddNew = .T.
  DO set_buttons WITH .T.

  SELECT zzndx
  SCATTER TO t_aGETvars MEMO BLANK

  * Move to first field to begin entry of new record.
  _CUROBJ = OBJNUM( t_cNdxLbl )
  RETURN


********************************************************************
PROCEDURE show_form
*++
* Display current data and Enable/Disable fields as appropriate.
*---

  SHOW GETS WINDOW (m.t_cWindow) LEVEL wRdLevel()
  RETURN


********************************************************************
FUNCTION set_buttons
PARAMETER bChanges
*++
* Set changes flag, and update control buttons accordingly.
*--
PRIVATE nRecno

  IF m.bChanges
    SHOW GET t_cOption,6 ENABLE LEVEL wRdLevel()
    SHOW GET t_cOption,7 ENABLE LEVEL wRdLevel()
  ELSE
    SHOW GET t_cOption,6 DISABLE LEVEL wRdLevel()
    SHOW GET t_cOption,7 DISABLE LEVEL wRdLevel()
  ENDIF

  * The AddNEw flag will always be set if there are no records.
  IF t_bAddNew
    t_bAtTop = .T.
    t_bAtEnd = .T.
  ELSE
    nRecno = RECNO()
    SKIP -1
    t_bAtTop = BOF()
    GO nRecno

    SKIP 1
    t_bAtEnd = EOF()
    GO nRecno
  ENDIF

  * Set buttons according to current record
  IF m.t_bAtTop
    SHOW GET t_cOption,1 DISABLE LEVEL wRdLevel()
  ELSE
    SHOW GET t_cOption,1 ENABLE LEVEL wRdLevel()
  ENDIF

  IF m.t_bAtEnd
    SHOW GET t_cOption,2 DISABLE LEVEL wRdLevel()
  ELSE
    SHOW GET t_cOption,2 ENABLE LEVEL wRdLevel()
  ENDIF

  * Store new value of task level change flag and return it.
  m.t_bChanges = m.bChanges
  RETURN m.bChanges


********************************************************************
FUNCTION ProcOption
PARAMETER cOption, bInObject
*++
* Process menu and pushbutton options.
*--

* if choice is picture button, strip off ".BMP" from end
* make sure .bmp button file names match menu options!
m.cOption = STRTRAN(m.cOption,'.BMP','')
* identify file name, strip off path + back-slashes
m.cOption = SUBSTR(m.cOption,RAT('\',m.cOption)+1)

SELECT zzndx
m.cOption = UPPER( ALLTRIM(m.cOption) )

  DO CASE
    * First, handle the common task button options.
    CASE controls(cOption, bInObject)

    * Then, check for task-specific button options.

    CASE m.cOption = 'INDEX'
      DO fixndx

    CASE m.cOption = 'LIST'
      * Launch an independant BROWSE window, linked to ours.
      DO wLaunch WITH 'ndxlist IN zzndx'

  ENDCASE

  RETURN .T.


********************************************************************
PROCEDURE ndxlist
PARAMETER cEvent, cTaskAlias
*++
* This BROWSE task is designed to work together with the
* search index update task window.
*
* Parameters from wLaunch are ignored for BROWSE tasks, since
* once they are started, we never get control of them again.
*--
  SELECT zzndx

  * Define a window for Browse to pattern itself after. Specify font
  * so size will be consistent even if Main Window font changes.
  DEFINE WINDOW bwin AT 1,1 SIZE 11,75 ;
                        FONT 'MS Sans Serif',8 STYLE 'B' ;
                        FLOAT SHADOW CLOSE MINIMIZE ZOOM ;
                        SYSTEM GROW COLOR SCHEME 8
  MOVE WINDOW bwin CENTER

  * Activate the BROWSE window. The WHEN clause calls zzndx.prg
  * with the event string 'UPDATE-n' where n is the new
  * record number to display in the window.
  BROWSE NOWAIT REST NOMENU NOMODIFY ;
         WINDOW bwin TITLE 'Database_Index_List' ;
         FIELDS dbf:H='Database',ndx:H='Index File',ndxlbl:H='Index Description' ;
         WHEN EVALUATE( 'zzndx' ;
                + '("UPDATE-' + ALLTRIM(STR(RECNO())) ;
                + '", "1_ZZNDX")' )

  RELEASE WINDOW bwin
  RETURN


********************************************************************
FUNCTION save_form
PARAMETER cMsgTxt
*++
* Validate complete form as a whole, and save changes. If cMsgTxt
* contains a string, use it to ask whether or not user wants to
* save changes.
*--
PRIVATE nBadField, cReason, cAnswer

  SELECT zzndx
  STORE '' TO m.cReason

  IF m.t_bChanges
    m.cAnswer = IIF(EMPTY(m.cMsgTxt), 'YES', zzQuest(m.t_cWindow, ;
        'Do you want to save changes made to this index ' ;
        + 'before ' + m.cMsgTxt + '?' ) )

    * Return failure immediately if user cancels.
    IF m.cAnswer = 'CANCEL'
      RETURN .F.
    ENDIF

    * Save the changes if we are supposed to.
    IF m.cAnswer = 'YES'
      * Make sure all required fields have been entered.
      DO CASE
        CASE EMPTY(t_cNdxLbl)
          m.cReason = 'A Description is required'
          m.nBadField = OBJNUM(t_cName)

      ENDCASE

      IF NOT EMPTY(m.cReason)
        DO zzWarn WITH m.t_cWindow, m.cReason

        * This routine may be called when no GETs are issued (like
        * during Global shutdown). OBJNUM() returns 0 in this case.
        _CUROBJ = nBadField
        RETURN .F.
      ENDIF

      * Add a new record to the database when needed.
      IF m.t_bAddNew
        * Create new record
        APPEND BLANK
        m.t_bAddNew = .F.
      ENDIF

      GATHER FROM t_aGETvars MEMO
      DO set_buttons WITH .F.
    ELSE
      * User said 'dont save', so reload from disk.
      DO load_form
      DO show_form
    ENDIF

    * Whether changes saved or discarded, release the locks.
    DO wUnlock WITH m.cTaskAlias

  ENDIF

  RETURN .T.


* EOF - save_form

********************************************************************
FUNCTION FixNdx
* create index for database and PACK if desired
*

DEFINE WINDOW NdxPack ;
  AT 4,7 ;
  SIZE 6,70 ;
  TITLE  'Index/Pack Database' ;
  FONT 'Times New Roman', 10 ;
  STYLE 'B' ;
  FLOAT ;
  CLOSE ;
  NOMINIMIZE ;
  DOUBLE
MOVE WINDOW NdxPack CENTER
ACTIVATE WINDOW NdxPack

TempDbf = ALLTRIM(t_cDbf)

IF NOT USED(TempDbf)
  * Use AGAIN in case another task, or BROWSE, has file open
  * under a different alias name.
  USE (LOCFILE(TempDbf,'DBF','Where is the .dbf?')) ;
      IN 0 EXCLUSIVE ALIAS &TempDbf
ENDIF
SELECT &TempDbf

IF zzCntnue('Do you want to REMOVE ALL deleted records?')
  WAIT 'Packing/Condensing ' + ALLTRIM(t_cDbf) ;
  + '.DBF for ' + ALLTRIM(STR(RECC())) + ' records now...' WINDOW NOWAIT

  SET TALK ON
  PACK
  SET TALK OFF
ELSE
  * continue
ENDIF

IF zzCntnue('Do you want to INDEX records?')

  WAIT 'Indexing ' + ALLTRIM(t_cNdxLbl) ;
  + ' for ' + ALLTRIM(STR(RECC())) + ' records now...' WINDOW NOWAIT

  tempkey = ALLTRIM(t_cNdxKey)
  SET TALK ON
  INDEX ON &tempkey TO &t_cNdx COMPACT
  SET TALK OFF

  WAIT 'Pack/Index Finished. Press <Enter> now.' WINDOW
  IF ALIAS(SELECT()) <> 'ZZNDX'
     USE
     SELECT zzndx
  ENDIF

ELSE
  * continue
ENDIF

DEACTIVATE WINDOW NdxPack

RETURN

* EOF - FixNdx
********************************************************************
********************************************************************
********************************************************************
* EOF - zzndx.prg