*       *********************************************************
*       *                                                         
*       * 03/11/1995              ZZP.PRG                15:54:43 
*       *                                                         
*       *********************************************************
*       *                                                         
*       * Patrick Smith                                           
*       *                                                         
*       * Copyright (c) 1995 Contact Technology                   
*       * 26 Aries Lane                                           
*       * Novato, CA  94947                                       
*       * U.S.A                                             
*       *                                                         
*       * Description:                                            
*       * This program was automatically generated by GENSCRN.    
*       *                                                         
*       *********************************************************

PARAMETERS cevent, ctaskalias

*       *********************************************************
*       *                                                         
*       *           ZZP/Windows Setup Code - SECTION 1            
*       *                                                         
*       *********************************************************
*

#REGION 1
*++
* Filter update task support code
*--

* Make sure this is the ONLY task window open!
IF NOT EMPTY(_aWindows[1])
  IF _aWindows[1] = '1_ZZP'
    * OK to go back to this window
  ELSE
    WAIT 'Close all windows before performing this function, press <Enter>' WINDOW
    RETURN
  ENDIF
ENDIF

PRIVATE ALL EXCEPT _*


*       *********************************************************
*       *                                                         
*       *           ZZP/Windows Setup Code - SECTION 2            
*       *                                                         
*       *********************************************************
*

#REGION 1
* Define offsets into GET variable array structure.
* The first section of the array must match the table layout
* so we can use GATHER/SCATTER to transfer between file and array.
* Make sure it is an exact match to the dbf structure!
* Adjust the size of the array below to hold the memvars

#DEFINE t_cFldN      t_aGETvars[1]
#DEFINE t_cFldP      t_aGETvars[2]
#DEFINE t_cFldI      t_aGETvars[3]
#DEFINE t_cOk2Zap    t_aGETvars[4]
#DEFINE t_cOk2Add    t_aGETvars[5]
#DEFINE t_cOk2Mod    t_aGETvars[6]
#DEFINE t_cOk2Del    t_aGETvars[7]
#DEFINE t_cOk2Rpt    t_aGETvars[8]
#DEFINE t_cok2Lbl    t_aGETvars[9]
#DEFINE t_cOk2Flt    t_aGETvars[10]
#DEFINE t_cOk2Edt    t_aGETvars[11]
#DEFINE t_cOk2Ndx    t_aGETvars[12]
#DEFINE t_cOk2Imp    t_aGETvars[13]
#DEFINE t_cOk2Exp    t_aGETvars[14]
#DEFINE t_cOk2All    t_aGETvars[15]
#DEFINE t_cOk2Qck    t_aGETvars[16]

* Now define elements for additional non-table fields
#DEFINE t_cOption    t_aGETvars[21]
#DEFINE t_nTopBump   t_aGETvars[22]
#DEFINE t_nBotBump   t_aGETvars[23]

  * And now define the array itself
  DIMENSION t_aGETvars[40]

  * Declare Screen-set wide global variables
  m.t_cWindow = ''   && Window name for this instance
  m.t_nWinRow = 2    && Default row for our window
  m.t_nWinCol = 2    && Default column for our window
  m.t_nCurObj = 0    && Current object number
  m.t_nRecno = 0     && Current record number
  m.t_cOrder = 'zzP'     && Default table order.
  m.t_bAddNew = .F.  && Set true if adding new record
  m.t_bChanges = .F. && Changes have been made flag.
  m.t_bAtTop = .F.   && Beginning of file flag
  m.t_bAtEnd = .F.   && End of file flag

  * Determine our task alias, or create a new one.
  IF m.cEvent = 'LAUNCH'
    * Look for topmost existing instance of this task first.
    m.t_cWindow = wTaskWin( m.cTaskAlias )

    IF EMPTY( m.t_cWindow )
      * Create a new instance of this task.
      m.cTaskAlias = wNewTask( m.cTaskAlias )
      IF EMPTY( m.cTaskAlias )
        RETURN .F.
      ENDIF

      m.t_cWindow = wAddWin( m.cTaskAlias, 'ZZp', ;
                         'User Password Update' )
    ELSE
      * Get the task alias associated with window we found.
      m.cTaskAlias = wWinAlias( m.t_cWindow )
    ENDIF
  ENDIF

  * Restore last saved state (if any) of memory variables.
  DO wGetState WITH m.cTaskAlias

  IF NOT USED('zzp')
    * Use AGAIN in case another task, or BROWSE, has file open
    * under a different alias name.
    USE (LOCFILE('zzp','DBF','Where is the Password file?'));
        IN 0 AGAIN ALIAS zzp
  ENDIF
  SELECT zzp
  SET INDEX TO (m.t_cOrder)
  SET ORDER TO (m.t_cOrder)

  * Restore current record from saved context.
  IF m.t_nRecno > 0 AND m.t_nRecno <= RECCOUNT()
    GO m.t_nRecno
  ENDIF

  DO CASE
    CASE m.cEvent = 'CLOSE'
      IF NOT save_form('closing the window')
        RETURN .F.
      ENDIF
      HIDE WINDOW (t_cWindow)

    CASE m.cEvent = 'UPDATE'
      * If changes have been made, ignore simple update events.
      * Note that this code depends on SET EXACT OFF.
      IF NOT (t_bChanges AND cEvent == 'UPDATE')
        IF save_form('selecting a new record')
          * Process Special event messages we support.
          IF '>' $ m.cEvent
            DO controls WITH SUBSTR(cEvent,AT('>',cEvent)+1)
          ELSE
            IF '-' $ m.cEvent
              GO VAL(SUBSTR(cEvent,AT('-',cEvent)+1))
            ENDIF
            DO load_form
            DO show_form
          ENDIF
        ENDIF
      ENDIF

    CASE m.cEvent = 'LAUNCH' OR m.cEvent = 'ACTIVATE'
      IF NOT WVISIBLE( m.t_cWindow )
        * Position newly created window(s) at last saved position.
        * SIZE must be manually adjusted, NOT from screen generator
        MODIFY WINDOW ( m.t_cWindow ) ;
                FONT 'MS Sans Serif',8 STYLE 'B';
                ICON FILE cardfile.ico ;
                AT m.t_nWinRow, m.t_nWinCol SIZE 30,96 ;
                COLOR RGB(,,,192,192,192)

        * Initialize the GET variable array.
        STORE '' TO t_aGETvars
        STORE 0 TO t_nTopBump, t_nBotBump, t_nCurObj

        * Load current record into GET variable array.
        DO load_form
      ENDIF

      * Issue GETS if this is first time, or another task cleared them
      ACTIVATE WINDOW (m.t_cWindow) NOSHOW
      IF OBJNUM( t_nTopBump, wRdLevel() ) = 0
        DO issue_gets

        * Object numbers have changed, so clear saved object number
        m.t_nCurObj = 0
      ELSE
        * If window was just re-opened, show the gets.
        IF NOT WVISIBLE(m.t_cWindow)
          SHOW GETS WINDOW (m.t_cWindow) LEVEL wRdLevel()
        ENDIF
      ENDIF

      * Set option buttons correctly
      DO set_buttons WITH m.t_bChanges
      ACTIVATE WINDOW (m.t_cWindow)

      * If no saved object, determine default first object to read.
      IF m.t_nCurObj = 0
        m.t_nCurObj = OBJNUM( t_cFldN, wRdLevel() )
      ENDIF

      * Define flag to remember the state of our menu pad. The
      * Activate clause is re-called each time a dialog window
      * is closed. By using this flag we can avoid the overhead of
      * re-redefining our menu in these cases.
      bMenuUp = .F.

      * Give ZZProc.prg our READ level validation expressions
      DO wReadInit WITH 'p_deact()', 'get_valid()', ;
                        'save_form("closing the window")'

      READ CYCLE SAVE OBJECT m.t_nCurObj ;
         ACTIVATE p_act() ;
         DEACTIVATE p_deact() ;
         VALID READKEY(1) = 5     && Only terminate if deactivate

      m.t_nCurObj = _nCurObj      && Remember last data object
  ENDCASE

  * Save current context information
  m.t_cOrder = ORDER('zzp')    && Remember data table order
  m.t_nRecno = RECNO('zzp')    && and record number
  DO wSaveState WITH m.cTaskAlias

  IF NOT WVISIBLE(t_cWindow)
    * Close the tables we use. If other tasks use them, they will
    * reopen them as part of their context restoration.
    SELECT zzp
    USE

    * Close associated browse window also, if open.
    IF WEXIST('User_Password_List')
      DEACTIVATE WINDOW 'User_Password_List'
    ENDIF

    DO wDelTask WITH m.cTaskAlias
  ENDIF
  RETURN .T.

*******************************************************************
PROCEDURE issue_gets
*++
* The code for this procedure will be generated by GENSCRN.  It
* will issue all the @GETs for the screen.  We want the GET
* commands to be in a seperate procedure so we can call them
* conditionally from the task program setup code.
*--

* ! Important !
* Make sure the When statement for the "get" field "TopBump"
* contains the name of the last "get" field and
* "BotBump" contains the name of the first "get" field
* this will insure that the cursor cycles properly!!!!!
*

*       *********************************************************
*       *                                                         
*       *                ZZP/Windows Screen Layout                
*       *                                                         
*       *********************************************************
*

#REGION 1
@ 5.308,6.833 SAY "User Name:" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 6.154,8.167 SAY "Password:" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 7.077,12.000 SAY "Initial:" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 7.077,2.167 TO 7.077,2.167 ;
	PEN 1, 8 ;
	STYLE "16"
@ 10.231,4.333 SAY "User Has Access To These Parts of SalesBridge:" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT"
@ 0.000,0.167 GET t_nTopBump ;
	PICTURE "@*IVN " ;
	SIZE 1.000,1.167,1.000 ;
	DEFAULT 0 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wBumper(OBJNUM(t_cFldN) + 7)
@ 5.462,22.000 GET t_cFldN ;
	SIZE 1.000,8.500 ;
	DEFAULT " " ;
	FONT "FoxFont", 9 ;
	PICTURE "@K XXXXXXXXXXXXXXXXXXXX" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 6.462,22.000 GET t_cFldP ;
	SIZE 1.000,8.500 ;
	DEFAULT " " ;
	FONT "FoxFont", 9 ;
	PICTURE "@K XXXXXXXX" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 7.462,22.000 GET t_cFldI ;
	SIZE 1.000,3.250 ;
	DEFAULT " " ;
	FONT "FoxFont", 9 ;
	PICTURE "@K !!!" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 12.846,4.667 GET t_cOk2Zap ;
	PICTURE "@*C Potentially Destructive Functions" ;
	SIZE 1.308,35.667 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 14.846,4.667 GET t_cOk2Add ;
	PICTURE "@*C Add/Copy Customer Records" ;
	SIZE 1.308,31.667 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 16.846,4.667 GET t_cOk2Mod ;
	PICTURE "@*C Modify Customer Records" ;
	SIZE 1.308,28.500 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 18.846,4.667 GET t_cOk2Del ;
	PICTURE "@*C Delete Customer Records" ;
	SIZE 1.308,28.500 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 20.846,4.667 GET t_cOk2Qck ;
	PICTURE "@*C Quick Edit Window" ;
	SIZE 1.308,22.500 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 22.846,4.667 GET t_cOk2Rpt ;
	PICTURE "@*C Report Printing/Modification" ;
	SIZE 1.308,31.167 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 24.846,4.667 GET t_cOk2Lbl ;
	PICTURE "@*C Label Printing/Modification" ;
	SIZE 1.308,30.000 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 12.846,42.667 GET t_cOk2Flt ;
	PICTURE "@*C Customer Filter Modification" ;
	SIZE 1.308,30.667 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 14.846,42.667 GET t_cOk2Edt ;
	PICTURE "@*C Edit/View External Text Files" ;
	SIZE 1.308,31.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 16.846,42.667 GET t_cOk2Ndx ;
	PICTURE "@*C Re-Index/Maintain Files" ;
	SIZE 1.308,27.000 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 18.846,42.667 GET t_cOk2Imp ;
	PICTURE "@*C Import Customer Records" ;
	SIZE 1.308,28.167 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 20.846,42.667 GET t_cOk2Exp ;
	PICTURE "@*C Export Customer Records" ;
	SIZE 1.308,28.333 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 22.846,42.667 GET t_cOk2All ;
	PICTURE "@*C Edit All Records, (Blank - Personal Only)" ;
	SIZE 1.308,42.667 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 0.000,1.333 GET t_nBotBump ;
	PICTURE "@*IVN " ;
	SIZE 1.077,0.833,1.000 ;
	DEFAULT 0 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wBumper( OBJNUM(t_cFldN) )
@ 1.000,4.500 GET t_cOption ;
	PICTURE "@*BHN " + ;
		(LOCFILE("prev.bmp","BMP|ICO|PCT|ICN","Where is prev?")) + ";" + ;
		(LOCFILE("next.bmp","BMP|ICO|PCT|ICN","Where is next?")) + ";" + ;
		(LOCFILE("list.bmp","BMP|ICO|PCT|ICN","Where is list?")) + ";" + ;
		(LOCFILE("add.bmp","BMP|ICO|PCT|ICN","Where is add?")) + ";" + ;
		(LOCFILE("copy.bmp","BMP|ICO|PCT|ICN","Where is copy?")) + ";" + ;
		(LOCFILE("undo.bmp","BMP|ICO|PCT|ICN","Where is undo?")) + ";" + ;
		(LOCFILE("save.bmp","BMP|ICO|PCT|ICN","Where is save?")) + ";" + ;
		(LOCFILE("exit.bmp","BMP|ICO|PCT|ICN","Where is exit?")) ;
	SIZE 2.923,8.667,0.667 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	VALID ProcOption(t_cOption,.T.)
@ 24.846,45.667 SAY '( Blank - Only edit "Owned" records )' ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT"
@ 4.077,3.333 TO 4.077,79.833 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 0.692,3.333 TO 0.692,79.666 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 0.692,3.000 TO 4.154,3.000 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 0.692,79.667 TO 4.077,79.667 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 5.000,3.000 TO 5.000,19.167 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 5.077,3.000 TO 8.769,3.000 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 5.077,19.000 TO 8.846,19.000 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 8.692,3.167 TO 8.692,19.167 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 5.000,20.833 TO 5.000,34.500 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 5.000,20.500 TO 8.769,20.500 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 8.769,20.667 TO 8.769,34.500 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 5.154,34.500 TO 8.769,34.500 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 9.769,3.000 TO 9.769,88.000 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 9.846,3.000 TO 11.692,3.000 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 9.846,87.833 TO 11.615,87.833 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 11.538,3.000 TO 11.538,88.000 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 12.385,3.333 TO 12.385,88.000 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 12.385,3.000 TO 26.539,3.000 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 26.462,3.167 TO 26.462,87.834 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 12.538,87.833 TO 26.461,87.833 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)


*       *********************************************************
*       *                                                         
*       *                ZZP/Windows Cleanup Code                 
*       *                                                         
*       *********************************************************
*

#REGION 1
********************************************************************


*       *********************************************************
*       *                                                         
*       *    ZZP/Windows Supporting Procedures and Functions      
*       *                                                         
*       *********************************************************
*

#REGION 1
FUNCTION p_act
*++
* Task specific READ activation handler.
*--

  * Put up custom menu pad for this task window. The activate clause
  * may sometimes be called after the window is hidden during a close
  * operation, if a dialog box was activated by the form level
  * validation handler. The WVISIBLE() test makes sure we don't put
  * the menu back up in this case. The bMenuUp flag is used only for
  * optimization purposes - so we don't redefine the menu if it's
  * already there.
  IF WVISIBLE(m.t_cWindow) AND NOT bMenuUp
    DO zzp.mpr
    bMenuUp = .T.
  ENDIF

  RETURN .T.


********************************************************************
FUNCTION p_deact
*++
* Task specific READ deactivation handler.
* This routine may be called by the READ command on a READ window
* deactivation, or explicitly by the wClearRead() function. That
* means we cannot depend on WLAST() or WONTOP() to be set right.
*--
  * Under FoxPro for Windows, Minimizing a window from the window
  * control box, or Choosing Next Window, bypasses the GET Valid
  * clause. This is our only chance to catch it, and thereby enforce
  * proper field validation.
  IF wCatchAll(m.t_cWindow)
    * Save last position of window
    m.t_nWinRow = WLROW(m.t_cWindow)
    m.t_nWinCol = WLCOL(m.t_cWindow)

    RELEASE PAD users OF _MSYSMENU
    RELEASE POPUP users
    bMenuUp = .F.
    RETURN .T.
  ELSE
    RETURN .F.
  ENDIF


********************************************************************
FUNCTION GET_valid
*++
* Common validation routine called when any field data is changed.
*
* This routine is responsible for:
*  1. Checking lock status of record, locking if needed.
*  2. Setting changes flag and setting buttons.
*
* Returns TRUE.
*  If data was changed and lock could not be established, data is
*  reset to initial value.
*--
PRIVATE xTemp

  IF NOT m.t_bchanges AND wChanged()
    IF NOT wLock(m.cTaskAlias, 'zzp', RECNO('zzp') )
      * Restore original field contents on Lock failure.
      DO wFldUndo

      * Return success, since user is warned, and changes undone.
      RETURN .T.
    ENDIF

    * Make sure any changes to record made since original
    * display are shown on screen when the record is locked.
    STORE EVALUATE( VARREAD() ) TO m.xTemp
    DO load_form
    STORE m.xTemp TO ( VARREAD() )
    DO show_form

    DO set_buttons WITH .T.
  ENDIF

  RETURN .T.


********************************************************************
PROCEDURE load_form
*++
* Load data from current record for display and/or edit.
*---
  SELECT zzp

  * Don't stay at EOF if we can help it.
  IF EOF()
    GOTO BOTTOM

    * If still at EOF, perform implicit add record command.
    IF EOF()
      RETURN init_form()
    ENDIF
  ENDIF

  m.t_bAddNew = .F.
  DO set_buttons WITH .F.

  * Let all the other tasks know what record we have displayed.
  DO wListen WITH m.cTaskAlias, 'zzp', RECNO('zzp')

  * Load data from field variables into GET variable array.
  SCATTER TO t_aGETvars MEMO
  RETURN


********************************************************************
PROCEDURE init_form
*++
* Initialize internal memory for a new address record.
* Let format default to current setting on add.
*---
  m.t_bAddNew = .T.
  DO set_buttons WITH .T.

  SELECT zzp
  SCATTER TO t_aGETvars MEMO BLANK

  * Move to first field to begin entry of new record.
  _CUROBJ = OBJNUM( t_cFldn )
  RETURN


********************************************************************
PROCEDURE show_form
*++
* Display current data and Enable/Disable fields as appropriate.
*---

  SHOW GETS WINDOW (m.t_cWindow) LEVEL wRdLevel()
  RETURN


********************************************************************
FUNCTION set_buttons
PARAMETER bChanges
*++
* Set changes flag, and update control buttons accordingly.
*--
PRIVATE nRecno

  IF m.bChanges
    SHOW GET t_cOption,6 ENABLE LEVEL wRdLevel()
    SHOW GET t_cOption,7 ENABLE LEVEL wRdLevel()
  ELSE
    SHOW GET t_cOption,6 DISABLE LEVEL wRdLevel()
    SHOW GET t_cOption,7 DISABLE LEVEL wRdLevel()
  ENDIF

  * The AddNEw flag will always be set if there are no records.
  IF t_bAddNew
    t_bAtTop = .T.
    t_bAtEnd = .T.
  ELSE
    nRecno = RECNO()
    SKIP -1
    t_bAtTop = BOF()
    GO nRecno

    SKIP 1
    t_bAtEnd = EOF()
    GO nRecno
  ENDIF

  * Set buttons according to current record
  IF m.t_bAtTop
    SHOW GET t_cOption,1 DISABLE LEVEL wRdLevel()
  ELSE
    SHOW GET t_cOption,1 ENABLE LEVEL wRdLevel()
  ENDIF

  IF m.t_bAtEnd
    SHOW GET t_cOption,2 DISABLE LEVEL wRdLevel()
  ELSE
    SHOW GET t_cOption,2 ENABLE LEVEL wRdLevel()
  ENDIF

  * Store new value of task level change flag and return it.
  m.t_bChanges = m.bChanges
  RETURN m.bChanges


********************************************************************
FUNCTION ProcOption
PARAMETER cOption, bInObject
*++
* Process menu and pushbutton options.
*--

* if choice is picture button, strip off ".BMP" from end
* make sure .bmp button file names match menu options!
m.cOption = STRTRAN(m.cOption,'.BMP','')
* identify file name, strip off path + back-slashes
m.cOption = SUBSTR(m.cOption,RAT('\',m.cOption)+1)


SELECT zzp
m.cOption = UPPER( ALLTRIM(m.cOption) )

  IF  m.cOption = 'COPY'
    APPEND BLANK
    GATHER FROM t_aGETvars MEMO
    DO load_form
    DO show_form
    DO wUnlock WITH m.cTaskAlias
    WAIT 'Record Copied' Window NOWAIT
    RETURN .T.
  ENDIF

  DO CASE
    * First, handle the common task button options.
    CASE controls(cOption, bInObject)

    CASE m.cOption = 'LIST'
      * Launch an independant BROWSE window, linked to ours.
      DO wLaunch WITH 'plist IN zzp'

  ENDCASE

  RETURN .T.


********************************************************************
PROCEDURE plist
PARAMETER cEvent, cTaskAlias
*++
* This BROWSE task is designed to work together with the
* filter update task window.
*
* Parameters from wLaunch are ignored for BROWSE tasks, since
* once they are started, we never get control of them again.
*--
  SELECT zzp

  * Define a window for Browse to pattern itself after. Specify font
  * so size will be consistent even if Main Window font changes.
  DEFINE WINDOW bwin AT 1,1 SIZE 11,75 ;
                        FONT 'MS Sans Serif',8 STYLE 'B' ;
                        FLOAT SHADOW CLOSE MINIMIZE ZOOM ;
                        SYSTEM GROW COLOR SCHEME 8
  MOVE WINDOW bwin CENTER

  * Activate the BROWSE window. The WHEN clause calls zzp.prg
  * with the event string 'UPDATE-n' where n is the new
  * record number to display in the window.
  BROWSE NOWAIT REST NOMENU NOMODIFY ;
         WINDOW bwin TITLE 'User_List' ;
         FIELDS Fldn:H='User' ;
         WHEN EVALUATE( 'zzp' ;
                + '("UPDATE-' + ALLTRIM(STR(RECNO())) ;
                + '", "1_ZZP")' )

  RELEASE WINDOW bwin
  RETURN


********************************************************************
FUNCTION save_form
PARAMETER cMsgTxt
*++
* Validate complete form as a whole, and save changes. If cMsgTxt
* contains a string, use it to ask whether or not user wants to
* save changes.
*--
PRIVATE nBadField, cReason, cAnswer

  SELECT zzp
  STORE '' TO m.cReason

  IF m.t_bChanges
    m.cAnswer = IIF(EMPTY(m.cMsgTxt), 'YES', zzQuest(m.t_cWindow, ;
        'Do you want to save changes made to this user ' ;
        + 'before ' + m.cMsgTxt + '?' ) )

    * Return failure immediately if user cancels.
    IF m.cAnswer = 'CANCEL'
      RETURN .F.
    ENDIF

    * Save the changes if we are supposed to.
    IF m.cAnswer = 'YES'
      * Make sure all required fields have been entered.
      DO CASE
        CASE EMPTY(t_cFldn)
          m.cReason = 'A user name is required'
          m.nBadField = OBJNUM(t_cFldN)
        CASE EMPTY(t_cFldp)
          m.cReason = 'A user password is required'
          m.nBadField = OBJNUM(t_cFldP)
        CASE EMPTY(t_cFldi)
          m.cReason = 'A user initial ID is required'
          m.nBadField = OBJNUM(t_cFldI)

      ENDCASE

      IF NOT EMPTY(m.cReason)
        DO zzWarn WITH m.t_cWindow, m.cReason

        * This routine may be called when no GETs are issued (like
        * during Global shutdown). OBJNUM() returns 0 in this case.
        _CUROBJ = nBadField
        RETURN .F.
      ENDIF

      * Add a new record to the database when needed.
      IF m.t_bAddNew
        * Create new record
        APPEND BLANK
        m.t_bAddNew = .F.
      ENDIF

      GATHER FROM t_aGETvars MEMO
      DO set_buttons WITH .F.
    ELSE
      * User said 'dont save', so reload from disk.
      DO load_form
      DO show_form
    ENDIF

    * Whether changes saved or discarded, release the locks.
    DO wUnlock WITH m.cTaskAlias

  ENDIF

  RETURN .T.


* EOF - save_form
********************************************************************
********************************************************************
********************************************************************
* EOF - zzp.prg