*************************************************************
* zzProc.prg - The main procedure library of SalesBridge
* Called from zz.prg
*************************************************************

* Define offsets into various array structures
#DEFINE kWorkArea  1    && Work area number for browse array
#DEFINE kTaskAlias 1    && Task alias name
#DEFINE kWinName   2    && Window name
#DEFINE kWinTitle  3    && Window Title (with instance number)
#DEFINE kTable     2    && Table name in Lock & Listen array
#DEFINE kRecord    3    && Record number in Lock & Listen array

***************************************************************************
PROCEDURE Wall
PARAMETERS mVert,mHorz
* Paint bitmap picture onto foxpro main screen

IF FILE(_Wall)
  IF .NOT. EMPTY(_Wall)
    @  0, 0 SAY _Wall BITMAP SIZE mVert,mHorz
  ELSE
    @  0, 0 CLEAR
  ENDIF
ELSE
  IF .NOT. EMPTY(_Wall)
    WAIT _Wall + ' is not in the SalesBridge directory, no display..' WINDOW TIMEOUT 2
  ENDIF
ENDIF

RETURN

* EOF - Wall
***************************************************************************
FUNCTION MakeList
* Create string to be used in master file browse for the "FIELDS" clause
* Used in zzCust.prg
*

PRIVATE rtrn_str

rtrn_str   = ALLTRIM(fld1)+':'+ALLTRIM(STR(width1))+':H="'+EVALUATE('B'+fld1)+'",' + ;
             ALLTRIM(fld2)+':'+ALLTRIM(STR(width2))+':H="'+EVALUATE('B'+fld2)+'",' + ;
             ALLTRIM(fld3)+':'+ALLTRIM(STR(width3))+':H="'+EVALUATE('B'+fld3)+'",' + ;
             ALLTRIM(fld4)+':'+ALLTRIM(STR(width4))+':H="'+EVALUATE('B'+fld4)+'",' + ;
             ALLTRIM(fld5)+':'+ALLTRIM(STR(width5))+':H="'+EVALUATE('B'+fld5)+'",' + ;
             ALLTRIM(fld6)+':'+ALLTRIM(STR(width6))+':H="'+EVALUATE('B'+fld6)+'",' + ;
             ALLTRIM(fld7)+':'+ALLTRIM(STR(width7))+':H="'+EVALUATE('B'+fld7)+'",' + ;
             ALLTRIM(fld8)+':'+ALLTRIM(STR(width8))+':H="'+EVALUATE('B'+fld8)+'",' + ;
             ALLTRIM(fld9)+':'+ALLTRIM(STR(width9))+':H="'+EVALUATE('B'+fld9)+'",' + ;
             ALLTRIM(fld10)+':'+ALLTRIM(STR(width10))+':H="'+EVALUATE('B'+fld10)+'",' + ;
             ALLTRIM(fld11)+':'+ALLTRIM(STR(width11))+':H="'+EVALUATE('B'+fld11)+'",' + ;
             ALLTRIM(fld12)+':'+ALLTRIM(STR(width12))+':H="'+EVALUATE('B'+fld12)+'"'

RETURN (rtrn_str)


* EOF - makelist()
*************************************************************
FUNCTION ExitMenu
PARAMETERS MenuPad
* menupad is taken from PAD() in calling "ON MENU"
* set memvar "browchoice" to assist in taking an action
* where a browse and system menu are simultaneously running
*

BrowChoice = 'NOCHOICE'
MenuChoice = menupad
KEYBOARD CHR(23)

return

* EOF - ExitMenu
*************************************************************
PROCEDURE zzShutDn
* Shut down menus, screens, gets, .....
* Restore settings to defaults
* Return to calling routine
*

POP MENU _MSYSMENU
MODIFY WINDOW SCREEN

SET PROCEDURE TO
CLOSE DATA
CLEAR

ON KEY
ON SHUTDOWN
ON ERROR
CLEAR WINDOWS
SET STATUS BAR ON
SET SYSMENU ON
SET SYSMENU TO DEFAULT
SET COLOR TO
SET HELP ON
SET ESCAPE ON

* Disable SalesBridge help file call to foxtools
=CALLFN(_nWinHelp,MAINHWND(),_cHlpFile,2,0)

@  0, 0 CLEAR
@  4, 0 SAY '  SalesBridge Shutdown Complete.......'
@  8, 0

CLEAR MEMO

RETURN

* EOF - PROCEDURE zzShutDn
*************************************************************
PROCEDURE PrgSusp
* THE routine to suspend the zz program
*

PUSH KEY                                && save key assignments
ON KEY                                  && clear keys
ON ERROR
SET SYSMENU TO DEFAULT

SUSPEND

POP KEY                                 && restore keys
ON ERROR DO zzerror WITH m.t_cWindow,'SalesBridge Message',ERROR(),MESSAGE(),MESSAGE(1),PROGRAM(),LINENO()

RETURN

* EOF - PrgSusp
*!*********************************************************************
PROCEDURE On_Key
* clear key definitions, use where "on key" would be used
* has extra key assignments for suspend, quit zzprogram, memory check....
*

IF NOT _Ok2Mod
  RETURN
ENDIF

ON KEY

SET FUNCTION f1 TO                      && turn off fkeys (no keyboard stuffing macros here)
SET FUNCTION f2 TO
SET FUNCTION f3 TO
SET FUNCTION f4 TO
SET FUNCTION f5 TO
SET FUNCTION f6 TO
SET FUNCTION f7 TO
SET FUNCTION f8 TO
SET FUNCTION f9 TO
SET FUNCTION f10 TO

ON KEY LABEL f1
ON KEY LABEL f2         KEYBOARD CHR(23)         && this will activate the picklist function from a "get"
ON KEY LABEL f3         KEYBOARD CHR(23)         && Ctrl-W...Save
ON KEY LABEL f4
ON KEY LABEL f5         KEYBOARD DTOC(DATE())
ON KEY LABEL f6         KEYBOARD '** ' + DTOC(DATE()) + ' ' + Time24(TIME()) + ' - ' + _Init + ' ' + CHR(13)

ON KEY LABEL f7
ON KEY LABEL f8
ON KEY LABEL f9         KEYBOARD CHR(23)  && Ctrl-W...Save
ON KEY LABEL f10        KEYBOARD CHR(25)  && Ctrl-Y...Blank out field
ON KEY LABEL rightmouse KEYBOARD CHR(13)  && simulate <Enter> key with right mouse button
ON KEY LABEL ctrl-q     RETURN TO MASTER
ON KEY LABEL ctrl-s     DO prgsusp

RETURN

* EOF - On_Key()

*************************************************************
PROCEDURE qFind
* Have user enter keys to SEEK record while in BROWSE
* The current index is used to SEEK
*

WAIT 'Type 1-4 Characters' WINDOW NOWAIT TIMEOUT 4

SrchStr = ''
UsrKey1 = 0
UsrKey2 = 0
UsrKey3 = 0
UsrKey4 = 0
UsrChr1 = ''
UsrChr2 = ''
UsrChr3 = ''
UsrChr4 = ''

UsrKey1 = INKEY(4)

IF UsrKey1 <> 0
   UsrChr1 = UPPER(CHR(UsrKey1))
   UsrKey2 = INKEY(1.5)
ELSE
   RETURN
ENDIF
IF UsrKey2 <> 0
   UsrChr2 = UPPER(CHR(UsrKey2))
   UsrKey3 = INKEY(1.5)
ENDIF
IF UsrKey3 <> 0
   UsrChr3 = UPPER(CHR(UsrKey3))
   UsrKey4 = INKEY(1.5)
ENDIF
IF UsrKey4 <> 0
   UsrChr4 = UPPER(CHR(UsrKey4))
ENDIF

SrchStr = UsrChr1+UsrChr2+UsrChr3+UsrChr4

SrchStr = ALLTRIM(SrchStr)

SEEK SrchStr

RETURN

* EOF() - qFind
*************************************************************
FUNCTION Time24
PARAMETERS TheTime
* Convert military-style time to 12 hour am/pm time
*

RtrnTime = ''
nHour    = VAL(SUBSTR(TheTime,1,2))

* convert numeric hours from 12-23 -> 1-11 pm
IF nHour > 12
  nHour    = nHour - 12
  cHour    = ALLTRIM(STR(nHour))
  RtrnTime = cHour + SUBSTR(TheTime,3) + 'pm '
ELSE
  RtrnTime = TheTime + 'am '
ENDIF

RETURN (RtrnTime)

* EOF() Time24
*************************************************************
PROCEDURE zzHelp
* call WinHelp to access SalesBridge help file
* listed in zzdata.dbf
*

=CALLFN(_nWinHelp,MAINHWND(),_cHlpFile,1,_TopicNo)

RETURN

* EOF - zzHelp
*************************************************************
PROCEDURE mLog
PARAMETER cEvent, cTaskAlias
*
* BROWSE window for error log
*

PRIVATE nArraySize

SELECT 0
IF NOT USED('zzError')
  * Use AGAIN in case another task, or BROWSE, has file open
  * under a different alias name.
  USE (LOCFILE('zzError','DBF','Where is zzError.dbf?'));
      EXCLUSIVE IN 0 AGAIN ALIAS zzError
ENDIF
SELECT zzError

IF NOT EMPTY(DBF())
  m._nBrow = IIF( m._nBrow > 12, 5, m._nBrow + 1)
  m._nBcol = IIF( m._nBcol > 20, 10, m._nBcol + 2)
  DEFINE WINDOW bwin FROM m._nBrow,m._nBcol SIZE 18,78 ;
         TITLE 'Message Log' ;
         FONT 'MS Sans Serif',8 STYLE 'B' ;
         FLOAT SHADOW CLOSE MINIMIZE ZOOM ;
         SYSTEM GROW COLOR SCHEME 8
  BROWSE WINDOW bwin NOMODIFY
  RELEASE WINDOW bwin

  * Add work area to list
  * disabled pds 10/94 to close dbf after use!
  *m.nArraySize = ALEN(_aBrowse, 1) + 1
  *DIMENSION _aBrowse[m.nArraySize,2]
  *_aBrowse[m.nArraySize,kWinName] = WONTOP()
  *_aBrowse[m.nArraySize,kWorkarea] = SELECT()

  IF zzCntnue('Do you want to DELETE all log records?')
    ZAP
  ELSE
    * continue
  ENDIF

  USE

ENDIF

* EOF - mlog
*************************************************************
PROCEDURE MastStru
PARAMETER cEvent, cTaskAlias
*
* BROWSE window for Master Structure dbf 
*

PRIVATE nArraySize

SELECT 0

IF NOT USED('zzSmast')
  * Use AGAIN in case another task, or BROWSE, has file open
  * under a different alias name.
  USE (LOCFILE('zzSmast','DBF','Where is zzSmast.dbf?'));
      EXCLUSIVE IN 0 AGAIN ALIAS zzSmast
ENDIF
SELECT zzSmast

IF NOT EMPTY(DBF())
  m._nBrow = IIF( m._nBrow > 12, 5, m._nBrow + 1)
  m._nBcol = IIF( m._nBcol > 20, 10, m._nBcol + 2)
  DEFINE WINDOW bwin FROM m._nBrow,m._nBcol SIZE 18,78 ;
         TITLE 'User Defined Fields' ;
         FONT 'MS Sans Serif',8 STYLE 'B' ;
         FLOAT SHADOW CLOSE MINIMIZE ZOOM ;
         SYSTEM GROW COLOR SCHEME 8
  BROWSE WINDOW bwin
  RELEASE WINDOW bwin

  * Add work area to list
  * disabled pds 11/94 to close dbf after use!
  * Uncomment out to leave file open
  
  *m.nArraySize = ALEN(_aBrowse, 1) + 1
  *DIMENSION _aBrowse[m.nArraySize,2]
  *_aBrowse[m.nArraySize,kWinName] = WONTOP()
  *_aBrowse[m.nArraySize,kWorkarea] = SELECT()
  
  USE
  
ENDIF

RETURN

* EOF - MastStru
*************************************************************
PROCEDURE ModiStru
* Modify structure of any closed database
*

SET EXCLUSIVE ON
SELECT 0
USE ? EXCLUSIVE
MODIFY STRUCTURE
USE
SET EXCLUSIVE OFF

RETURN

* EOF - ModiStru
***************************************************************************
FUNCTION Pw_Entrd
* open zzp.dbf
* fields: fldn = user name
* fields: fldp = user password
* fields: _Ok2xxx = different user privilages, see zzInit.prg
*

* Init info from user passwords/Security file
* See proc "ChkPword" below for descriptions of each memvar
*

* Underline global memvars, all others are closed
* at the start of each window procedure
PUBLIC _Ok2Zap,_Ok2Add,_Ok2Mod,_Ok2Del,_Ok2Rpt,_Ok2Qck
PUBLIC _Ok2Lbl,_Ok2Flt,_Ok2Edt,_Ok2Ndx,_Ok2Imp,_Ok2Exp,_Ok2All
PUBLIC _Name,_PWord,_Init
PUBLIC _Owner

_Ok2Zap = .T.
_Ok2Add = .T.
_Ok2Mod = .T.
_Ok2Del = .T.
_Ok2Rpt = .T.
_Ok2Lbl = .T.
_Ok2Flt = .T.
_Ok2Edt = .T.
_Ok2Ndx = .T.
_Ok2Imp = .T.
_Ok2Exp = .T.
_Ok2All = .T.
_Ok2Qck = .T.

_Name   = ''
_PWord  = ''
_Init   = ''

_Owner  = ''

* Check for password protect flag, keep behind _xxx memvar initialization!
IF .NOT. _Pprotect
  RETURN .T.
ENDIF

Rtrn_Val = .F.

DEFINE WINDOW password FROM 8,20 TO 26,60 ;
   TITLE  ' SalesBridge User Log On ' ;
   FONT 'Times New Roman', 10 ;
   STYLE 'B' ;
   FLOAT ;
   NOCLOSE ;
   NOMINIMIZE ;
   DOUBLE
ACTIVATE WINDOW password

sv_dbf = ALIAS(SELECT())

IF NOT USED('zzP')
  USE (LOCFILE('zzP','DBF','Where is the security file?'));
      IN 0 AGAIN ALIAS zzP
ENDIF
SELECT zzP

m_name     = SPACE(20)
db_pass    = SPACE(10)
m_password = SPACE(10)
pw_counter = 0

@  1, 1 SAY 'Enter your name now.'
@  2, 1 SAY 'Press <Esc> to quit SalesBridge'
@  4, 1 SAY 'Name....:' GET m_name PICTURE 'XXXXXXXXXXXXXXXXXXXX';
   VALID chkpword() ERROR 'Name incorrect, try again'
READ

IF LASTKEY() = 27
   DEACTIVATE WINDOW password
ENDIF

@  1, 1 SAY 'Enter your password '
@  6, 1 SAY 'Password:'
dcol = COL()

ACTIVATE WINDOW password

FOR nn = 1 TO 4                         && only allow 4 attempts
   rtrn_val = .F.
   DO pw_dots WITH 6, dcol, LEN(m_password)
   IF ALLTRIM(m_password) == ALLTRIM(db_pass) .OR. LASTKEY() = 27
      rtrn_val = .T.
      @  0, 0 CLEAR
      EXIT
   ELSE
      @  7, 1 SAY 'Password incorrect, try again'
      =INKEY(0)
      @  7, 1 CLEAR
      m_password = SPACE(10)
      LOOP
   ENDIF
ENDFOR  && endfor nn

DEACTIVATE WINDOW password

IF LASTKEY() = 27 .OR. .NOT. rtrn_val
   * Quit SalesBridge
   DO zzShutDn
   ON SHUTDOWN
   CANCEL
   rtrn_val = .F.
ENDIF

USE

SELECT A

RELEASE pword

* Turn off all keys if user does not have access to modify data
IF .NOT. _Ok2Mod
  DO Keys_Off
ENDIF

RETURN (rtrn_val)

* - EOF pw_entrd()
*******************************************************************
*!*********************************************************************
*!
*!      Procedure: CHKPWORD
*!
*!      Called by: PW_ENTRD           (procedure in ZZPROC.PRG)
*!
*!*********************************************************************
FUNCTION ChkPword
* Check to see if password entered by user
* exists in zzP.dbf
*

GO TOP
LOCATE FOR (FldN = m_Name)              && no index needed for small file, also i

IF FOUND()
  DB_Pass     = FldP      && user must enter this password
  _Init       = FldI      && user initials, used in Notes, last update...
  _Name       = FldN      && user name
  _Ok2Zap     = Ok2Zap    && OK to Alter dbf file structures Etc.
  _Ok2Add     = Ok2Add    && OK to Add records
  _Ok2Mod     = Ok2Mod    && OK to Modify records
  _Ok2Del     = Ok2Del    && OK to Delete records
  _Ok2Rpt     = Ok2Rpt    && OK to Access Report Writer
  _Ok2Lbl     = Ok2Lbl    && OK to Access Mailing labels
  _Ok2Flt     = Ok2Flt    && OK to Modify Filter List
  _Ok2Edt     = Ok2Edt    && OK to Use text Editor
  _Ok2Ndx     = Ok2Ndx    && OK to Use Index Files
  _Ok2Imp     = Ok2Imp    && OK to Use Import cust records
  _Ok2Exp     = Ok2Exp    && OK to Use Export cust records
  _Ok2All     = Ok2All    && OK access ALL non-owned records
  _Ok2Qck     = Ok2Qck    && OK to access quick edit window
  * Initials become the "Owner" filter string
  * Placed before _Filt in zzfilt,zzrpts,zzlbls, and zzrepl.prg,
  * if _Ok2All = .F. (That limits user access to 
  * only that person's records!)
  _Owner    = ALLTRIM(FldI)

  RETURN (.T.)

ELSE

  RETURN (.F.)

ENDIF

* EOF - ChkPword()
*******************************************************************************
PROCEDURE Keys_Off
* Turn off keys to block end user input
*

PUBLIC _NoKey
_NoKey = ''

ON KEY LABEL a KEYBOARD _NoKey
ON KEY LABEL b KEYBOARD _NoKey
ON KEY LABEL c KEYBOARD _NoKey
ON KEY LABEL d KEYBOARD _NoKey
ON KEY LABEL e KEYBOARD _NoKey
ON KEY LABEL f KEYBOARD _NoKey
ON KEY LABEL g KEYBOARD _NoKey
ON KEY LABEL h KEYBOARD _NoKey
ON KEY LABEL i KEYBOARD _NoKey
ON KEY LABEL j KEYBOARD _NoKey
ON KEY LABEL k KEYBOARD _NoKey
ON KEY LABEL l KEYBOARD _NoKey
ON KEY LABEL m KEYBOARD _NoKey
ON KEY LABEL n KEYBOARD _NoKey
ON KEY LABEL o KEYBOARD _NoKey
ON KEY LABEL p KEYBOARD _NoKey
ON KEY LABEL q KEYBOARD _NoKey
ON KEY LABEL r KEYBOARD _NoKey
ON KEY LABEL s KEYBOARD _NoKey
ON KEY LABEL t KEYBOARD _NoKey
ON KEY LABEL u KEYBOARD _NoKey
ON KEY LABEL v KEYBOARD _NoKey
ON KEY LABEL w KEYBOARD _NoKey
ON KEY LABEL x KEYBOARD _NoKey
ON KEY LABEL y KEYBOARD _NoKey
ON KEY LABEL z KEYBOARD _NoKey

ON KEY LABEL A KEYBOARD _NoKey
ON KEY LABEL B KEYBOARD _NoKey
ON KEY LABEL C KEYBOARD _NoKey
ON KEY LABEL D KEYBOARD _NoKey
ON KEY LABEL E KEYBOARD _NoKey
ON KEY LABEL F KEYBOARD _NoKey
ON KEY LABEL G KEYBOARD _NoKey
ON KEY LABEL H KEYBOARD _NoKey
ON KEY LABEL I KEYBOARD _NoKey
ON KEY LABEL J KEYBOARD _NoKey
ON KEY LABEL K KEYBOARD _NoKey
ON KEY LABEL L KEYBOARD _NoKey
ON KEY LABEL M KEYBOARD _NoKey
ON KEY LABEL N KEYBOARD _NoKey
ON KEY LABEL O KEYBOARD _NoKey
ON KEY LABEL P KEYBOARD _NoKey
ON KEY LABEL Q KEYBOARD _NoKey
ON KEY LABEL R KEYBOARD _NoKey
ON KEY LABEL S KEYBOARD _NoKey
ON KEY LABEL T KEYBOARD _NoKey
ON KEY LABEL U KEYBOARD _NoKey
ON KEY LABEL V KEYBOARD _NoKey
ON KEY LABEL W KEYBOARD _NoKey
ON KEY LABEL X KEYBOARD _NoKey
ON KEY LABEL Y KEYBOARD _NoKey
ON KEY LABEL Z KEYBOARD _NoKey

ON KEY LABEL 0 KEYBOARD _NoKey
ON KEY LABEL 1 KEYBOARD _NoKey
ON KEY LABEL 2 KEYBOARD _NoKey
ON KEY LABEL 3 KEYBOARD _NoKey
ON KEY LABEL 4 KEYBOARD _NoKey
ON KEY LABEL 5 KEYBOARD _NoKey
ON KEY LABEL 6 KEYBOARD _NoKey
ON KEY LABEL 7 KEYBOARD _NoKey
ON KEY LABEL 8 KEYBOARD _NoKey
ON KEY LABEL 9 KEYBOARD _NoKey

ON KEY LABEL F1  KEYBOARD _NoKey
ON KEY LABEL F2  KEYBOARD _NoKey
ON KEY LABEL F3  KEYBOARD _NoKey
ON KEY LABEL F4  KEYBOARD _NoKey
ON KEY LABEL F5  KEYBOARD _NoKey
ON KEY LABEL F6  KEYBOARD _NoKey
ON KEY LABEL F7  KEYBOARD _NoKey
ON KEY LABEL F8  KEYBOARD _NoKey
ON KEY LABEL F9  KEYBOARD _NoKey
ON KEY LABEL F10 KEYBOARD _NoKey
ON KEY LABEL F11 KEYBOARD _NoKey
ON KEY LABEL F12 KEYBOARD _NoKey

ON KEY LABEL SHIFT+F1  KEYBOARD _NoKey
ON KEY LABEL SHIFT+F2  KEYBOARD _NoKey
ON KEY LABEL SHIFT+F3  KEYBOARD _NoKey
ON KEY LABEL SHIFT+F4  KEYBOARD _NoKey
ON KEY LABEL SHIFT+F5  KEYBOARD _NoKey
ON KEY LABEL SHIFT+F6  KEYBOARD _NoKey
ON KEY LABEL SHIFT+F7  KEYBOARD _NoKey
ON KEY LABEL SHIFT+F8  KEYBOARD _NoKey
ON KEY LABEL SHIFT+F9  KEYBOARD _NoKey
ON KEY LABEL SHIFT+F10 KEYBOARD _NoKey
ON KEY LABEL SHIFT+F11 KEYBOARD _NoKey
ON KEY LABEL SHIFT+F12 KEYBOARD _NoKey

ON KEY LABEL ALT+F1  KEYBOARD _NoKey
ON KEY LABEL ALT+F2  KEYBOARD _NoKey
ON KEY LABEL ALT+F3  KEYBOARD _NoKey
ON KEY LABEL ALT+F4  KEYBOARD _NoKey
ON KEY LABEL ALT+F5  KEYBOARD _NoKey
ON KEY LABEL ALT+F6  KEYBOARD _NoKey
ON KEY LABEL ALT+F7  KEYBOARD _NoKey
ON KEY LABEL ALT+F8  KEYBOARD _NoKey
ON KEY LABEL ALT+F9  KEYBOARD _NoKey
ON KEY LABEL ALT+F10 KEYBOARD _NoKey
ON KEY LABEL ALT+F11 KEYBOARD _NoKey
ON KEY LABEL ALT+F12 KEYBOARD _NoKey

ON KEY LABEL CTRL+F1  KEYBOARD _NoKey
ON KEY LABEL CTRL+F2  KEYBOARD _NoKey
ON KEY LABEL CTRL+F3  KEYBOARD _NoKey
ON KEY LABEL CTRL+F4  KEYBOARD _NoKey
ON KEY LABEL CTRL+F5  KEYBOARD _NoKey
ON KEY LABEL CTRL+F6  KEYBOARD _NoKey
ON KEY LABEL CTRL+F7  KEYBOARD _NoKey
ON KEY LABEL CTRL+F8  KEYBOARD _NoKey
ON KEY LABEL CTRL+F9  KEYBOARD _NoKey
ON KEY LABEL CTRL+F10 KEYBOARD _NoKey
ON KEY LABEL CTRL+F11 KEYBOARD _NoKey
ON KEY LABEL CTRL+F12 KEYBOARD _NoKey

ON KEY LABEL SPACEBAR KEYBOARD _NoKey
ON KEY LABEL DEL      KEYBOARD _NoKey
ON KEY LABEL TAB      KEYBOARD _NoKey

ON KEY LABEL !        KEYBOARD _NoKey
ON KEY LABEL @        KEYBOARD _NoKey
ON KEY LABEL #        KEYBOARD _NoKey
ON KEY LABEL $        KEYBOARD _NoKey
ON KEY LABEL %        KEYBOARD _NoKey
ON KEY LABEL ^        KEYBOARD _NoKey
ON KEY LABEL &        KEYBOARD _NoKey
ON KEY LABEL *        KEYBOARD _NoKey
ON KEY LABEL (        KEYBOARD _NoKey
ON KEY LABEL )        KEYBOARD _NoKey
ON KEY LABEL -        KEYBOARD _NoKey
ON KEY LABEL _        KEYBOARD _NoKey
ON KEY LABEL +        KEYBOARD _NoKey
ON KEY LABEL =        KEYBOARD _NoKey
ON KEY LABEL '['      KEYBOARD _NoKey
ON KEY LABEL ']'      KEYBOARD _NoKey
ON KEY LABEL {        KEYBOARD _NoKey
ON KEY LABEL }        KEYBOARD _NoKey
ON KEY LABEL ;        KEYBOARD _NoKey
ON KEY LABEL :        KEYBOARD _NoKey
ON KEY LABEL "'"      KEYBOARD _NoKey
ON KEY LABEL '"'      KEYBOARD _NoKey
ON KEY LABEL <        KEYBOARD _NoKey
ON KEY LABEL >        KEYBOARD _NoKey
ON KEY LABEL ','      KEYBOARD _NoKey
ON KEY LABEL '.'      KEYBOARD _NoKey
ON KEY LABEL /        KEYBOARD _NoKey
ON KEY LABEL ?        KEYBOARD _NoKey
ON KEY LABEL \        KEYBOARD _NoKey
ON KEY LABEL |        KEYBOARD _NoKey

RETURN

* EOF - Keys_Off
*******************************************************************************
*!*********************************************************************
*!
*!      Procedure: PW_DOTS
*!
*!      Called by: PW_ENTRD           (procedure in ZZPROC.PRG)
*!
*!               : PRGSUSP            (procedure in ZZPROC.PRG)
*!
*!*********************************************************************
PROCEDURE Pw_Dots
PARAMETERS pw_row, pw_col, pw_len
* Display character to indicate user password letters entered
*

IF LASTKEY() = 27
  RETURN
ENDIF

PRIVATE Password, dRow, dCol, dLen, Old_Color, Old_Cursor

Old_Cursor = SET([cursor],1)

SET CURSOR OFF

Password = ""
dRow     = Pw_Row
dCol     = Pw_Col
dLen     = Pw_Len

@ dRow,dCol SAY "[" + SPACE(dLen) + "     ]"

FOR y = 1 TO dLen
   
   KeyPress = INKEY(0)
   
   DO CASE
      
   CASE LASTKEY() = 27                  && <esc>
      SET CURSOR &old_cursor.
      RETURN
      
   CASE LASTKEY() = 19 .OR. LASTKEY() = 8 .OR. LASTKEY() =127   && <L-arrow>, <delete>, or <b-space>
      IF y < 2
         y = 0
      ELSE
         y = y - 2
         Password = SUBSTR(Password,1,y)
         @ dRow,dCol+y+1 SAY " " COLOR N/N,N/N
      ENDIF
      
   CASE LASTKEY() = 13                  && <enter> - password is entered...
      EXIT
      
   OTHERWISE
      Password = Password + CHR(KeyPress)
      @ dRow,dCol+y SAY "*" COLOR GR+/N
      
   ENDCASE
   
ENDFOR

m_Password = Password

RELEASE Temp

SET CURSOR &old_cursor.

RETURN

* EOF - Pw_Dots

*************************************************************
*************************************************************
* Start of event driven programming routines
*************************************************************
*************************************************************


*************************************************************
FUNCTION wLaunch
PARAMETER cTaskName
*
* Called by selecting a bar from the task menu pad.
*
* Sets task name to launch and executes a CLEAR READ. This
* causes any active task READ to terminate as soon as
* the menu processing routine is complete and also requests
* that the foundation READ be teminated.  The active 
* task level READ terminates first and control passes back 
* to the foundation READ. Since it has also been CLEARed, it
* executes its VALID routine. This VALID routine, noting that 
* the global variable "m._cLaunchMe" has been assigned a 
* value, launches the new task program.
*

* If you want use the shift key to decide whether to launch a
* new instance or re-activate an existing instance, check and
* save the state of the shift key at this point (a C or
* assembler routine is required to do this). If this flag is 
* set (.t.) wDispatch will pass 'LAUNCH-NEW' to the task 
* program to tell it to start a new instance.

M._bforcenew = .T.

m._cLaunchMe = m.cTaskName

IF WREAD(WONTOP())
  IF NOT wClearRead()
    m._cLaunchMe = ''
    RETURN .F.
  ENDIF
ELSE
  DO _wWakeUp
ENDIF

RETURN .T.

* EOF - FUNCTION wLaunch
*************************************************************
FUNCTION wDispatch
*
* Foundation READ VALID handler.
*
* The Foundation READ terminates when this routine returns .T.
* As long as it returns .F., execution of the Foundation READ 
* will continue.
*

PRIVATE cTaskName, cTopWin

IF _Wall <> _svWall OR _ReStart
  * Re-Start SalesBridge zz.prg if desired
  RETURN .T.
ENDIF

* Set this value to the minimum memory required for your
* task programs to run.
#DEFINE kMinMemory 0

* Clean up after Closed stand-alone browse windows.
*DO _wFixBrowse

* Keep our READ wakeup workaround window out of sight.
IF WEXIST('FoxWakeUp_')
  HIDE WINDOW FoxWakeUp_
ENDIF

* Launch a new task if requested, or activate topmost window.
IF NOT EMPTY(m._cLaunchMe)
  * If low on memory, we can clear all the GETs here. Doing 
  * this means task windows will need to re-draw next time
  * they are activated. It also means output from 'UPDATE' 
  * events to inactive windows will not be displayed until 
  * the window's task program is reactivated.
  IF VAL(SYS(1001)) - VAL(SYS(1016)) < kMinMemory
    * Clear all GETs for all tasks
    CLEAR GETS

    * Now that the GETs are gone, we can physically release all
    * closed task windows, which previously were only hidden.
    m.cTopWin = WCHILD('',0)
    DO WHILE NOT EMPTY(m.cTopWin )
      IF NOT WVISIBLE(m.cTopWin)
        RELEASE WINDOW (m.cTopWin)
      ENDIF
      m.cTopWin = WCHILD('',1)
    ENDDO

    * If still not enough memory, abort gracefully.
    IF VAL(SYS(1001)) - VAL(SYS(1016)) < kMinMemory
      DO zzwarn WITH "Launch Task", ;
                   "Not enough memory to launch " + m._cLaunchMe
      m._cLaunchMe = ""
      RETURN .F.
    ENDIF
  ENDIF

  * Launch first or new instance of a task.
  m.cTaskName = m._cLaunchMe
  m._cLaunchMe = ''
  DO &cTaskName WITH ;
    IIF(m._bforcenew, 'LAUNCH-NEW', 'LAUNCH'), m.cTaskName
ELSE
  * Activate window explicitly requested by wActivate().
  IF NOT EMPTY(m._cActivate)
    ACTIVATE WINDOW (m._cActivate)
    m._cActivate = ""
  ENDIF

  * Get task name associated with topmost window.
  m.cTaskName = wWinTask( WONTOP() )

  * If task name is empty, this is a system window. In that 
  * case we do nothing, and let this routine return to the 
  * foundation READ, where FoxPro will start the code to
  * drive the window.
  IF NOT EMPTY( m.cTaskName )
    * Activate the task program associated with topmost window.
    DO (m.cTaskName) WITH 'ACTIVATE', wWinAlias(WONTOP())
  ENDIF
ENDIF

* Common task cleanup code can go here.
* Restore FoxPro's default field undo command
DO _wFixUndo

* Interrupted GETs must be dealt with before this point.
IF m._bRIP
  m._bRIP = .F.
  DO zzwarn WITH 'Coding Error', ;
    'Read-In-Progress not properly handled'
ENDIF

* Clear manually implimented READ and GET clauses.
m._cDeactExp = '.T.'    && READ deactivate expression.
m._cGetValid = '.T.'    && Common GET valid expression.
m._cFrmValid = '.T.'    && Form level valid expression.

* Process a shutdown request.
DO WHILE m._bShutdown AND NOT EMPTY(WONTOP())
  m.cTopWin = WONTOP()

  * Get task name associated with topmost window.
  m.cTaskName = wWinTask(m.cTopWin)
  IF EMPTY(m.cTaskName)
    * No task name means this is a system window - release it.
    RELEASE WINDOW (m.cTopWin)
  ELSE
    * Send a shutdown request to the window's task program.
    m._bShutdown = EVALUATE( m.cTaskName ;
                  + '("CLOSE", wWinAlias(m.cTopWin) )' )
  ENDIF

  * If the same window is still there, something is wrong.
  * Cancel the shutdown request.
  IF WONTOP() == m.cTopwin
    m._bShutdown = .F.
  ENDIF
ENDDO

* Clear outstanding GETs whenever all task windows close.
IF m._nMaxWind = 0
  CLEAR GETS
  CLEAR WINDOWS
ENDIF

* If this is the last time we are called, clear the shutdown handler
IF m._bShutdown
  ON SHUTDOWN
ENDIF

RETURN m._bShutdown

* EOF - FUNCTION wDispatch
*************************************************************
PROCEDURE wHelp
PARAMETER cEvent, cTaskAlias
*
* Launch the Help System window, from the help menu option.
* Not used as of 10/94 pds

* Insert code here to examine WONTOP() in order to provide
* context sensitive help.  For demonstration purposes, we
* just call the regular Fox help window.

HELP NOWAIT
RETURN

* EOF - PROCEDURE wHelp
*************************************************************
PROCEDURE wTextEdit
PARAMETER cEvent, cTaskAlias
*
* Text editor window - once started, it behaves like 
* a Desk Accessory.
*

MODI FILE ? NOWAIT
RETURN

* EOF - PROCEDURE wTextEdit
*************************************************************
PROCEDURE wTextView
PARAMETER cEvent, cTaskAlias
*
* Text file viewing window - once started, it behaves like 
* a Desk Accessory.
*

MODI FILE ? NOEDIT NOWAIT
RETURN

* EOF - PROCEDURE wTextView
*************************************************************
PROCEDURE wBrowse
PARAMETER cEvent, cTaskAlias
*
* Generic BROWSE window. Edit OK
*

PRIVATE nArraySize

* Ask the user for a table to browse through
SELECT 0
USE ?

IF NOT EMPTY(DBF())
  m._nBrow = IIF( m._nBrow > 12, 5, m._nBrow + 1)
  m._nBcol = IIF( m._nBcol > 20, 10, m._nBcol + 2)
  DEFINE WINDOW bwin FROM m._nBrow,m._nBcol SIZE 10,75 ;
         FONT 'MS Sans Serif',8 STYLE 'B' ;
         FLOAT SHADOW CLOSE MINIMIZE ZOOM ;
         SYSTEM GROW COLOR SCHEME 8
  BROWSE WINDOW bwin
  RELEASE WINDOW bwin

  * Add work area to list
  * disabled as of 10/93 to allow dbf file close before exit
  * insert "NOWAIT" after "BROWSE" above to enable this feature
  * also un-comment next 4 lines and comment out "USE"
  
  *m.nArraySize = ALEN(_aBrowse, 1) + 1
  *DIMENSION _aBrowse[m.nArraySize,2]
  *_aBrowse[m.nArraySize,kWinName] = WONTOP()
  *_aBrowse[m.nArraySize,kWorkarea] = SELECT()
  
  USE
  
ENDIF

* EOF - PROCEDURE wBrowse
*************************************************************
PROCEDURE wDbfView
PARAMETER cEvent, cTaskAlias
*
* Generic BROWSE window - once started, it behaves like 
* a Desk Accessory. NO edit
*

PRIVATE nArraySize

* Ask the user for a table to browse through
SELECT 0
USE ?

IF NOT EMPTY(DBF())
  m._nBrow = IIF( m._nBrow > 12, 5, m._nBrow + 1)
  m._nBcol = IIF( m._nBcol > 20, 10, m._nBcol + 2)
  DEFINE WINDOW bwin FROM m._nBrow,m._nBcol SIZE 10,75 ;
         FONT 'MS Sans Serif',8 STYLE 'B' ;
         FLOAT SHADOW CLOSE MINIMIZE ZOOM ;
         SYSTEM GROW COLOR SCHEME 8
  BROWSE WINDOW bwin NOMODIFY
  RELEASE WINDOW bwin

  * Add work area to list
  * disabled as of 10/93 to allow dbf file close before exit
  * insert "NOWAIT" after "BROWSE" above to enable this feature
  * also un-comment next 4 lines and comment out "USE"

  *m.nArraySize = ALEN(_aBrowse, 1) + 1
  *DIMENSION _aBrowse[m.nArraySize,2]
  *_aBrowse[m.nArraySize,kWinName] = WONTOP()
  *_aBrowse[m.nArraySize,kWorkarea] = SELECT()
  
  USE
  
ENDIF

* EOF - PROCEDURE wDbfView
*************************************************************
FUNCTION wNewTask
PARAMETERS cTaskName
*
* Parameters:
*   cTaskName - Full name of program to run for this app. 
*              Includes path and extension if needed.
*
* Returns:
*   A unique task alias for this instance of the task.
*   This alias is used by other window management routines to
*   identify this particular instance of the task window.
*

PRIVATE cTaskAlias

IF INLIST(m.cTaskName,'1_','2_','3_','4_','5_','6_','7_','8_','9_')
  RETURN m.cTaskName
ENDIF
* Alias name is an instance digit plus task name. Note
* that this naming technique will only work for up to nine
* instances of a task window open at any one time.
m.cTaskAlias = '1_' + UPPER(m.cTaskName)

* Increment first char of alias name (the '1') until unique.
DO WHILE ASCAN( _aWindows,m.cTaskAlias ) > 0
  m.cTaskAlias = STUFF( m.cTaskAlias,1,1, ;
                 CHR( ASC(m.cTaskAlias) + 1 ) )
ENDDO

* Naming scheme only allows up to 9 valid names.
* Switch to using letters to support up to 26 names.
IF LEFT(m.cTaskAlias,1) > '9'
  DO zzwarn WITH 'Launch Task '+UPPER(m.cTaskName), ;
    'Too many instances already open'
  RETURN ''
ELSE
  RETURN m.cTaskAlias
ENDIF

* EOF - FUNCTION wNewTask
*************************************************************
FUNCTION wAddWin
PARAMETERS cTaskAlias, cWinName, cWinTitle
*
* Purpose:
*   1. Generates unique window names for multiple instance
*      support.
*   2. Defines the window
*   3. Associates window names with task program name.
*   4. Adds windows to Window popup menu bar.
*
*   Only READ windows can be registered with this routine, 
*   because we depend on the READ DEACTIVATE clause to remove 
*   the window from the list when it is closed. There is no 
*   foolproof way to tell when non-READ windows are closed.
*
* Returns:
*   A unique window name to use for this instance of the
*   task.
*

* Make sure the window name is unique. Window name is
* constructed from first 9 characters of supplied name, 
* plus the instance digit from the task alias.

IF NOT EMPTY( m.cWinName )
  m.cWinName = LEFT( m.cWinName,9 ) + LEFT( m.cTaskAlias,1 )
ELSE
  * If specified window name is empty, use Title.
  m.cWinName = m.cWinTitle
ENDIF

m._nMaxWind = m._nMaxWind + 1
DIMENSION _aWindows[_nMaxWind,3]

_aWindows[m._nMaxWind,kTaskAlias] = UPPER( m.cTaskAlias )
_aWindows[m._nMaxWind,kWinName] = UPPER( m.cWinName )
_aWindows[m._nMaxWind,kWinTitle] = m.cWinTitle ;
  + IIF(m.cTaskAlias = '1', '', ' ('+LEFT(m.cTaskAlias,1)+')')

* Define window - caller will move and size it later. If
* window was already open in this session, the definition will
* still be there - don't redefine it.
IF NOT WEXIST( m.cWinName )
  DEFINE WINDOW (m.cWinName) ;
    TITLE _aWindows[m._nMaxWind,kWinTitle] ;
    FROM 1,1 TO 5,5 ;
    SYSTEM SHADOW FLOAT MINIMIZE GROW ;
    COLOR RGB(,,,192,192,192)
ENDIF

* Keep the window array sorted by window Title.
* This sort is the reason we keep title stored in the array.

=ASORT(_aWindows,kWinTitle)

* Rebuild the Window popup now to include the new window.

DO _wPopup

* Return the generated window name to caller.
RETURN UPPER( m.cWinName )

* EOF - FUNCTION wAddWin
*************************************************************
PROCEDURE wDelTask
PARAMETER cTaskAlias
*
* Remove all of a task's windows from Window popup and
* our internal list of active tasks.
*
* The task level READ must be terminated before calling this.
*

PRIVATE ix

* Make sure all intra-sytem locks for this task are cleared.
DO wUnlock WITH m.cTaskAlias, ''
DO wListen WITH m.cTaskAlias, ''

ix = 1
DO WHILE ix <= m._nMaxWind
  IF _aWindows[ix,kTaskAlias] == m.cTaskAlias

    * Hide the window, and delete it from our list.
    HIDE WINDOW (_aWindows[ix,kWinName])
    =ADEL(_aWindows, ix)
    m._nMaxWind = m._nMaxWind - 1
  ELSE
    ix = ix + 1
  ENDIF
ENDDO

* Shrink the array to its new size
DIMENSION _aWindows[MAX(1,m._nMaxWind),3]

* Rebuild the Window popup now to reflect the changes.
DO _wPopup
RETURN

* EOF - PROCEDURE wDelTask
*************************************************************
FUNCTION wWinTask
PARAMETER cWinName
*
* Given a window name, return the task name that it is
* a part of. Uses Window array created by wAddApp
*

PRIVATE ix

* Search for window name. Do not use ASCAN, since it is
* possible (though not likely) that a window title may match 
* another window's name, and ASCAN cannot search only one 
* "column" of a 2 dimensional array.

FOR ix = 1 TO m._nMaxWind
  IF _aWindows[ix,kWinName] == cWinName
    RETURN SUBSTR( _aWindows[ix,kTaskAlias], 3 )
  ENDIF
ENDFOR

* Return NULL if not found - this is not a READ window.
RETURN ''

* EOF - FUNCTION wWinTask
*************************************************************
FUNCTION wWinAlias
PARAMETER cWinName
*
* Given a window name, return the task alias that it is a
* part of. Uses Window array created by wAddApp
*

PRIVATE ix

FOR ix = 1 TO m._nMaxWind
  IF _aWindows[ix,kWinName] == cWinName
    RETURN _aWindows[ix,kTaskAlias]
  ENDIF
ENDFOR

* Return NULL if not found - ie this is not a READ window.
RETURN ''

* EOF - FUNCTION wWinAlias
*************************************************************
FUNCTION wAliasWin
PARAMETER cTaskAlias
*
* Given a task alias, return the first window found that is
* part of that task. Uses Window array created by wAddApp.
*

PRIVATE ix

FOR ix = 1 TO m._nMaxWind
  IF _aWindows[ix,kTaskAlias] == cTaskAlias
    RETURN _aWindows[ix,kWinName]
  ENDIF
ENDFOR

* Return NULL string if not found - ie undefined alias.
RETURN ''

* EOF - FUNCTION wAliasWin
*************************************************************
FUNCTION wTaskWin
PARAMETER cTaskName
*
* Given a task name, return the topmost window found that is
* part of that task. Uses Window array created by wAddApp
*

PRIVATE ix

FOR ix = 1 TO m._nMaxWind
  IF SUBSTR(_aWindows[ix,kTaskAlias],3) == UPPER(cTaskName)
    RETURN _aWindows[ix,kWinName]
  ENDIF
ENDFOR

* Return NULL if not found - no windows for this task.
RETURN ''

* EOF - FUNCTION wTaskWin
*************************************************************
FUNCTION wCycle
*++
* Cycle to the next window - called from WINDOW menu popup.
*--

PRIVATE cNewWin

m.cNewWin = WCHILD('',0)
DO WHILE NOT WVISIBLE( m.cNewWin )
  m.cNewWin = WCHILD('',1)

  * We hit end of window list with no visible windows.
  IF EMPTY( m.cNewWin )
    RETURN .F.
  ENDIF
ENDDO
RETURN wActivate(m.cNewWin)

* EOF - FUNCTION wCycle
*************************************************************
FUNCTION wActivate
PARAMETER cNewWin
*
* Activate the specified window - called from WINDOW menu popup.
* If we are moving from a Non-READ window to a READ window, we
* need to issue a CLEAR READ to wake up the foundation READ.
*

IF WREAD(WONTOP())
  IF wRIPcheck()
    IF wWinAlias(WONTOP()) == wWinAlias(m.cNewWin)
      * Another window in same task - Fox can handle this by itself.
      ACTIVATE WINDOW (m.cNewWin)
    ELSE
      * New window not part of task, call deactivate & clear read.
      =EVALUATE(m._cDeactExp)
      CLEAR READ

      * Tell wDispatch() which window we want active next.
      m._cActivate = m.cNewWin
    ENDIF
  ELSE
    RETURN .F.
  ENDIF
ELSE
  ACTIVATE WINDOW (m.cNewWin)

  * If moving from system (non-READ) window to task (READ) window
  * we need to manually tell the foundation READ to wake up.
  IF NOT EMPTY(wWinTask(m.cNewWin))
    CLEAR READ
  ENDIF
ENDIF

* Restore the window to its normal size if it was minimized.
IF WMINIMUM(m.cNewWin)
  ZOOM WINDOW (m.cNewWin) NORM
ENDIF
RETURN .T.

* EOF - FUNCTION wActivate
*************************************************************
FUNCTION wShutdown
*
* Called when the QUIT menu selection is chosen, to trigger a 
* global shutdown.
*

m._bQuitFox = .F.
m._bShutdown = .T.
m._bShutdown = wClearRead()

RETURN .T.

* EOF - FUNCTION wShutdown
*************************************************************
FUNCTION wClose
*
* Close the current window - called from WINDOW menu popup.
* READ windows are 'Closed' by hiding them, which preserves
* the window contents, so if an error occurs, the window can 
* be redisplayed.
*

PRIVATE cTopWin

m.cTopwin = WONTOP()
IF NOT EMPTY( m.cTopwin )
  IF WREAD( m.cTopwin )
    * The HIDE command bypasses GET valid, so fix it.
    IF wRIPcheck() AND EVALUATE(m._cFrmValid)
      HIDE WINDOW (m.cTopwin)
    ELSE
      RETURN .F.
    ENDIF
  ELSE
    * Check for the special case of a task READ window
    * being on top with no active READ. This will happen when
    * a DA or browse window is closed via <esc> or close box.
    * If this is a task window, don't release it.
    IF EMPTY( wWinAlias(m.cTopwin) )
      * This is a system window - release it.
      RELEASE WINDOW (m.cTopwin)
  
      * If the system window could not release return False.
      IF WONTOP() == m.cTopwin
        RETURN .F.
      ENDIF
    ENDIF

    * Need to manually re-trigger Foundation valid clause after
    * releasing a system window.
    CLEAR READ
  ENDIF
ENDIF

RETURN .T.

* EOF - FUNCTION wClose
*************************************************************
FUNCTION wClearRead
*
* Clear the current READ level, but make sure the DEACTIVATE 
* expression gets evaluated first. This routine should be 
* called instead of a native CLEAR READ whenever a task
* READ window is active.
*

IF wRIPcheck()
  * If the current READ window has a deactivate expression, 
  * it must be evaluated before we can clear the READ.
  =EVALUATE( m._cDeactExp )

  CLEAR READ
  RETURN .T.
ENDIF
RETURN .F.

* EOF - FUNCTION wClearRead
*************************************************************
FUNCTION wRdLevel
*
* Use wRdLevel() instead of RDLEVEL() in your task programs so they
* will run properly if you decide to use to WinLib/Pro.
*

RETURN RDLEVEL()

* EOF - FUNCTION wRdLevel
*************************************************************
FUNCTION wBumper
PARAMETER nNewobj
*
* Routine to keep the cursor within the GET objects associated 
* with the current task window. This is the WHEN clause of 
* special invisible objects that are the first and last GET
* objects for each task. When the cursor gets to one of these 
* objects, we send it to the specified wrap object.  Always 
* returns False, so the special end 'bumper' objects
* never actualy become current.
*

* In the current version of FPW 2.5, _CUROBJ is ignored after a
* DEACTIVATE clause returns .F. and the first field in the form is
* read instead, which should always be a bumper object. If _bRIP is
* set, we know this just happened, so we go to the interupted field 
* instead of the specified wrap object.
_CUROBJ = IIF(m._bRIP, m._nCurObj, m.nNewobj)
RETURN .F.

* EOF - FUNCTION wBumper
*************************************************************
PROCEDURE wReadInit
PARAMETERS cDeactExp, cGetValid, cFormValid
*
* Store DEACTIVATE expression and common GET VALID handler to 
* be used for this READ session.
*

m._cDeactExp = IIF(EMPTY(m.cDeactExp), '.T.', m.cDeactExp)
m._cGetValid = IIF(EMPTY(m.cGetValid), '.T.', m.cGetValid)
m._cFrmValid = IIF(EMPTY(m.cFormValid),'.T.', m.cFormValid)
RETURN

* EOF - PROCEDURE wReadInit
*************************************************************
FUNCTION wGetWhen
PARAMETER cFldValid, cType
*
* Called by the WHEN clause of each GET field, to store
* initial value for undo.
*
* Store the name of the validation routine for this field, 
* for use by the field/read exit handler.
*
* Different datatypes supported, and functions performed are:
*	Type	          Sets RIP   Save Initial   Local Undo
*    'C' @GET char      Y          Y             Y
*    'N' @GET non-char  Y          Y             Y
*    'E' @Edit char     Y          Y             N
*    'K' Control        N          Y             N
*

* If no object type specified, assume regular GET text field.
m._cObjType = IIF( PARAMETERS()<2, 'C', m.cType )

* Controls can't set RIP - we can't force Validate them.
IF m._cObjType = 'K'
  m._xInitial = EVALUATE( VARREAD() )
ELSE
  IF NOT m._bRIP OR m._nCurObj <> _CUROBJ
    m._bRIP = .T.             && Set Read-In_Progress flag
    m._xInitial = EVALUATE( VARREAD() )
  ENDIF
ENDIF

m._nCurObj = _CUROBJ
m._cFldValid = IIF(EMPTY(m.cFldValid), ".T.", m.cFldValid)

* Set manual undo menu bar for @GET fields.
IF m._cObjType $ 'CN'
  IF GETBAR('_MEDIT', 1) # 1
    RELEASE BAR _MED_UNDO OF _MEDIT
    DEFINE BAR 1 OF _MEDIT PROMPT '\<Undo';
      BEFORE _MFIRST KEY CTRL+Z,'^Z' ;
      SKIP FOR NOT m._bRIP
    ON SELECTION BAR 1 OF _MEDIT DO wFldUndo WITH .T.
  ENDIF
ELSE
  DO _wFixUndo
ENDIF

RETURN .T.

* EOF - FUNCTION wGetWhen
*************************************************************
PROCEDURE wModalRead
PARAMETER cRealRead
*
* Clean up task menu and undo state, and issue a nested modal read
* for dialog boxes and alerts. This protects task level GETs from 
* a modal window's GETs.
*

PRIVATE nLastbar, cLastPop

* Tell the world we can't be disturbed.
m._bInModal = .T.

* Restore FoxPro's default field undo command
DO _wFixUndo

* Allow special access to help window from MODAL read window.
PUSH KEY
ON KEY LABEL F1 DO wHelp

* We only need nested READ construct at foundation READ level.
IF WREAD(WONTOP())
  * Deactivate any task specific menu pads, which may redirect
  * <escape> and ctrl-enter. Task specific menus go before the
  * Window pad for Windows style applications.
  m.nLastbar = GETBAR("_MSYSMENU",CNTBAR("_MSYSMENU")-2)
  m.cLastPop = PRMBAR("_MSYSMENU",m.nLastbar)

  * If the menu pad before Window is not a system pad, and not 
  * Sb's task pad, it's a custom menu that needs to be hidden.
  IF m.nLastbar > 0 AND UPPER(m.cLastPop) <> "TASK"
    PUSH MENU _MSYSMENU
    RELEASE BAR ALL OF (m.cLastPop)
    DEFINE BAR 1 OF (m.cLastPop) PROMPT " - Unavailable - "
    =EVALUATE(m.cRealRead)
    POP MENU _MSYSMENU
  ELSE
    =EVALUATE(m.cRealRead)
  ENDIF
ELSE
  * We are at foundation READ - nest the modal READ to protect
  * any task level GETs that may still be active.
  READ SAVE WHEN (EVALUATE(m.cRealRead) AND .F.)
ENDIF

POP KEY

* Tell the world we can can be interrupted again, and return.
m._bInModal = .F.
RETURN

* EOF - PROCEDURE wModalRead
*************************************************************
PROCEDURE wFldUndo
PARAMETER lSelectAll
*
* Reset @GET field to its initial value.
*

* Be sure to stay on the same object.
_CUROBJ = _CUROBJ

STORE m._xInitial TO (VARREAD())

* Need to manually redisplay data for cases when the READ will
* not be returned to because of a CLEAR READ.
SHOW OBJECT _CUROBJ

IF m.lSelectAll
  KEYBOARD '{CTRL+A}' PLAIN
ENDIF

RETURN

* EOF - PROCEDURE wFldUndo
*************************************************************
FUNCTION wGetValid
PARAMETER lMouseHit
*
* GET level valid routine driver.
*

IF LASTKEY() = 23 AND _Ok2Mod   && ctrl-w activated by F2 "Picklist"
  DO zzpick WITH m.t_cWindow,'List'
ENDIF

* Remember if field was mouse-terminated.
m._bMouse = m.lMouseHit

* Evaluate task specific GET valid handlers.
IF EVALUATE(m._cGetValid) AND EVALUATE(m._cFldValid)
  * Clear Read-In_Progress flag
  m._bRIP = .F.
  RETURN .T.
ENDIF

* Restore window to normal size if it was just minimized. If it is
* minimized, WONTOP() may be another window, but WOUTPUT() will
* still be the current READ window.
IF WMINIMUM( WOUTPUT() )
  ZOOM WINDOW (WOUTPUT()) NORM
ENDIF

* Return 0 to suppress default READ msg.
RETURN 0

* - FUNCTION wGetValid
*************************************************************
FUNCTION wRIPcheck
*
* This function is call by Menu option handlers to
* enforce validation of the current GET field. This workaround 
* is necessary because of design limitations in FoxPro 2.5.
*

* Only force-validate if current field READ was interrupted.
IF m._bRIP
  m._bMouse = .T.         && Act as though mouse-terminated.

  * Evaluate task specific GET valid handlers.
  IF EVALUATE(m._cGetValid) AND EVALUATE(m._cFldValid)
    _CUROBJ = _CUROBJ     && Stay on the same field
    m._bRIP = .F.         && Clear Read-In_Progress flag
  ELSE
    _CUROBJ = _CUROBJ     && Stay on the same field
    RETURN .F.            && Field did not pass validation.
  ENDIF
ENDIF
RETURN .T.

* EOF - FUNCTION wRIPcheck
*************************************************************
FUNCTION wCatchAll
PARAMETER cWindow
*
* Under FoxPro for Windows, Minimizing a window from the window
* control box, or Choosing Next Window, bypasses the GET Valid
* clause. This routine, called from the DEACTIVATE handler, is 
* our only chance to catch it.
*

IF NOT wRIPcheck()
  ACTIVATE WINDOW (m.cWindow)

  * Don't let it stay minimized on validation errors.
  IF WMINIMUM(m.cWindow)
    ZOOM WINDOW (m.cWindow) NORM
  ENDIF
  RETURN .F.
ENDIF
RETURN .T.

* EOF - FUNCTION wCatchAll
*************************************************************
FUNCTION wChanged
*
* Returns .T. if the current GET object is an editable field
* and has been modified since last validated.
*

IF INLIST(m._cObjType, 'C', 'E')
  * Cases added 8/94 don't trim numeric, logical or date fields!
  DO CASE
  CASE TYPE('EVALUATE(VARREAD())') <> TYPE('m._xInitial')
    RETURN .F.
  CASE TYPE(VARREAD()) = 'C' .OR. TYPE(VARREAD()) = 'M'
    IF 'EXIT' $ UPPER(EVALUATE(VARREAD()))
       RETURN .F.
    ENDIF
    RETURN NOT TRIM(EVALUATE(VARREAD())) == TRIM(m._xInitial)
  OTHERWISE
    RETURN NOT EVALUATE(VARREAD()) == m._xInitial
  ENDCASE
ELSE
  RETURN EVALUATE( VARREAD() ) <> m._xInitial
ENDIF

* EOF - FUNCTION wChanged
*************************************************************
FUNCTION wLastKey
*
* Add mouse support to the LASTKEY() FoxPro function.
*

* 151 is the value INKEY() returns for a mouse click.
RETURN IIF(m._bMouse, 151, LASTKEY())

* EOF - FUNCTION wLastKey
*************************************************************
FUNCTION wGetState
PARAMETER cTaskAlias
*
* Restore saved preference variables from .mem file
*

MemFile = _WkDir + cTaskAlias
IF FILE(MemFile+'.MEM')
  RESTORE FROM &MemFile ADDITIVE
  RETURN .T.
ELSE
  RETURN .F.
*  RETURN zzwarn(m.cTaskAlias, ;
*    "System Error - Memory File or c:\zz DIR Missing")
ENDIF

PRIVATE cOldError, bError, nOldSelect

m.bError = .F.

IF NOT USED('resource')
  * Handle errors gracefully.
  m.cOldError = ON('ERROR')
  m.nOldSelect = SELECT()
  ON ERROR m.bError = .T.

  SELECT 0
  USE SYS(2005) ORDER 1 AGAIN ALIAS RESOURCE

  * Make sure we can write to the resource file
  IF NOT m.bError
    GO TOP
    REPLACE resource.readonly WITH resource.readonly
  ENDIF

  * Restore original error handler, and notify caller if problem.
  ON ERROR &cOldError
  SELECT (m.nOldSelect)

  IF m.bError
    USE
    RETURN zzwarn(MESSAGE(),'SalesBridge Requires WRITE access ';
           + 'to the FoxPro resource file in order to run.')
  ENDIF
ENDIF

IF SEEK('ZZ          '+UPPER(m.cTaskAlias), 'resource')
 IF resource.ckval <> VAL(SYS(2007,resource.data))
    RETURN zzwarn(m.cTaskAlias, ;
          "System Error - Stored Context Variables Corrupted")
  ENDIF
  RESTORE FROM MEMO resource.data ADDITIVE
  RETURN .T.
ENDIF
RETURN .F.

* EOF - FUNCTION wGetState
*************************************************************
FUNCTION wSaveState
PARAMETER cTaskAlias
*
* Save preference variables to resource file

MemFile = _WkDir + cTaskAlias
SAVE TO &MemFile ALL LIKE 't_*'
RETURN .T.
** end of routine to save to local disk .mem file

* This procedure below is not used in SalesBridge
* all screen memvars are saved to .mem files on the local c: drive

** start routine to save to foxuser file
PRIVATE nOldSelect

* wGetState() is always called first, so no file is an error.
IF NOT USED('resource')
  RETURN .F.
ENDIF

m.nOldSelect = SELECT()
SELECT resource

IF NOT SEEK('ZZ          '+UPPER(m.cTaskAlias))
  APPEND BLANK
*  REPLACE resource.type WITH 'ZZ', ;
*    resource.id WITH UPPER(m.cTaskAlias)
ENDIF
IF NOT resource.readonly
  SAVE TO MEMO resource.data ALL LIKE 't_*'
  REPLACE resource.ckval WITH VAL(SYS(2007,resource.data)), ;
    resource.updated WITH DATE()
ENDIF

SELECT (m.nOldSelect)
RETURN .T.

* EOF - FUNCTION wSaveState
*************************************************************
FUNCTION wLock
PARAMETER cTaskAlias, cAlias, nRecno
*
* Obtain intra-system record locks. This provides a mechanism 
* for preventing multiple task windows from changing the same 
* record. This routine may be easily expanded to also impliment
* 'real' record locks, to prevent simulateous inter-system
* record changes. It could also be expanded to handle read-only
* files (ie refuse to grant the lock if read-only), or control
* access according to a security database.
*
* To lock the entire file, specify a record number of -1.
*

PRIVATE ix, cTable, nArraySize

m.cTable = IIF(EMPTY(m.cAlias), '', DBF(m.cAlias))
m.nArraySize = ALEN(_aLocks, 1)

* Look through lock table to check for existing lock.
FOR ix = 1 TO m.nArraySize
  IF _aLocks[ix,kTable] == m.cTable AND ;
     (m.nRecno = -1 OR _aLocks[ix,kRecord] == -1 OR ;
     _aLocks[ix,kRecord] == m.nRecno)

    * Already locked. OK, if by us, else it is an error.
    IF _aLocks[ix,kTaskAlias] == m.cTaskAlias
      RETURN .T.
    ELSE
      RETURN zzwarn( wAliasWin(m.cTaskAlias), ;
       'This Record is currently being modified in window "';
       + WTITLE(wAliasWin(_aLocks[ix,kTaskAlias])) + '"' )
    ENDIF
  ENDIF
ENDFOR

* Add a new intra-system lock to the list
DIMENSION _aLocks[ix,3]
_aLocks[ix,kTaskAlias] = UPPER(m.cTaskAlias)
_aLocks[ix,kTable] = m.cTable
_aLocks[ix,kRecord] = m.nRecno
RETURN .T.

* EOF - FUNCTION wLock
*************************************************************
PROCEDURE wUnlock
PARAMETER cTaskAlias, cAlias
*
* Release all Intra-system record lock for the specified task
* and work area alias.
*
* An empty work area alias means remove all locks for this
* task.
*

PRIVATE ix, ix2, cTable, nArraySize, cExclude

m.nArraySize = ALEN(_aLocks, 1)
m.cTable = IIF(EMPTY(m.cAlias), '', DBF(m.cAlias))

* Don't call our own task if it is in list of listeners.
m.cExclude = m.cTaskAlias + ','

ix = 1
DO WHILE ix <= m.nArraySize
  IF _aLocks[ix,kTaskAlias] == m.cTaskAlias AND ;
      (EMPTY(m.cTable) OR _aLocks[ix,kTable] == m.cTable)
    * If anyone is listening to this record, tell them it
    * has been changed.
    FOR ix2 = 1 TO ALEN(_aListen, 1)
      IF _aListen[ix2,kTable] == _aLocks[ix,kTable] AND ;
          _aListen[ix2,kRecord] = _aLocks[ix,kRecord] AND ;
          NOT _aListen[ix2,kTaskAlias] $ m.cExclude
        * Strip 1st 2 chars off alias to get task name to run.
        DO (SUBSTR( _aListen[ix2,kTaskAlias], 3 )) ;
          WITH 'UPDATE', _aListen[ix2,kTaskAlias]
         * Add to list of excluded tasks, so only called once.
        m.cExclude = m.cExclude ;
                     + _aListen[ix2,kTaskAlias] + ','
      ENDIF
    ENDFOR

    * Release the intra system lock.
    =ADEL( _aLocks, ix )
    m.nArraySize = m.nArraySize - 1
  ELSE
    ix = ix + 1
  ENDIF
ENDDO

* Shrink the array down to its new size
DIMENSION _aLocks[m.nArraySize,3]
RETURN

* EOF - PROCEDURE wUnlock
*************************************************************
PROCEDURE wListen
PARAMETER cTaskAlias, cAlias, nRecno
*
* Maintain a list of records that tasks want to listen
* for changes to. When a record in this list is unlocked via
* wUnlock (which implies that it has been changed), the 
* associated task is called with notification that the 
* record has changed.
*
* A record number of 0 means remove the entry.
* An empty work area alias means remove all entries for task.
*

PRIVATE ix, cTable, nArraySize

m.nArraySize = ALEN(_aListen, 1)
m.cTable = IIF(EMPTY(m.cAlias), '', DBF(m.cAlias))

IF EMPTY(m.nRecno)
  ix = 1
  DO WHILE ix <= m.nArraySize
    IF _aListen[ix,kTaskAlias] == m.cTaskAlias AND ;
        (EMPTY(m.cTable) OR _aListen[ix,kTable] == m.cTable)
      =ADEL( _aListen, ix )
      m.nArraySize = m.nArraySize - 1
    ELSE
      ix = ix + 1
    ENDIF
  ENDDO

  * Shrink the array down to its new size
  DIMENSION _aListen[m.nArraySize,3]
ELSE
  FOR ix = 1 TO m.nArraySize
    IF _aListen[ix,kTaskAlias] == m.cTaskAlias AND ;
        _aListen[ix,kTable] == m.cTable
      EXIT
    ENDIF
  ENDFOR

  IF ix > m.nArraySize
    DIMENSION _aListen[ix,3]
    _aListen[ix,kTaskAlias] = UPPER(m.cTaskAlias)
    _aListen[ix,kTable] = m.cTable
  ENDIF
   _aListen[ix,kRecord] = m.nRecno
ENDIF

* EOF - PROCEDURE wListen
*************************************************************
FUNCTION wBeep
*
* Ring the bell, only if user preference 'Bell' is enabled, and
* clear the typeahead buffer.
*

CLEAR TYPEAHEAD

* Turned off PDS 9/94, regardless of BELL setting
*IF m._bBeep
*  SET BELL TO 2000,2
*  ?? CHR(7)
*  SET BELL TO 1000,2
*  ?? CHR(7)
*ENDIF
RETURN .F.

* EOF - FUNCTION wBeep
*************************************************************
PROCEDURE _wWakeup
*
* Fake a terminating child read to cleanly wake up the parent READ.
* The combination of a READ and the seperate window trick 
* the Foundation READ and other READs into terminating in cases
* when CLEAR READ will not work properly.
*
* This avoids a problem in Fox's handling of @GET list objects in FP 
* DOS, and helps with ON SHUTDOWN processing in Windows.
*

* Use an underscore in the name to avoid conflict w/other windows.
IF NOT WEXIST("FoxWakeUp_")
  DEFINE WINDOW FoxWakeUp_ at -10,-10 size 1,1 NONE
ENDIF
ACTIVATE WINDOW FoxWakeUp_

READ SAVE WHEN .F.

* EOF - PROCEDURE _wWakeup
*************************************************************
PROCEDURE _wSysShut
*
* Called only as the FoxPro for Windows ON SHUTDOWN handler, when
* an attempt to exit FoxPro is recieved. This can also be called
* as the result of an attept to exit Windows itself.
*

* Can't allow clean shutdown while a modal dialog is active.
IF _bInModal
  RETURN inform('Cannot close Main Window while a Dialog or Alert is active')
ENDIF

m._bQuitFox = .T.
IF WREAD( WONTOP() )
  * If the current field fails validation, skip the shutdown.
  IF wRIPcheck()
    m._bShutdown = .T.
    =EVALUATE( m._cDeactExp )
    * CLEAR READ seems to be ignored within an ON SHUTDOWN handler
    * for READs with GETs. Use our hack READ waker-upper instead.
    DO _wWakeUp
  ENDIF
ELSE
  * Sometimes CLEAR READ immediatley trigger the READ VALID clause,
  * so make sure all flags are set before we issue the CLEAR.
  m._bShutdown = .T.
  CLEAR READ
  RETURN
ENDIF

RETURN

* EOF - PROCEDURE _wSysShut
*************************************************************
PROCEDURE _wPopup
*
* Rebuild the active window list in the Window popup menu.
*

PRIVATE ix, cCommand
#DEFINE kWinBar 3

* Clear any existing window list. The defined constant
* kWinBar is the bar number of the dividing line before the 
* first window name. If the number of fixed window popup bars
* changes, this constant must also change.
FOR ix = kWinBar TO CNTBAR('Window')
  RELEASE BAR ix OF window
ENDFOR

* Now add the current window list to the popup.
IF m._nMaxWind > 0
  DEFINE BAR kWinBar OF window PROMPT '\-'
  FOR ix = 1 TO m._nMaxWind
    DEFINE BAR kWinBar+ix OF window ;
      PROMPT IIF(ix<10, '\<'+ALLTRIM(STR(ix))+' ', '  ') ;
      + _aWindows[ix,kWinTitle]
    m.cCommand = "DO wActivate WITH '" ;
      + _aWindows[ix,kWinName] + "'"
    ON SELECTION BAR kWinBar+ix OF window &cCommand
  ENDFOR
ENDIF

* EOF - PROCEDURE _wPopup
*************************************************************
PROCEDURE _wFixUndo
*
* Restore FoxPro's default field undo command in the Edit menu. We
* need to restore the menu this way instead of using PUSH/POP
* POPUP because of a bug that causes a "Menu manager internal 
* consistensy error" when POPing a POPUP after one of it's bars
* has been released.
*

IF GETBAR('_MEDIT', 1) = 1
  * Release our replacement undo command menu bar
  RELEASE BAR 1 OF _MEDIT

  * And re-define the default system undo command.
  DEFINE BAR _MED_UNDO OF _medit PROMPT "\<Undo" ;
    BEFORE _MFIRST KEY CTRL+Z, "^Z"
ENDIF

* EOF - PROCEDURE _wFixUndo
*************************************************************
PROCEDURE _wFixBrowse
*
* Close any tables left behind by closed stand-alone BROWSEs.
*

PRIVATE ix, nArraySize

m.nArraySize = ALEN(_aBrowse, 1)

* Scan Browse table array and remove entries that have closed.
ix = 1
DO WHILE ix <= m.nArraySize
  IF NOT WEXIST(_aBrowse[ix,kWinName])
    SELECT _aBrowse[ix,kWorkarea]
    USE
    =ADEL(_aBrowse,ix)
    m.nArraySize = m.nArraySize - 1
  ELSE
    ix = ix + 1
  ENDIF
ENDDO

* Shrink array to its new smaller size, First element is
* empty string - it will always exist.
DIMENSION _aBrowse[m.nArraySize,2]

RETURN

* EOF - PROCEDURE _wFixBrowse
*************************************************************
PROCEDURE Controls
PARAMETER cOption, bInObject
*
* Process Common task control button options.
*
* Parameters:
*    cOption   - The prompt of the control button/menu bar selected.
*    bInObject - Set to .T. if we are called from the VALID clause
*                of a control, .F. if called from a menu.
*
* Returns:
*    True if the cOption is one we handle, False otherwise.
*

m.cOption = UPPER( ALLTRIM(m.cOption) )

* Form level undo must take place before auto-save.
DO CASE
CASE m.cOption = "UNDO"
  PRIVATE cAskmsg
  m.cAskmsg = "Are you sure you want to discard " ;
    + IIF( m.t_bAddNew, "this new record?", ;
    "changes to this record?" )
  IF zzconfrm( m.t_cWindow, m.cAskmsg )
    * Clear READ-In-Progress without invoking field validation
    _bRIP = .F.
    DO wUnlock WITH m.cTaskAlias
    DO load_form
    DO show_form
  ENDIF

CASE m.cOption = "EXIT"
  * If we are called from an objects valid clause, we must
  * explicitly clear the read, or FoxPro will hang.
  * wClose() will return False if Form level valid failed,
  * or user hit cancel button when asked to save changes.
  IF wClose() AND m.bInObject
    DO wClearRead
  ENDIF

OTHERWISE        
  * Make sure any interrupted READ field gets properly validated.
  * Also, validate and Save changes (if any) to current record.
  * If you pass a prompt string to save_form(), it will ask 
  * before saving changes to the current record.
  IF wRIPcheck() AND save_form('')

    DO CASE
    CASE LASTKEY() = 3  && disable pgup and pgdn to prev/next record
    CASE LASTKEY() = 18
    CASE m.cOption = "ADD"
      DO init_form
      DO show_form
        RETURN .T.
    CASE m.cOption = "SAVE"
        * Save is all done, by form_valid() function.
        WAIT WINDOW NOWAIT "Changes Saved"
     CASE m.cOption = "FIRST"
        GO TOP
     CASE m.cOption = "PREV"
       IF EMPTY(_Filt) OR ALIAS() <> 'ZZMAST'
         IF NOT BOF()
           SKIP -1
         ENDIF
         IF BOF()
           DO wBeep
         ENDIF
       ELSE
*         ON ERROR WAIT 'Top of file' WINDOW TIMEOUT 2
         Sv_Rec = RECNO()
         DO WHILE NOT BOF()
           SKIP -1
           IF &_Filt OR BOF()
             EXIT
           ENDIF
         ENDDO
         IF BOF()
           GOTO Sv_Rec
         ENDIF
*         ON ERROR DO zzerror WITH ERROR(),MESSAGE(),PROGRAM(),MESSAGE(1),LINENO(1)
        ENDIF

     CASE m.cOption = "NEXT"

       IF EMPTY(_Filt) OR ALIAS() <> 'ZZMAST'
         IF NOT EOF()
           SKIP 1
         ENDIF
         IF EOF()
           DO wBeep
         ENDIF
       ELSE
         Sv_Rec = RECNO()
         SKIP
         SCAN REST FOR &_Filt
           EXIT
         ENDSCAN
         IF EOF()
           GOTO Sv_Rec
         ENDIF
       ENDIF

     CASE m.cOption = "LAST"
       GO BOTTOM

     CASE m.cOption = "FIND"
       DO zzfind WITH WTITLE(m.t_cWindow)

     CASE m.cOption = "DELETE"
       IF zzconfrm( WONTOP(), ;
          "Are you sure you want to DELETE this record?" )
          DELETE
          SKIP 1
          IF EOF()
            GO TOP
          ENDIF
       ENDIF

     OTHERWISE
       RETURN .F.
     ENDCASE

     * Load new record into GET variables, and redisplay.
     DO load_form
     DO show_form
  ELSE
     RETURN .T.
  ENDIF
ENDCASE

* Move to last read data field.
_CUROBJ = m._nCurObj

RETURN .T.

* EOF - PROCEDURE controls
*************************************************************
PROCEDURE Inform
PARAMETER cText
*
* Display an informational message.
*
* We return false so GET validation routines can use this
* to display a meesage describing the problem on error by
* simply coding "RETURN inform( "This is the problem" )
*

WAIT WINDOW NOWAIT m.cText
*DO wBeep
CLEAR TYPEAHEAD

RETURN .F.

* EOF - PROCEDURE inform

*************************************************************
* EOF - Event driven routines
*************************************************************



*************************************************************
*************************************************************
*************************************************************
* EOF - zzproc.prg
*************************************************************
*************************************************************
*************************************************************
