*       *********************************************************
*       *                                                         
*       * 03/13/95             ZZRPTS.PRG                08:57:03 
*       *                                                         
*       *********************************************************
*       *                                                         
*       * Patrick Smith                                           
*       *                                                         
*       * Copyright (c) 1995 Contact Technology                   
*       * 26 Aries Lane                                           
*       * Novato, CA  94947                                       
*       * U.S.A                                             
*       *                                                         
*       * Description:                                            
*       * This program was automatically generated by GENSCRN.    
*       *                                                         
*       *********************************************************

PARAMETERS cevent, ctaskalias

*       *********************************************************
*       *                                                         
*       *          ZZRPTS/Windows Setup Code - SECTION 1          
*       *                                                         
*       *********************************************************
*

#REGION 1
*++
* Report update task support code
*--
* Make sure this is the ONLY task window open!
IF NOT EMPTY(_aWindows[1])
  IF _aWindows[1] = '1_ZZRPTS'
    * OK to go back to this window
  ELSE
    WAIT 'Close all windows before performing this function, press <Enter>' WINDOW
    RETURN
  ENDIF
ENDIF

PRIVATE ALL EXCEPT _*


*       *********************************************************
*       *                                                         
*       *          ZZRPTS/Windows Setup Code - SECTION 2          
*       *                                                         
*       *********************************************************
*

#REGION 1
* Define offsets into GET variable array structure.
* The first section of the array must match the table layout
* so we can use GATHER/SCATTER to transfer between file and array.
* Make sure it is an exact match to the dbf structure!
* Adjust the size of the array below to hold the memvars

#DEFINE t_cName      t_aGETvars[1]
#DEFINE t_cDesc      t_aGETvars[2]
#DEFINE t_cDbf       t_aGETvars[3]
#DEFINE t_cNdx1      t_aGETvars[4]
#DEFINE t_cNdxKey1   t_aGETvars[5]
#DEFINE t_cNdxKey2   t_aGETvars[6]
#DEFINE t_cNdxKey3   t_aGETvars[7]
#DEFINE t_cFiltDsc   t_aGETvars[8]
#DEFINE t_cFilt      t_aGETvars[9]

* Now define elements for additional non-table fields
#DEFINE t_cOption    t_aGETvars[31]
#DEFINE t_nTopBump   t_aGETvars[32]
#DEFINE t_nBotBump   t_aGETvars[33]

  * And now define the array itself
  DIMENSION t_aGETvars[40]

  * Declare Screen-set wide global variables
  m.t_cWindow = ''   && Window name for this instance
  m.t_nWinRow = 2    && Default row for our window
  m.t_nWinCol = 2    && Default column for our window
  m.t_nCurObj = 0    && Current object number
  m.t_nRecno = 0     && Current record number
  m.t_cOrder= 'zzRpts'     && Default table order.
  m.t_bAddNew = .F.  && Set true if adding new record
  m.t_bChanges = .F. && Changes have been made flag.
  m.t_bAtTop = .F.   && Beginning of file flag
  m.t_bAtEnd = .F.   && End of file flag

  * Determine our task alias, or create a new one.
  IF m.cEvent = 'LAUNCH'
    * Look for topmost existing instance of this task first.
    m.t_cWindow = wTaskWin( m.cTaskAlias )

    IF EMPTY( m.t_cWindow )
      * Create a new instance of this task.
      m.cTaskAlias = wNewTask( m.cTaskAlias )
      IF EMPTY( m.cTaskAlias )
        RETURN .F.
      ENDIF

      m.t_cWindow = wAddWin( m.cTaskAlias, 'ZZRPTS', ;
                         'Report Update' )
    ELSE
      * Get the task alias associated with window we found.
      m.cTaskAlias = wWinAlias( m.t_cWindow )
    ENDIF
  ENDIF

  * Restore last saved state (if any) of memory variables.
  DO wGetState WITH m.cTaskAlias

  * Make sure the files we use are open
  * get filter array list
  IF NOT USED('zzFilt')
    * Use AGAIN in case another task, or BROWSE, has file open
    * under a different alias name.
    USE (LOCFILE('zzFilt','DBF','Where is the Filter file?'));
        IN 0 AGAIN ALIAS zzFilt
  ENDIF
  SELECT zzFilt
  SET INDEX TO zzFilt
  SET ORDER TO 1

  IF NOT USED('zzrpts')
    * Use AGAIN in case another task, or BROWSE, has file open
    * under a different alias name.
    USE (LOCFILE('zzrpts','DBF','Where is the Reports file?'));
        IN 0 AGAIN ALIAS zzrpts
  ENDIF
  SELECT zzrpts
  SET INDEX TO (m.t_cOrder)
  SET ORDER TO (m.t_cOrder)

  * Restore current record from saved context.
  IF m.t_nRecno > 0 AND m.t_nRecno <= RECCOUNT()
    GO m.t_nRecno
  ENDIF

  DO CASE
    CASE m.cEvent = 'CLOSE'
      IF NOT save_form('closing the window')
        RETURN .F.
      ENDIF
      HIDE WINDOW (t_cWindow)

    CASE m.cEvent = 'UPDATE'
      * If changes have been made, ignore simple update events.
      * Note that this code depends on SET EXACT OFF.
      IF NOT (t_bChanges AND cEvent == 'UPDATE')
        IF save_form('selecting a new record')
          * Process Special event messages we support.
          IF '>' $ m.cEvent
            DO controls WITH SUBSTR(cEvent,AT('>',cEvent)+1)
          ELSE
            IF '-' $ m.cEvent
              GO VAL(SUBSTR(cEvent,AT('-',cEvent)+1))
            ENDIF
            DO load_form
            DO show_form
          ENDIF
        ENDIF
      ENDIF

    CASE m.cEvent = 'LAUNCH' OR m.cEvent = 'ACTIVATE'
      IF NOT WVISIBLE( m.t_cWindow )
        * Position newly created window(s) at last saved position.
        * SIZE must be manually adjusted, NOT from screen generator
        MODIFY WINDOW ( m.t_cWindow ) ;
                FONT 'MS Sans Serif',8 STYLE 'B';
                ICON FILE cardfile.ico ;
                AT m.t_nWinRow, m.t_nWinCol SIZE 30,96 ;
                COLOR RGB(,,,192,192,192)

        * Initialize the GET variable array.
        STORE '' TO t_aGETvars
        STORE 0 TO t_nTopBump, t_nBotBump, t_nCurObj

        * Load current record into GET variable array.
        DO load_form
      ENDIF

      * Issue GETS if this is first time, or another task cleared them
      ACTIVATE WINDOW (m.t_cWindow) NOSHOW
      IF OBJNUM( t_nTopBump, wRdLevel() ) = 0
        DO issue_gets

        * Object numbers have changed, so clear saved object number
        m.t_nCurObj = 0
      ELSE
        * If window was just re-opened, show the gets.
        IF NOT WVISIBLE(m.t_cWindow)
          SHOW GETS WINDOW (m.t_cWindow) LEVEL wRdLevel()
        ENDIF
      ENDIF

      * Set option buttons correctly
      DO set_buttons WITH m.t_bChanges
      ACTIVATE WINDOW (m.t_cWindow)

      * If no saved object, determine default first object to read.
      IF m.t_nCurObj = 0
        m.t_nCurObj = OBJNUM( t_cDesc, wRdLevel() )
      ENDIF

      * Define flag to remember the state of our menu pad. The
      * Activate clause is re-called each time a dialog window
      * is closed. By using this flag we can avoid the overhead of
      * re-redefining our menu in these cases.
      bMenuUp = .F.

      * Give ZZProc.prg our READ level validation expressions
      DO wReadInit WITH 'rpts_deact()', 'get_valid()', ;
                        'save_form("closing the window")'

      READ CYCLE SAVE OBJECT m.t_nCurObj ;
         ACTIVATE rpts_act() ;
         DEACTIVATE rpts_deact() ;
         VALID READKEY(1) = 5     && Only terminate if deactivate

      m.t_nCurObj = _nCurObj      && Remember last data object
  ENDCASE

  * Save current context information
  m.t_cOrder = ORDER('zzrpts')    && Remember data table order
  m.t_nRecno = RECNO('zzrpts')    && and record number
  DO wSaveState WITH m.cTaskAlias

  IF NOT WVISIBLE(t_cWindow)
    * Close the tables we use. If other tasks use them, they will
    * reopen them as part of their context restoration.
    SELECT zzRpts
    USE

    * Close associated browse window also, if open.
    IF WEXIST('Report_List')
      DEACTIVATE WINDOW 'Report_List'
    ENDIF

    DO wDelTask WITH m.cTaskAlias
  ENDIF
  RETURN .T.

*******************************************************************
PROCEDURE issue_gets
*++
* The code for this procedure will be generated by GENSCRN.  It
* will issue all the @GETs for the screen.  We want the GET
* commands to be in a seperate procedure so we can call them
* conditionally from the task program setup code.
*--

* ! Important !
* Make sure the When statement for the "get" field "TopBump"
* contains the name of the last "get" field and
* "BotBump" contains the name of the first "get" field
* this will insure that the cursor cycles properly!!!!!
*

*       *********************************************************
*       *                                                         
*       *              ZZRPTS/Windows Screen Layout               
*       *                                                         
*       *********************************************************
*

#REGION 1
@ 4.077,1.667 TO 4.077,78.167 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 0.692,1.667 TO 0.692,78.000 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 0.692,1.333 TO 4.154,1.333 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 0.692,78.000 TO 4.077,78.000 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 23.923,3.167 SAY "Print Report Filter/Query List  (List Defined in Filter Window, Blank = All Records) " ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT"
@ 23.538,1.333 TO 23.538,81.666 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 23.538,1.333 TO 25.384,1.333 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 23.538,81.500 TO 25.230,81.500 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 25.231,1.500 TO 25.231,81.833 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 26.000,1.833 TO 26.000,81.666 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 26.000,1.500 TO 28.615,1.500 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 28.615,1.833 TO 28.615,81.500 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 26.077,81.500 TO 28.615,81.500 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 5.615,3.667 SAY "Report File Name:" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 9.615,2.000 SAY '(Data file name, up to 8 characters.)' + CHR(13) + ;
		'(Usually "zzmast")' ;
	SIZE 2.000,34.500, 0.000 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT"
@ 7.000,8.167 SAY "Description:" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 5.077,1.333 TO 5.077,21.000 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 5.077,1.333 TO 8.385,1.333 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 5.154,20.833 TO 8.308,20.833 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 8.308,1.500 TO 8.308,21.167 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 9.077,1.333 TO 9.077,40.000 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 9.077,1.333 TO 12.154,1.333 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 9.154,39.667 TO 12.000,39.667 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 12.000,1.500 TO 12.000,40.000 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 5.077,23.167 TO 5.077,61.667 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 5.077,22.833 TO 8.539,22.833 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 8.462,23.167 TO 8.462,61.834 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 5.077,61.667 TO 8.462,61.667 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 9.077,42.167 TO 9.077,58.334 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 9.077,41.833 TO 12.154,41.833 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 12.000,42.167 TO 12.000,58.334 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 9.154,58.167 TO 12.000,58.167 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 13.308,2.167 SAY "Order the reports by up to 3 fields." + CHR(13) + ;
		"(Ex: by State then City then Zip)" + CHR(13) + ;
		"Leave blank if no order necessary." ;
	SIZE 3.000,33.667, 0.000 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT"
@ 12.846,1.333 TO 12.846,39.833 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 12.846,1.333 TO 17.000,1.333 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 12.923,39.667 TO 16.846,39.667 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 16.846,1.500 TO 16.846,40.000 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 12.846,42.333 TO 12.846,63.000 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 12.846,42.000 TO 18.769,42.000 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 18.692,42.333 TO 18.692,63.000 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 13.000,62.833 TO 18.692,62.833 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 20.154,2.500 SAY "Index file name, (up to 8 characters.)" + CHR(13) + ;
		"Leave blank if not ordering the reports." ;
	SIZE 2.000,37.833, 0.000 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT"
@ 19.692,1.333 TO 19.692,40.000 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 19.692,1.333 TO 22.615,1.333 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 19.769,39.667 TO 22.615,39.667 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 22.615,1.500 TO 22.615,40.000 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 19.615,42.500 TO 19.615,58.667 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 19.615,42.167 TO 22.692,42.167 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 22.538,42.500 TO 22.538,58.667 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 19.692,58.500 TO 22.538,58.500 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 0.000,0.167 GET t_nTopBump ;
	PICTURE "@*IVN " ;
	SIZE 1.000,1.167,1.000 ;
	DEFAULT 0 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wBumper(OBJNUM(t_cName) + 7)
@ 5.769,24.833 GET t_cName ;
	SIZE 1.000,11.333 ;
	DEFAULT " " ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	PICTURE "@K !!!!!!!!" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 7.000,24.833 GET t_cdesc ;
	SIZE 1.000,35.500 ;
	DEFAULT " " ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	PICTURE "@K" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 10.077,43.833 GET t_cDbf ;
	SIZE 1.000,12.500 ;
	DEFAULT " " ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	PICTURE "@K !!!!!!!!" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 13.462,43.500 GET t_cNdxKey1 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 15.000,43.500 GET t_cNdxKey2 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 16.538,43.500 GET t_cNdxKey3 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 20.538,43.833 GET t_cNdx1 ;
	SIZE 1.000,12.667 ;
	DEFAULT " " ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	PICTURE "@K !!!!!!!!" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 26.538,2.667 GET t_cFiltDsc ;
	PICTURE "@^" ;
	FROM _zzFilt ;
	SIZE 1.538,77.333 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 29.000,2.000 SAY IIF(_Ok2All,'','For: Owner = [' +_Owner + ']' ) ;
	SIZE 1.000,33.333 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 1.000,2.667 GET t_cOption ;
	PICTURE "@*BHN " + ;
		(LOCFILE("prev.bmp","BMP|ICO|PCT|ICN","Where is prev?")) + ";" + ;
		(LOCFILE("next.bmp","BMP|ICO|PCT|ICN","Where is next?")) + ";" + ;
		(LOCFILE("list.bmp","BMP|ICO|PCT|ICN","Where is list?")) + ";" + ;
		(LOCFILE("add.bmp","BMP|ICO|PCT|ICN","Where is add?")) + ";" + ;
		(LOCFILE("modify.bmp","BMP|ICO|PCT|ICN","Where is modify?")) + ";" + ;
		(LOCFILE("execute.bmp","BMP|ICO|PCT|ICN","Where is execute?")) + ";" + ;
		(LOCFILE("undo.bmp","BMP|ICO|PCT|ICN","Where is undo?")) + ";" + ;
		(LOCFILE("save.bmp","BMP|ICO|PCT|ICN","Where is save?")) + ";" + ;
		(LOCFILE("exit.bmp","BMP|ICO|PCT|ICN","Where is exit?")) ;
	SIZE 2.923,7.667,0.667 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	VALID ProcOption(t_cOption,.T.)
@ 0.000,1.333 GET t_nBotBump ;
	PICTURE "@*IVN " ;
	SIZE 1.077,0.833,1.000 ;
	DEFAULT 0 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wBumper( OBJNUM(t_cName) )


*       *********************************************************
*       *                                                         
*       *               ZZRPTS/Windows Cleanup Code               
*       *                                                         
*       *********************************************************
*

#REGION 1
********************************************************************


*       *********************************************************
*       *                                                         
*       *   ZZRPTS/Windows Supporting Procedures and Functions    
*       *                                                         
*       *********************************************************
*

#REGION 1
FUNCTION rpts_act
*++
* Task specific READ activation handler.
*--

  * Put up custom menu pad for this task window. The activate clause
  * may sometimes be called after the window is hidden during a close
  * operation, if a dialog box was activated by the form level
  * validation handler. The WVISIBLE() test makes sure we don't put
  * the menu back up in this case. The bMenuUp flag is used only for
  * optimization purposes - so we don't redefine the menu if it's
  * already there.
  IF WVISIBLE(m.t_cWindow) AND NOT bMenuUp
    DO zzrpts.mpr
    bMenuUp = .T.
  ENDIF

  RETURN .T.


********************************************************************
FUNCTION rpts_deact
*++
* Task specific READ deactivation handler.
* This routine may be called by the READ command on a READ window
* deactivation, or explicitly by the wClearRead() function. That
* means we cannot depend on WLAST() or WONTOP() to be set right.
*--
  * Under FoxPro for Windows, Minimizing a window from the window
  * control box, or Choosing Next Window, bypasses the GET Valid
  * clause. This is our only chance to catch it, and thereby enforce
  * proper field validation.
  IF wCatchAll(m.t_cWindow)
    * Save last position of window
    m.t_nWinRow = WLROW(m.t_cWindow)
    m.t_nWinCol = WLCOL(m.t_cWindow)

    RELEASE PAD reports OF _MSYSMENU
    RELEASE POPUP reports
    bMenuUp = .F.
    RETURN .T.
  ELSE
    RETURN .F.
  ENDIF


********************************************************************
FUNCTION GET_valid
*++
* Common validation routine called when any field data is changed.
*
* This routine is responsible for:
*  1. Checking lock status of record, locking if needed.
*  2. Setting changes flag and setting buttons.
*
* Returns TRUE.
*  If data was changed and lock could not be established, data is
*  reset to initial value.
*--
PRIVATE xTemp

  IF NOT m.t_bchanges AND wChanged()
    IF NOT wLock(m.cTaskAlias, 'zzrpts', RECNO('zzrpts') )
      * Restore original field contents on Lock failure.
      DO wFldUndo

      * Return success, since user is warned, and changes undone.
      RETURN .T.
    ENDIF

    * Make sure any changes to record made since original
    * display are shown on screen when the record is locked.
    STORE EVALUATE( VARREAD() ) TO m.xTemp
    DO load_form
    STORE m.xTemp TO ( VARREAD() )
    DO show_form

    DO set_buttons WITH .T.
  ENDIF

  RETURN .T.


********************************************************************
PROCEDURE load_form
*++
* Load data from current record for display and/or edit.
*---
  SELECT zzrpts

  * Don't stay at EOF if we can help it.
  IF EOF()
    GOTO BOTTOM

    * If still at EOF, perform implicit add record command.
    IF EOF()
      RETURN init_form()
    ENDIF
  ENDIF

  m.t_bAddNew = .F.
  DO set_buttons WITH .F.

  * Let all the other tasks know what record we have displayed.
  DO wListen WITH m.cTaskAlias, 'zzrpts', RECNO('zzrpts')

  * Load data from field variables into GET variable array.
  SCATTER TO t_aGETvars MEMO
  RETURN


********************************************************************
PROCEDURE init_form
*++
* Initialize internal memory for a new address record.
* Let format default to current setting on add.
*---
  m.t_bAddNew = .T.
  DO set_buttons WITH .T.

  SELECT zzrpts
  SCATTER TO t_aGETvars MEMO BLANK

  * Move to first field to begin entry of new record.
  _CUROBJ = OBJNUM( t_cName )
  RETURN


********************************************************************
PROCEDURE show_form
*++
* Display current data and Enable/Disable fields as appropriate.
*---

  SHOW GETS WINDOW (m.t_cWindow) LEVEL wRdLevel()
  RETURN


********************************************************************
FUNCTION set_buttons
PARAMETER bChanges
*++
* Set changes flag, and update control buttons accordingly.
*--
PRIVATE nRecno

  IF m.bChanges
    SHOW GET t_cOption,7 ENABLE LEVEL wRdLevel()
    SHOW GET t_cOption,8 ENABLE LEVEL wRdLevel()
  ELSE
    SHOW GET t_cOption,7 DISABLE LEVEL wRdLevel()
    SHOW GET t_cOption,8 DISABLE LEVEL wRdLevel()
  ENDIF

  * The AddNEw flag will always be set if there are no records.
  IF t_bAddNew
    t_bAtTop = .T.
    t_bAtEnd = .T.
  ELSE
    nRecno = RECNO()
    SKIP -1
    t_bAtTop = BOF()
    GO nRecno

    SKIP 1
    t_bAtEnd = EOF()
    GO nRecno
  ENDIF

  * Set buttons according to current record
  IF m.t_bAtTop
    SHOW GET t_cOption,1 DISABLE LEVEL wRdLevel()
  ELSE
    SHOW GET t_cOption,1 ENABLE LEVEL wRdLevel()
  ENDIF

  IF m.t_bAtEnd
    SHOW GET t_cOption,2 DISABLE LEVEL wRdLevel()
  ELSE
    SHOW GET t_cOption,2 ENABLE LEVEL wRdLevel()
  ENDIF

  * Store new value of task level change flag and return it.
  m.t_bChanges = m.bChanges
  RETURN m.bChanges


********************************************************************
FUNCTION ProcOption
PARAMETER cOption, bInObject
*++
* Process menu and pushbutton options.
*--

  * place chosen filter into report filter memvar
  SELECT zzFilt
  IF NOT EMPTY(t_cFiltDsc)
    SEEK UPPER(t_cFiltDsc)

    * Limit user to "owned" records if required

    * Add something like [owner='JFK' AND ]
    * to the begining of the filter string
    * if limiting user access to not all records

    IF _Ok2All
      t_cFilt = zzFilt->FiltStr
    ELSE
      t_cFilt = 'owner=[' +_Owner + '] AND ' + ALLTRIM(zzFilt->FiltStr)
      * disable "Owner = " display on reports, pds 12/94
      * un-comment to enable!
      *t_cFiltDsc = '( Owner = ' + _Owner + ') ' + ALLTRIM(qFiltList)
    ENDIF

  ELSE

    IF _Ok2All
      t_cFilt = ''
    ELSE
      t_cFilt = 'owner=[' +_Owner + ']'
      * disable "Owner = " display on reports, pds 12/94
      * un-comment to enable!
      *t_cFiltDsc = '( Owner = ' + _Owner + ') '
    ENDIF

  ENDIF

  * if choice is picture button, strip off ".BMP" from end
  * make sure .bmp button file names match menu options!
  m.cOption = STRTRAN(m.cOption,'.BMP','')
  * identify file name, strip off path + back-slashes
  m.cOption = SUBSTR(m.cOption,RAT('\',m.cOption)+1)

  SELECT zzRpts
  m.cOption = UPPER( ALLTRIM(m.cOption) )

  IF  m.cOption = 'COPY'
    APPEND BLANK
    GATHER FROM t_aGETvars MEMO
    DO load_form
    DO show_form
    DO wUnlock WITH m.cTaskAlias
    WAIT 'Record Copied' Window NOWAIT
    RETURN .T.
  ENDIF

  DO CASE
    * First, handle the common task button options.
    CASE controls(cOption, bInObject)


    CASE m.cOption = 'MODIFY'
      DO RptMod
    CASE m.cOption = 'EXECUTE'
      DO RptExe
    CASE m.cOption = 'LIST'
      * Launch an independant BROWSE window, linked to ours.
      DO wLaunch WITH 'rptlist IN zzrpts'

  ENDCASE

  RETURN .T.


********************************************************************
PROCEDURE rptlist
PARAMETER cEvent, cTaskAlias
*++
* This BROWSE task is designed to work together with the
* Report update task window.
*
* Parameters from wLaunch are ignored for BROWSE tasks, since
* once they are started, we never get control of them again.
*--
  SELECT zzrpts

  * Define a window for Browse to pattern itself after. Specify font
  * so size will be consistent even if Main Window font changes.
  DEFINE WINDOW bwin AT 1,1 SIZE 11,75 ;
                        FONT 'MS Sans Serif',8 STYLE 'B' ;
                        FLOAT SHADOW CLOSE MINIMIZE ZOOM ;
                        SYSTEM GROW COLOR SCHEME 8
  MOVE WINDOW bwin CENTER

  * Activate the BROWSE window. The WHEN clause calls zzrpts.prg
  * with the event string 'UPDATE-n' where n is the new
  * record number to display in the window.
  BROWSE NOWAIT REST NOMENU NOMODIFY ;
         WINDOW bwin TITLE 'Report_List' ;
         FIELDS Desc,Name ;
         WHEN EVALUATE( 'zzrpts' ;
                + '("UPDATE-' + ALLTRIM(STR(RECNO())) ;
                + '", "1_ZZRPTS")' )

  RELEASE WINDOW bwin
  RETURN


********************************************************************
FUNCTION save_form
PARAMETER cMsgTxt
*++
* Validate complete form as a whole, and save changes. If cMsgTxt
* contains a string, use it to ask whether or not user wants to
* save changes.
*--
PRIVATE nBadField, cReason, cAnswer

  SELECT zzrpts
  STORE '' TO m.cReason

  IF m.t_bChanges
    m.cAnswer = IIF(EMPTY(m.cMsgTxt), 'YES', zzQuest(m.t_cWindow, ;
        'Do you want to save changes made to this report ' ;
        + 'before ' + m.cMsgTxt + '?' ) )

    * Return failure immediately if user cancels.
    IF m.cAnswer = 'CANCEL'
      RETURN .F.
    ENDIF

    * Save the changes if we are supposed to.
    IF m.cAnswer = 'YES'
      * Make sure all required fields have been entered.
      DO CASE
        CASE EMPTY(t_cName)
          m.cReason = 'A Report Name is required'
          m.nBadField = OBJNUM(t_cName)
        CASE EMPTY(t_cDbf)
          m.cReason = 'A Report Database is required'
          m.nBadField = OBJNUM(t_cDbf)
        CASE EMPTY(t_cDesc)
          m.cReason = 'A Report Description is required'
          m.nBadField = OBJNUM(t_cDesc)

      ENDCASE

      IF NOT EMPTY(m.cReason)
        DO zzWarn WITH m.t_cWindow, m.cReason

        * This routine may be called when no GETs are issued (like
        * during Global shutdown). OBJNUM() returns 0 in this case.
        _CUROBJ = nBadField
        RETURN .F.
      ENDIF

      * Add a new record to the database when needed.
      IF m.t_bAddNew
        * Create new record
        APPEND BLANK
        m.t_bAddNew = .F.
      ENDIF

      GATHER FROM t_aGETvars MEMO
      DO set_buttons WITH .F.
    ELSE
      * User said 'dont save', so reload from disk.
      DO load_form
      DO show_form
    ENDIF

    * Whether changes saved or discarded, release the locks.
    DO wUnlock WITH m.cTaskAlias

  ENDIF

  RETURN .T.


* EOF - save_form
********************************************************************
FUNCTION RptMod
* Modify selected report
*

mRpt     = ALLTRIM(t_cName)
mDbf     = ALLTRIM(t_cDbf)
mNdx     = ALLTRIM(t_cNdx1)
mRptFilt = t_cFilt

IF NOT USED(mDbf)
  * Use AGAIN in case another task, or BROWSE, has file open
  * under a different alias name.
  USE (LOCFILE(mDbf,'DBF','Where is ' + mDbf + '.dbf?'));
      IN 0 AGAIN ALIAS &mdbf
ENDIF
SELECT &mDbf
mRptKey  = BldIdx(mNdx)

* Place other cases here for dbf's with many indexes
* that you may want open for rushmore optimization!
* one each, depending on whether user entered an
* index file name.

* Add report order index to master index list, if necessary
RptNdxs = mNdx + ',' + _MastNdx

DO CASE
CASE .NOT. EMPTY(mNdx) .AND. mDbf = _MastFile
  SET INDEX TO &RptNdxs
  SET ORDER TO 1
CASE EMPTY(mNdx) .AND. mDbf = _MastFile
  SET INDEX TO &_MastNdx
  SET ORDER TO 1
* put 2 cases here, above last 2
CASE .NOT. EMPTY(mNdx) .AND. mDbf <> _MastFile
  SET INDEX TO &mNdx
  SET ORDER TO 1
CASE EMPTY(mNdx) .AND. mDbf <> _MastFile
  SET INDEX TO
ENDCASE

MODI REPORT &mRpt

SELECT &_MastFile
SET INDEX TO
SET INDEX TO &_MastNdx

RETURN

* EOF - RptMod
********************************************************************
FUNCTION RptExe
* Execute selected report
*

mRpt = ALLTRIM(t_cName)
mDbf = ALLTRIM(t_cDbf)
mNdx = ALLTRIM(t_cNdx1)

IF NOT USED(mDbf)
  * Use AGAIN in case another task, or BROWSE, has file open
  * under a different alias name.
  USE (LOCFILE(mDbf,'DBF','Where is ' + mDbf + '.dbf?'));
      IN 0 AGAIN ALIAS &mdbf
ENDIF
SELECT &mDbf
mRptFilt = t_cFilt
mRptKey  = BldIdx(mNdx)

* Place other cases here for dbf's with many indexes
* that you may want open for rushmore optimization!
* one each, depending on whether user entered an
* index file name.

* Add report order index to master index list, if necessary
RptNdxs = mNdx + ',' + _MastNdx

DO CASE
CASE .NOT. EMPTY(mNdx) .AND. mDbf = _MastFile
  SET INDEX TO &RptNdxs
  SET ORDER TO 1
CASE EMPTY(mNdx) .AND. mDbf = _MastFile
  SET INDEX TO &_MastNdx
  SET ORDER TO 1
* put 2 cases here, above last 2
CASE .NOT. EMPTY(mNdx) .AND. mDbf <> _MastFile
  SET INDEX TO &mNdx
  SET ORDER TO 1
CASE EMPTY(mNdx) .AND. mDbf <> _MastFile
  SET INDEX TO
ENDCASE

IF .NOT. EMPTY(mRptFilt) OR NOT _Ok2All
  IF zzCntnue('Do you want to PREVIEW the report?')
    REPORT FORM &mRpt TO PRINT PREVIEW FOR &mRptFilt
  ELSE
    * continue
  ENDIF

  IF zzCntnue('Do you want to PRINT the report?')
    REPORT FORM &mRpt TO PRINT PROMPT NOCONSOLE FOR &mRptFilt
  ELSE
    * continue
  ENDIF

ELSE

  IF zzCntnue('Do you want to PREVIEW the report?')
    REPORT FORM &mRpt TO PRINT PREVIEW
  ELSE
    * continue
  ENDIF

  IF zzCntnue('Do you want to PRINT the report?')
    REPORT FORM &mRpt TO PRINT PROMPT NOCONSOLE
  ELSE
    * continue
  ENDIF

ENDIF

SET INDEX TO &_MastNdx

WAIT 'Report finished ' WINDOW TIMEOUT 2

RETURN

* EOF - RptExe
*******************************************************************
FUNCTION BLdIdx
PARAMETERS TempNdx
* Build index string for report, index selected database if desired
* TempNdx is the index file name
*

IF EMPTY(t_cNdxKey1)
  RETURN ''
ENDIF

NdxStr  = ''
NdxStr1 = ''
NdxStr2 = ''
NdxStr3 = ''

* Get index key for field 1
IF .NOT. EMPTY(t_cNdxKey1)
  mPos = ASCAN(_zzsmast,t_cNdxKey1)
  mSub = ASUBSCRIPT(_zzsmast,mPos,1)

  NdxFld = ALLTRIM(_zzsmast(mSub,2)) && the dbf field name
  UsrType = _zzsmast(mSub,3)          && Field type
  UsrLen  = _zzsmast(mSub,4)          && Field Length
  UsrDec  = _zzsmast(mSub,5)          && Decimals, if numeric

  DO CASE
  CASE UsrType = 'D'
    NdxStr1 = [DTOS(] + ALLTRIM(NdxFld) + [)]
  CASE UsrType = 'N'
    NdxStr1 = [STR(] + ALLTRIM(NdxFld) + [)]
  OTHERWISE
    NdxStr1 = [UPPER(] + ALLTRIM(NdxFld) + [)]
  ENDCASE

  NdxStr = NdxStr1
ENDIF

* Get index key for field 2
IF .NOT. EMPTY(t_cNdxKey2)
  mPos = ASCAN(_zzsmast,t_cNdxKey2)
  mSub = ASUBSCRIPT(_zzsmast,mPos,1)

  NdxFld = ALLTRIM(_zzsmast(mSub,2)) && the dbf field name
  UsrType = _zzsmast(mSub,3)          && Field type
  UsrLen  = _zzsmast(mSub,4)          && Field Length
  UsrDec  = _zzsmast(mSub,5)          && Decimals, if numeric

  DO CASE
  CASE UsrType = 'D'
    NdxStr2 = [DTOS(] + ALLTRIM(NdxFld) + [)]
  CASE UsrType = 'N'
    NdxStr2 = [STR(] + ALLTRIM(NdxFld) + [)]
  OTHERWISE
    NdxStr2 = [UPPER(] + ALLTRIM(NdxFld) + [)]
  ENDCASE

  NdxStr = NdxStr + '+' + NdxStr2
ENDIF

* Get index key for field 3
IF .NOT. EMPTY(t_cNdxKey3)
  mPos = ASCAN(_zzsmast,t_cNdxKey3)
  mSub = ASUBSCRIPT(_zzsmast,mPos,1)

  NdxFld = ALLTRIM(_zzsmast(mSub,2)) && the dbf field name
  UsrType = _zzsmast(mSub,3)          && Field type
  UsrLen  = _zzsmast(mSub,4)          && Field Length
  UsrDec  = _zzsmast(mSub,5)          && Decimals, if numeric

  DO CASE
  CASE UsrType = 'D'
    NdxStr3 = [DTOS(] + ALLTRIM(NdxFld) + [)]
  CASE UsrType = 'N'
    NdxStr3 = [STR(] + ALLTRIM(NdxFld) + [)]
  OTHERWISE
    NdxStr3 = [UPPER(] + ALLTRIM(NdxFld) + [)]
  ENDCASE

  NdxStr = NdxStr + '+' + NdxStr3
ENDIF

IF .NOT. EMPTY(NdxStr)

  IF zzCntnue('Do you want to CREATE new report index?') ;
      OR NOT FILE(ALLTRIM(t_cNdx1)+'.IDX')

    WAIT 'Indexing ' + ALLTRIM(NdxStr) ;
    + ' for ' + ALLTRIM(STR(RECC())) + ' records now...' WINDOW NOWAIT

    DEFINE WINDOW ndx ;
      AT 4,7 ;
      SIZE 6,70 ;
      TITLE  'Report Index' ;
      FONT 'Times New Roman', 10 ;
      STYLE 'B' ;
      FLOAT ;
      CLOSE ;
      NOMINIMIZE ;
      DOUBLE
    MOVE WINDOW ndx CENTER
    ACTIVATE WINDOW ndx

    TempKey = ALLTRIM(NdxStr)
    SET TALK ON
    INDEX ON &TempKey TO &TempNdx COMPACT
    SET TALK OFF
    DEACTIVATE WINDOW ndx

  ELSE
    * continue, no index
  ENDIF { user wants to create index }

ELSE

  WAIT 'Report will be in search order, Press <Enter> now.' WINDOW

ENDIF

RETURN NdxStr

* EOF - BldNdx
********************************************************************
********************************************************************
********************************************************************
* EOF - zzRpts.prg