*       *********************************************************
*       *                                                         
*       * 03/11/95              ZZUDF.PRG                18:19:49 
*       *                                                         
*       *********************************************************
*       *                                                         
*       * Patrick Smith                                           
*       *                                                         
*       * Copyright (c) 1995 Contact Technology                   
*       * 26 Aries Lane                                           
*       * Novato, CA  94947                                       
*       * U.S.A                                             
*       *                                                         
*       * Description:                                            
*       * This program was automatically generated by GENSCRN.    
*       *                                                         
*       *********************************************************

PARAMETERS cevent, ctaskalias

*       *********************************************************
*       *                                                         
*       *          ZZUDF/Windows Setup Code - SECTION 1           
*       *                                                         
*       *********************************************************
*

#REGION 1
*++
* User Defined Fields update task support code
*--

* Make sure this is the ONLY task window open!
IF NOT EMPTY(_aWindows[1])
  IF _aWindows[1] = '1_ZZUDF'
    * OK to go back to this window
  ELSE
    WAIT 'Close all windows before performing this function, press <Enter>' WINDOW
    RETURN
  ENDIF
ENDIF

PRIVATE ALL EXCEPT _*


*       *********************************************************
*       *                                                         
*       *          ZZUDF/Windows Setup Code - SECTION 2           
*       *                                                         
*       *********************************************************
*

#REGION 1
* Define offsets into GET variable array structure.
* The first section of the array must match the table layout
* so we can use GATHER/SCATTER to transfer between file and array.
* Make sure it is an exact match to the dbf structure!
* Adjust the size of the array below to hold the memvars

#DEFINE t_cField_name t_aGETvars[1]
#DEFINE t_cField_type t_aGETvars[2]
#DEFINE t_cField_len  t_aGETvars[3]
#DEFINE t_cField_dec  t_aGETvars[4]
#DEFINE t_cFldLabel   t_aGETvars[5]
#DEFINE t_cField_Pic  t_aGETvars[6]
#DEFINE t_cOk2Del     t_aGETvars[7]
#DEFINE t_cOk2Mod     t_aGETvars[8]
#DEFINE t_cOk2Filt    t_aGETvars[9]
#DEFINE t_cFieldPos   t_aGETvars[10]

* Now define elements for additional non-table fields
#DEFINE t_cOption    t_aGETvars[20]
#DEFINE t_nTopBump   t_aGETvars[21]
#DEFINE t_nBotBump   t_aGETvars[22]
#DEFINE t_cFldList   t_aGETvars[23]

  * And now define the array itself
  DIMENSION t_aGETvars[30]

  * Declare Screen-set wide global variables
  m.t_cWindow = ''   && Window name for this instance
  m.t_nWinRow = 2    && Default row for our window
  m.t_nWinCol = 2    && Default column for our window
  m.t_nCurObj = 0    && Current object number
  m.t_nRecno = 0     && Current record number
  m.t_cOrder= ''     && Default table order.
  m.t_bAddNew = .F.  && Set true if adding new record
  m.t_bChanges = .F. && Changes have been made flag.
  m.t_bAtTop = .F.   && Beginning of file flag
  m.t_bAtEnd = .F.   && End of file flag

  * Determine our task alias, or create a new one.
  IF m.cEvent = 'LAUNCH'
    * Look for topmost existing instance of this task first.
    m.t_cWindow = wTaskWin( m.cTaskAlias )

    IF EMPTY( m.t_cWindow )
      * Create a new instance of this task.
      m.cTaskAlias = wNewTask( m.cTaskAlias )
      IF EMPTY( m.cTaskAlias )
        RETURN .F.
      ENDIF

      m.t_cWindow = wAddWin( m.cTaskAlias, 'ZZUDF', ;
                         'Customer Fields Update' )
    ELSE
      * Get the task alias associated with window we found.
      m.cTaskAlias = wWinAlias( m.t_cWindow )
    ENDIF
  ENDIF

  * Restore last saved state (if any) of memory variables.
  DO wGetState WITH m.cTaskAlias

  * Make sure the files we use are open
  IF NOT USED('zzsmast')
    * Use AGAIN in case another task, or BROWSE, has file open
    * under a different alias name.
    USE (LOCFILE('zzsmast','DBF','Where is zzsmast.dbf?'));
        IN 0 AGAIN ALIAS zzsmast
  ENDIF
  SELECT zzsmast
  *IF .NOT. FILE('zzsmast.idx')
  *  INDEX ON UPPER() TO zzxxx
  *ENDIF
  *SET INDEX TO zzxx
  *SET ORDER TO (m.t_cOrder)

  * Restore current record from saved context.
  IF m.t_nRecno > 0 AND m.t_nRecno <= RECCOUNT()
    GO m.t_nRecno
  ENDIF

  DO CASE
    CASE m.cEvent = 'CLOSE'
      IF NOT save_form('closing the window')
        RETURN .F.
      ENDIF
      HIDE WINDOW (t_cWindow)

    CASE m.cEvent = 'UPDATE'
      * If changes have been made, ignore simple update events.
      * Note that this code depends on SET EXACT OFF.
      IF NOT (t_bChanges AND cEvent == 'UPDATE')
        IF save_form('selecting a new record')
          * Process Special event messages we support.
          IF '>' $ m.cEvent
            DO controls WITH SUBSTR(cEvent,AT('>',cEvent)+1)
          ELSE
            IF '-' $ m.cEvent
              GO VAL(SUBSTR(cEvent,AT('-',cEvent)+1))
            ENDIF
            DO load_form
            DO show_form
          ENDIF
        ENDIF
      ENDIF

    CASE m.cEvent = 'LAUNCH' OR m.cEvent = 'ACTIVATE'
      IF NOT WVISIBLE( m.t_cWindow )
        * Position newly created window(s) at last saved position.
        * SIZE must be manually adjusted, NOT from screen generator
        MODIFY WINDOW ( m.t_cWindow ) ;
                FONT 'MS Sans Serif',8 STYLE 'B';
                ICON FILE cardfile.ico ;
                AT m.t_nWinRow, m.t_nWinCol SIZE 31,96 ;
                COLOR RGB(,,,192,192,192)

        * Initialize the GET variable array.
        STORE '' TO t_aGETvars
        STORE 0 TO t_nTopBump, t_nBotBump, t_nCurObj

        * Load current record into GET variable array.
        DO load_form
      ENDIF

      * Issue GETS if this is first time, or another task cleared them
      ACTIVATE WINDOW (m.t_cWindow) NOSHOW
      IF OBJNUM( t_nTopBump, wRdLevel() ) = 0
        DO issue_gets

        * Object numbers have changed, so clear saved object number
        m.t_nCurObj = 0
      ELSE
        * If window was just re-opened, show the gets.
        IF NOT WVISIBLE(m.t_cWindow)
          SHOW GETS WINDOW (m.t_cWindow) LEVEL wRdLevel()
        ENDIF
      ENDIF

      * Set option buttons correctly
      DO set_buttons WITH m.t_bChanges
      ACTIVATE WINDOW (m.t_cWindow)

      * If no saved object, determine default first object to read.
      IF m.t_nCurObj = 0
        m.t_nCurObj = OBJNUM( t_cFldLabel, wRdLevel() )
      ENDIF

      * Define flag to remember the state of our menu pad. The
      * Activate clause is re-called each time a dialog window
      * is closed. By using this flag we can avoid the overhead of
      * re-redefining our menu in these cases.
      bMenuUp = .F.

      * init memvar for field list in screen
      t_cFldList = space(40)

      * Give ZZProc.prg our READ level validation expressions
      DO wReadInit WITH 'udf_deact()', 'get_valid()', ;
                        'save_form("closing the window")'

      READ CYCLE SAVE OBJECT m.t_nCurObj ;
         ACTIVATE udf_act() ;
         DEACTIVATE udf_deact() ;
         VALID READKEY(1) = 5     && Only terminate if deactivate

      m.t_nCurObj = _nCurObj      && Remember last data object
  ENDCASE

  * Save current context information
  m.t_cOrder = ORDER('zzsmast')    && Remember data table order
  m.t_nRecno = RECNO('zzsmast')    && and record number
  DO wSaveState WITH m.cTaskAlias

  IF NOT WVISIBLE(t_cWindow)
    * Close the tables we use. If other tasks use them, they will
    * reopen them as part of their context restoration.
    SELECT zzSMast
    USE

    * Close associated browse window also, if open.
    IF WEXIST('Customer_Fields_List')
      DEACTIVATE WINDOW 'Customer_Fields_List'
    ENDIF

    DO wDelTask WITH m.cTaskAlias
  ENDIF
  RETURN .T.

*******************************************************************
PROCEDURE issue_gets
*++
* The code for this procedure will be generated by GENSCRN.  It
* will issue all the @GETs for the screen.  We want the GET
* commands to be in a seperate procedure so we can call them
* conditionally from the task program setup code.
*--

* ! Important !
* Make sure the When statement for the "get" field "TopBump"
* contains the name of the last "get" field and
* "BotBump" contains the name of the first "get" field
* this will insure that the cursor cycles properly!!!!!
*

*       *********************************************************
*       *                                                         
*       *               ZZUDF/Windows Screen Layout               
*       *                                                         
*       *********************************************************
*

#REGION 1
@ 13.462,6.167 SAY "Field Type:" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 14.846,4.500 SAY "Field Length:" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 9.308,5.333 SAY "Description:" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 10.462,5.500 SAY "Field Name:" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 9.231,44.333 SAY "( The data entry screen field name. )" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 10.462,44.333 SAY "( The 10 character database field name. )" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 0.000,0.667 GET t_nTopBump ;
	PICTURE "@*IVN " ;
	SIZE 1.000,1.167,1.000 ;
	DEFAULT 0 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wBumper(OBJNUM(t_cFldLabel) + 5)
@ 9.385,20.833 GET t_cFldLabel ;
	SIZE 1.000,20.333 ;
	DEFAULT " " ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	PICTURE "@K" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 10.462,20.833 GET t_cField_Name ;
	SIZE 1.000,16.333 ;
	DEFAULT " " ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	PICTURE "@K !!!!!!!!!!" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 13.231,20.500 GET t_cField_Type ;
	PICTURE "@^ C - Character;N - Numeric;D - Date;L - Logical;G - General;M - Memo" ;
	SIZE 1.538,16.167 ;
	DEFAULT "C - Character" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 15.077,21.000 GET t_cField_Len ;
	SPINNER 1.000, 1, 30 ;
	PICTURE "@K ##" ;
	SIZE 0.846, 9.000 ;
	DEFAULT 1.000 ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() ) ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 0.000,1.333 GET t_nBotBump ;
	PICTURE "@*IVN " ;
	SIZE 1.077,1.000,1.000 ;
	DEFAULT 0 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wBumper( OBJNUM(t_cFldLabel) )
@ 5.077,4.000 SAY 'This window contains one record for each field in your customer database.' + CHR(13) + ;
		'Add a record here to add a new data entry field to your customer database.' + CHR(13) + ;
		'Select "Create" to copy your customers into the new customer database.' ;
	SIZE 3.000,72.000, 0.000 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT"
@ 16.308,7.500 SAY "Decimals:" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 16.462,21.000 GET t_cFIeld_Dec ;
	SPINNER 1.000, 1, 30 ;
	PICTURE "@K ##" ;
	SIZE 0.846, 9.000 ;
	DEFAULT 1.000 ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() ) ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 19.692,4.500 SAY "Field" + CHR(13) + ;
		"Data Entry" + CHR(13) + ;
		"Format:" ;
	SIZE 3.000,10.833, 0.000 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 20.538,21.333 GET t_cField_pic ;
	SIZE 1.000,64.333 ;
	DEFAULT " " ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	PICTURE "@K" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 24.769,7.667 SAY "Picture Examples:  !XXXXXXXXX - Uppercase first letter" + CHR(13) + ;
		"(more in help)        @D               - Date Field" + CHR(13) + ;
		"                           9999999        - Only allow numbers" ;
	SIZE 3.000,52.833, 0.000 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT"
@ 12.769,45.667 SAY 'Important! Have ALL other SalesBridge users' + CHR(13) + ;
		'  quit SalesBridge BEFORE doing "Create".' ;
	SIZE 2.000,42.667, 0.000 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT"
@ 1.000,3.333 GET t_cOption ;
	PICTURE "@*BHN " + ;
		(LOCFILE("prev.bmp","BMP|ICO|PCT|ICN","Where is prev?")) + ";" + ;
		(LOCFILE("next.bmp","BMP|ICO|PCT|ICN","Where is next?")) + ";" + ;
		(LOCFILE("list.bmp","BMP|ICO|PCT|ICN","Where is list?")) + ";" + ;
		(LOCFILE("add.bmp","BMP|ICO|PCT|ICN","Where is add?")) + ";" + ;
		(LOCFILE("create.bmp","BMP|ICO|PCT|ICN","Where is create?")) + ";" + ;
		(LOCFILE("undo.bmp","BMP|ICO|PCT|ICN","Where is undo?")) + ";" + ;
		(LOCFILE("save.bmp","BMP|ICO|PCT|ICN","Where is save?")) + ";" + ;
		(LOCFILE("exit.bmp","BMP|ICO|PCT|ICN","Where is exit?")) ;
	SIZE 2.923,8.667,0.667 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	VALID ProcOption(t_cOption,.T.)
@ 16.385,39.167 SAY "( # of digits to right of decimal point, numeric only. )" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 4.692,2.000 TO 4.692,79.000 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 4.692,2.000 TO 8.538,2.000 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 4.769,78.667 TO 8.461,78.667 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 8.385,2.167 TO 8.385,79.000 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 4.077,2.333 TO 4.077,78.833 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 0.692,2.333 TO 0.692,78.666 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 0.692,2.000 TO 4.154,2.000 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 0.692,78.667 TO 4.077,78.667 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 8.923,2.000 TO 8.923,17.167 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 8.923,2.000 TO 11.923,2.000 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 9.000,17.000 TO 11.923,17.000 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 11.769,2.167 TO 11.769,17.167 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 8.923,19.500 TO 8.923,43.333 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 8.923,19.167 TO 11.923,19.167 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 11.846,19.500 TO 11.846,43.333 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 9.077,43.167 TO 11.923,43.167 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 12.385,44.500 TO 12.385,90.000 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 12.385,44.500 TO 15.385,44.500 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 12.462,90.000 TO 15.385,90.000 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 15.231,44.667 TO 15.231,90.167 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 12.923,2.000 TO 12.923,17.167 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 13.000,2.000 TO 17.846,2.000 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 13.000,17.000 TO 17.846,17.000 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 17.692,2.167 TO 17.692,17.000 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 12.923,19.500 TO 12.923,37.667 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 12.923,19.167 TO 17.846,19.167 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 17.769,19.333 TO 17.769,37.666 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 12.923,37.500 TO 17.846,37.500 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 18.769,2.000 TO 18.769,17.167 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 18.846,2.000 TO 23.692,2.000 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 18.846,17.000 TO 23.692,17.000 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 23.538,2.167 TO 23.538,17.000 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 19.923,20.333 TO 19.923,87.166 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 19.923,20.000 TO 22.231,20.000 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 22.077,20.333 TO 22.077,87.166 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 20.077,87.000 TO 22.154,87.000 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 24.231,2.000 TO 24.231,79.000 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 24.231,2.000 TO 28.077,2.000 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 24.308,78.667 TO 28.000,78.667 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 27.923,2.167 TO 27.923,79.000 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)


*       *********************************************************
*       *                                                         
*       *               ZZUDF/Windows Cleanup Code                
*       *                                                         
*       *********************************************************
*

#REGION 1
********************************************************************


*       *********************************************************
*       *                                                         
*       *   ZZUDF/Windows Supporting Procedures and Functions     
*       *                                                         
*       *********************************************************
*

#REGION 1
FUNCTION udf_act
*++
* Task specific READ activation handler.
*--

  * Put up custom menu pad for this task window. The activate clause
  * may sometimes be called after the window is hidden during a close
  * operation, if a dialog box was activated by the form level
  * validation handler. The WVISIBLE() test makes sure we don't put
  * the menu back up in this case. The bMenuUp flag is used only for
  * optimization purposes - so we don't redefine the menu if it's
  * already there.
  IF WVISIBLE(m.t_cWindow) AND NOT bMenuUp
    DO zzudf.mpr
    bMenuUp = .T.
  ENDIF

  RETURN .T.


********************************************************************
FUNCTION udf_deact
*++
* Task specific READ deactivation handler.
* This routine may be called by the READ command on a READ window
* deactivation, or explicitly by the wClearRead() function. That
* means we cannot depend on WLAST() or WONTOP() to be set right.
*--
  * Under FoxPro for Windows, Minimizing a window from the window
  * control box, or Choosing Next Window, bypasses the GET Valid
  * clause. This is our only chance to catch it, and thereby enforce
  * proper field validation.
  IF wCatchAll(m.t_cWindow)
    * Save last position of window
    m.t_nWinRow = WLROW(m.t_cWindow)
    m.t_nWinCol = WLCOL(m.t_cWindow)

    RELEASE PAD fields OF _MSYSMENU
    RELEASE POPUP fields
    bMenuUp = .F.
    RETURN .T.
  ELSE
    RETURN .F.
  ENDIF


********************************************************************
FUNCTION GET_valid
*++
* Common validation routine called when any field data is changed.
*
* This routine is responsible for:
*  1. Checking lock status of record, locking if needed.
*  2. Setting changes flag and setting buttons.
*
* Returns TRUE.
*  If data was changed and lock could not be established, data is
*  reset to initial value.
*--
PRIVATE xTemp

  IF NOT m.t_bchanges AND wChanged()
    IF NOT wLock(m.cTaskAlias, 'zzsmast', RECNO('zzsmast') )
      * Restore original field contents on Lock failure.
      DO wFldUndo

      * Return success, since user is warned, and changes undone.
      RETURN .T.
    ENDIF

    * Make sure any changes to record made since original
    * display are shown on screen when the record is locked.
    STORE EVALUATE( VARREAD() ) TO m.xTemp
    DO load_form
    STORE m.xTemp TO ( VARREAD() )
    DO show_form

    DO set_buttons WITH .T.
  ENDIF

  RETURN .T.


********************************************************************
PROCEDURE load_form
*++
* Load data from current record for display and/or edit.
*---
  SELECT zzsmast

  * Don't stay at EOF if we can help it.
  IF EOF()
    GOTO BOTTOM

    * If still at EOF, perform implicit add record command.
    IF EOF()
      RETURN init_form()
    ENDIF
  ENDIF

  m.t_bAddNew = .F.
  DO set_buttons WITH .F.

  * Let all the other tasks know what record we have displayed.
  DO wListen WITH m.cTaskAlias, 'zzsmast', RECNO('zzsmast')

  * Load data from field variables into GET variable array.
  SCATTER TO t_aGETvars MEMO
  RETURN


********************************************************************
PROCEDURE init_form
*++
* Initialize internal memory for a new address record.
* Let format default to current setting on add.
*---
  m.t_bAddNew = .T.
  DO set_buttons WITH .T.

  SELECT zzsmast
  SCATTER TO t_aGETvars MEMO BLANK

  * Move to first field to begin entry of new record.
  _CUROBJ = OBJNUM( t_cFldLabel )
  RETURN


********************************************************************
PROCEDURE show_form
*++
* Display current data and Enable/Disable fields as appropriate.
*---

  SHOW GETS WINDOW (m.t_cWindow) LEVEL wRdLevel()
  RETURN


********************************************************************
FUNCTION set_buttons
PARAMETER bChanges
*++
* Set changes flag, and update control buttons accordingly.
*--
PRIVATE nRecno

  IF m.bChanges
    SHOW GET t_cOption,6 ENABLE LEVEL wRdLevel()
    SHOW GET t_cOption,7 ENABLE LEVEL wRdLevel()
  ELSE
    SHOW GET t_cOption,6 DISABLE LEVEL wRdLevel()
    SHOW GET t_cOption,7 DISABLE LEVEL wRdLevel()
  ENDIF

  * The AddNEw flag will always be set if there are no records.
  IF t_bAddNew
    t_bAtTop = .T.
    t_bAtEnd = .T.
  ELSE
    nRecno = RECNO()
    SKIP -1
    t_bAtTop = BOF()
    GO nRecno

    SKIP 1
    t_bAtEnd = EOF()
    GO nRecno
  ENDIF

  * Set buttons according to current record
  IF m.t_bAtTop
    SHOW GET t_cOption,1 DISABLE LEVEL wRdLevel()
  ELSE
    SHOW GET t_cOption,1 ENABLE LEVEL wRdLevel()
  ENDIF

  IF m.t_bAtEnd
    SHOW GET t_cOption,2 DISABLE LEVEL wRdLevel()
  ELSE
    SHOW GET t_cOption,2 ENABLE LEVEL wRdLevel()
  ENDIF

  * Store new value of task level change flag and return it.
  m.t_bChanges = m.bChanges
  RETURN m.bChanges


********************************************************************
FUNCTION ProcOption
PARAMETER cOption, bInObject
*++
* Process menu and pushbutton options.
*--

* if choice is picture button, strip off ".BMP" from end
* make sure .bmp button file names match menu options!
m.cOption = STRTRAN(m.cOption,'.BMP','')
* identify file name, strip off path + back-slashes
m.cOption = SUBSTR(m.cOption,RAT('\',m.cOption)+1)

SELECT zzsmast
m.cOption = UPPER( ALLTRIM(m.cOption) )

  DO CASE
    * First, handle the common task button options.
    CASE controls(cOption, bInObject)

    * Then, check for task-specific button options.

    CASE m.cOption = 'CREATE'
      DO CreateDB

    CASE m.cOption = 'LIST'
      * Launch an independant BROWSE window, linked to ours.
      DO wLaunch WITH 'udflist IN zzudf'

  ENDCASE

  IF m.cOption = 'EXIT'
    * Start SalesBridge zz.prg from top of file
    _ReStart = .T.
  ENDIF

  RETURN .T.


********************************************************************
PROCEDURE udflist
PARAMETER cEvent, cTaskAlias
*++
* This BROWSE task is designed to work together with the
* search index update task window.
*
* Parameters from wLaunch are ignored for BROWSE tasks, since
* once they are started, we never get control of them again.
*--
  SELECT zzsmast

  * Define a window for Browse to pattern itself after. Specify font
  * so size will be consistent even if Main Window font changes.
  DEFINE WINDOW bwin AT 1,1 SIZE 11,75 ;
                        FONT 'MS Sans Serif',8 STYLE 'B' ;
                        FLOAT SHADOW CLOSE MINIMIZE ZOOM ;
                        SYSTEM GROW COLOR SCHEME 8
  MOVE WINDOW bwin CENTER

  * Activate the BROWSE window. The WHEN clause calls zzudf.prg
  * with the event string 'UPDATE-n' where n is the new
  * record number to display in the window.
  BROWSE NOWAIT REST NOMENU NOMODIFY NODELETE ;
         WINDOW bwin TITLE 'Customer_Fields_List' ;
         FIELDS fldlabel:H='Description', ;
           field_name:H='Field', ;
           field_type:H='Type', ;
           field_len:H='Length', ;
           field_dec:H='decimals' ;
         WHEN EVALUATE( 'zzudf' ;
                + '("UPDATE-' + ALLTRIM(STR(RECNO())) ;
                + '", "1_ZZUDF")' )

  RELEASE WINDOW bwin
  RETURN


********************************************************************
FUNCTION save_form
PARAMETER cMsgTxt
*++
* Validate complete form as a whole, and save changes. If cMsgTxt
* contains a string, use it to ask whether or not user wants to
* save changes.
*--
PRIVATE nBadField, cReason, cAnswer

  SELECT zzsmast
  STORE '' TO m.cReason

  IF m.t_bChanges
    m.cAnswer = IIF(EMPTY(m.cMsgTxt), 'YES', zzQuest(m.t_cWindow, ;
        'Do you want to save changes made to this index ' ;
        + 'before ' + m.cMsgTxt + '?' ) )

    * Return failure immediately if user cancels.
    IF m.cAnswer = 'CANCEL'
      RETURN .F.
    ENDIF

    * Save the changes if we are supposed to.
    IF m.cAnswer = 'YES'

      * Check for dupe field names!
      Sv_Rec = RECNO()
      locate for zzSMast.Field_name = t_cField_Name ;
             AND RECNO() <> Sv_Rec
      IF Found()
        WAIT 'Field Name already exists, Change and save again.' WINDOW TIMEOUT 5
        RETURN .F.
      ENDIF
      GOTO Sv_Rec

      * Make sure all required fields have been entered.
      DO CASE
        CASE EMPTY(t_cFldLabel)
          m.cReason = 'A Description is required'
          m.nBadField = OBJNUM(t_cFldLabel)

        CASE EMPTY(t_cField_Name)
          m.cReason = 'A database field name is required'
          m.nBadField = OBJNUM(t_cField_Name)

        CASE EMPTY(t_cField_Type)
          m.cReason = 'A field type is required'
          m.nBadField = OBJNUM(t_cField_Type)

        CASE EMPTY(t_cField_Len)
          m.cReason = 'A Field Length is required'
          m.nBadField = OBJNUM(t_cField_Len)

      ENDCASE

      IF NOT EMPTY(m.cReason)
        DO zzWarn WITH m.t_cWindow, m.cReason

        * This routine may be called when no GETs are issued (like
        * during Global shutdown). OBJNUM() returns 0 in this case.
        _CUROBJ = nBadField
        RETURN .F.
      ENDIF

      * Add a new record to the database when needed.
      IF m.t_bAddNew
        * Create new record
        APPEND BLANK
        m.t_bAddNew = .F.
      ENDIF

      GATHER FROM t_aGETvars MEMO
      DO set_buttons WITH .F.
    ELSE
      * User said 'dont save', so reload from disk.
      DO load_form
      DO show_form
    ENDIF

    * Whether changes saved or discarded, release the locks.
    DO wUnlock WITH m.cTaskAlias

  ENDIF

  RETURN .T.


* EOF - save_form

********************************************************************
FUNCTION CreateDB
* Create new master dbf from zzSMast.dbf structure file
*

DEFINE WINDOW CreateDB ;
  AT 4,7 ;
  SIZE 6,70 ;
  TITLE  'Create New Customer Fields' ;
  FONT 'Times New Roman', 10 ;
  STYLE 'B' ;
  FLOAT ;
  CLOSE ;
  NOMINIMIZE ;
  DOUBLE
MOVE WINDOW CreateDB CENTER
ACTIVATE WINDOW CreateDB

IF NOT zzCntnue('Do you want to CREATE fields now?')
  DEACTIVATE WINDOW CreateDB
ELSE
  WAIT 'Creating ' + ALLTRIM(STR(RECC())) + ' fields now...' WINDOW TIMEOUT 2
  SELECT zzSMast
  PACK
  CLOSE DATABASES
  SET TALK ON
  CREATE zzTemp FROM zzSMast

  USE (LOCFILE(_MastFile,'DBF','Where is the customer master file?'));
     IN 0 EXCLUSIVE ALIAS &_MastFile
  SELECT &_MastFile

  IF NOT USED(_MastFile)

     WAIT 'You must have exclusive use of the customer file first!' WINDOW TIMEOUT 3
     IF NOT USED('zzsmast')
       * Use AGAIN in case another task, or BROWSE, has file open
       * under a different alias name.
       USE (LOCFILE('zzsmast','DBF','Where is zzsmast.dbf?'));
           IN 0 AGAIN ALIAS zzsmast
     ENDIF
     SELECT zzsmast
     * re-init field pos in master.dbf stru. file for field list arrays!
     REPLACE ALL Field_Pos with ALLTRIM(STR(RECNO()))

     DEACTIVATE WINDOW CreateDB
     RETURN

  ENDIF

  IF NOT USED('zzTemp')
    * Use AGAIN in case another task, or BROWSE, has file open
    * under a different alias name.
    USE (LOCFILE('zzTemp','DBF','Where is zzTemp.dbf?'));
        IN 0 AGAIN ALIAS zzTemp
  ENDIF
  WAIT 'Copying ' + ALLTRIM(STR(RECC())) + ' customers now...' WINDOW TIMEOUT 2
  SELECT zzTemp
  APPEND FROM &_MastFile
  USE
  SELECT &_MastFile
  USE

  SET TALK OFF

  IF FILE('zzmastol.dbf')
    ERASE zzmastol.dbf
  ENDIF
  IF FILE('zzmastol.fpt')
    ERASE zzmastol.fpt
  ENDIF
  MastName = _MastFile + '.dbf'
  MastFpt  = _MastFile + '.fpt'
  RENAME &MastName TO zzMastol.dbf
  RENAME &MastFpt  TO zzMastol.fpt

  RENAME zzTemp.dbf TO &MastName
  RENAME zzTemp.fpt TO &MastFpt

ENDIF

DO mastinit IN zzinit WITH .t.,.f.

IF NOT USED('zzsmast')
  * Use AGAIN in case another task, or BROWSE, has file open
  * under a different alias name.
  USE (LOCFILE('zzsmast','DBF','Where is zzsmast.dbf?'));
      IN 0 AGAIN ALIAS zzsmast
ENDIF
SELECT zzsmast
* re-init field pos in zzsmast.dbf for field list arrays!
REPLACE ALL Field_Pos with ALLTRIM(STR(RECNO()))

DEACTIVATE WINDOW CreateDB

RETURN

* EOF - CreateDB
********************************************************************
********************************************************************
********************************************************************
* EOF - zzudf.prg